#!/bin/bash -ex

export ROOTDIR=${PWD}
if [ "$SAGE_HOME" == "" ]; then
echo "ERROR: Cross compiler not found."
echo "Please install the Sage EDK."
echo "http://www.se-eng.com/products/sage-edk/"
exit 1
fi


mkdir -p build/cpu/amd/agesa/family14
mkdir -p build/cpu/amd/mtrr
mkdir -p build/cpu/x86/cache
mkdir -p build/cpu/x86/mtrr
mkdir -p build/drivers/spi
mkdir -p build/northbridge/amd/common
mkdir -p build/superio/acpi
mkdir -p build/superio/common
mkdir -p build/superio/nuvoton/nct5104d
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/liblzma
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/crypto
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86
mkdir -p $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpci
mkdir -p util
mkdir -p $ROOTDIR/payloads/ipxe/src/bin
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Recovery/HT
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Tech
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Ps
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Ps/ON
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/NB
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Main
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Main/ON
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/TABLE
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/S3
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/PARTRN
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ODTHERMAL
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/MEMCLR
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/LVDDR3
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/INTLVRN
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/IDENDIMM
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/EXCLUDIMM
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ECC
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/DMI
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/CSINTLV
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/CHINTLV
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Ardk
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ON
mkdir -p build/vendorcode/amd/agesa/f14/Proc/HT
mkdir -p build/vendorcode/amd/agesa/f14/Proc/HT/Fam14
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Nb
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieTrainingV1
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieAlibV1
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbNbInitLibV1
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxConfig
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family/0x14
mkdir -p build/vendorcode/amd/agesa/f14/Proc/GNB/Common
mkdir -p build/vendorcode/amd/agesa/f14/Proc/Common
mkdir -p build/vendorcode/amd/agesa/f14/Proc/CPU
mkdir -p build/vendorcode/amd/agesa/f14/Proc/CPU/Feature
mkdir -p build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON
mkdir -p build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14
mkdir -p build/vendorcode/amd/agesa/f14/Lib
mkdir -p build/vendorcode/amd/agesa/f14/Legacy/Proc
mkdir -p build/cbfs/fallback
mkdir -p build/vendorcode/amd/cimx/sb800
mkdir -p build/southbridge/amd/cimx/sb800
mkdir -p build/southbridge/amd/cimx
mkdir -p build/northbridge/amd/agesa/family14
mkdir -p build/northbridge/amd/agesa/common
mkdir -p build/lib/loaders
mkdir -p build/lib
mkdir -p build/drivers/uart
mkdir -p build/drivers/pc80
mkdir -p build/device/dram
mkdir -p build/device
mkdir -p build/cpu/x86/lapic
mkdir -p build/cpu/x86
mkdir -p build/cpu/amd/agesa
mkdir -p build/console
mkdir -p build/arch/x86/lib
mkdir -p build/arch/x86/boot
mkdir -p build/mainboard/pcengines/apu
mkdir -p build/generated
mkdir -p build/cbfs/fallback build/generated
cp build/util/cbfstool/cbfstool build/cbfstool
pushd payloads/seabios
mkdir -p out//include/config
mkdir -p out/src out/src/hw out/src/fw out/vgasrc
mkdir -p out//include/config
mkdir -p out/src out/src/hw out/src/fw out/vgasrc
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/misc.c -o out/src/misc.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/stacks.c -o out/src/stacks.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/output.c -o out/src/output.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/string.c -o out/src/string.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/x86.c -o out/src/x86.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/block.c -o out/src/block.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/cdrom.c -o out/src/cdrom.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/mouse.c -o out/src/mouse.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/kbd.c -o out/src/kbd.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/serial.c -o out/src/serial.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/clock.c -o out/src/clock.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/resume.c -o out/src/resume.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/pnpbios.c -o out/src/pnpbios.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/vgahooks.c -o out/src/vgahooks.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/pcibios.c -o out/src/pcibios.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/apm.c -o out/src/apm.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/smp.c -o out/src/fw/smp.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/pci.c -o out/src/hw/pci.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/timer.c -o out/src/hw/timer.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/rtc.c -o out/src/hw/rtc.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/dma.c -o out/src/hw/dma.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/pic.c -o out/src/hw/pic.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/ps2port.c -o out/src/hw/ps2port.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/serialio.c -o out/src/hw/serialio.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb.c -o out/src/hw/usb.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb-uhci.c -o out/src/hw/usb-uhci.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb-ohci.c -o out/src/hw/usb-ohci.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb-ehci.c -o out/src/hw/usb-ehci.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb-hid.c -o out/src/hw/usb-hid.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb-msc.c -o out/src/hw/usb-msc.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb-uas.c -o out/src/hw/usb-uas.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/blockcmd.c -o out/src/hw/blockcmd.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/floppy.c -o out/src/hw/floppy.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/ata.c -o out/src/hw/ata.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/ramdisk.c -o out/src/hw/ramdisk.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/virtio-ring.c -o out/src/hw/virtio-ring.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/virtio-pci.c -o out/src/hw/virtio-pci.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/virtio-blk.c -o out/src/hw/virtio-blk.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/virtio-scsi.c -o out/src/hw/virtio-scsi.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/lsi-scsi.c -o out/src/hw/lsi-scsi.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/esp-scsi.c -o out/src/hw/esp-scsi.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/megasas.c -o out/src/hw/megasas.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/sdhc_generic.c -o out/src/hw/sdhc_generic.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/sd.c -o out/src/hw/sd.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/sd_if.c -o out/src/hw/sd_if.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/sd_utils.c -o out/src/hw/sd_utils.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/post.c -o out/src/post.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/memmap.c -o out/src/memmap.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/malloc.c -o out/src/malloc.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/pmm.c -o out/src/pmm.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/romfile.c -o out/src/romfile.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/optionroms.c -o out/src/optionroms.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/boot.c -o out/src/boot.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/bootsplash.c -o out/src/bootsplash.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/jpeg.c -o out/src/jpeg.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/bmp.c -o out/src/bmp.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/ahci.c -o out/src/hw/ahci.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/pvscsi.c -o out/src/hw/pvscsi.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb-xhci.c -o out/src/hw/usb-xhci.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/hw/usb-hub.c -o out/src/hw/usb-hub.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/coreboot.c -o out/src/fw/coreboot.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/lzmadecode.c -o out/src/fw/lzmadecode.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/csm.c -o out/src/fw/csm.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/biostables.c -o out/src/fw/biostables.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/paravirt.c -o out/src/fw/paravirt.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/shadow.c -o out/src/fw/shadow.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/pciinit.c -o out/src/fw/pciinit.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/smm.c -o out/src/fw/smm.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/mtrr.c -o out/src/fw/mtrr.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/xen.c -o out/src/fw/xen.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-cpp -P -MD -MT out/src/fw/acpi-dsdt.hex src/fw/acpi-dsdt.dsl -o out/src/fw/acpi-dsdt.dsl.i.orig
python ./scripts/acpi_extract_preprocess.py out/src/fw/acpi-dsdt.dsl.i.orig > out/src/fw/acpi-dsdt.dsl.i
"$SAGE_HOME"/tools/xgcc/bin/iasl -Pn -vs -l -tc -p out/src/fw/acpi-dsdt out/src/fw/acpi-dsdt.dsl.i
python ./scripts/acpi_extract.py out/src/fw/acpi-dsdt.lst > out/src/fw/acpi-dsdt.off
cat out/src/fw/acpi-dsdt.off > out/src/fw/acpi-dsdt.hex
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-cpp -P -MD -MT out/src/fw/ssdt-proc.hex src/fw/ssdt-proc.dsl -o out/src/fw/ssdt-proc.dsl.i.orig
python ./scripts/acpi_extract_preprocess.py out/src/fw/ssdt-proc.dsl.i.orig > out/src/fw/ssdt-proc.dsl.i
"$SAGE_HOME"/tools/xgcc/bin/iasl -Pn -vs -l -tc -p out/src/fw/ssdt-proc out/src/fw/ssdt-proc.dsl.i
python ./scripts/acpi_extract.py out/src/fw/ssdt-proc.lst > out/src/fw/ssdt-proc.off
cat out/src/fw/ssdt-proc.off > out/src/fw/ssdt-proc.hex
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-cpp -P -MD -MT out/src/fw/ssdt-pcihp.hex src/fw/ssdt-pcihp.dsl -o out/src/fw/ssdt-pcihp.dsl.i.orig
python ./scripts/acpi_extract_preprocess.py out/src/fw/ssdt-pcihp.dsl.i.orig > out/src/fw/ssdt-pcihp.dsl.i
"$SAGE_HOME"/tools/xgcc/bin/iasl -Pn -vs -l -tc -p out/src/fw/ssdt-pcihp out/src/fw/ssdt-pcihp.dsl.i
python ./scripts/acpi_extract.py out/src/fw/ssdt-pcihp.lst > out/src/fw/ssdt-pcihp.off
cat out/src/fw/ssdt-pcihp.off > out/src/fw/ssdt-pcihp.hex
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-cpp -P -MD -MT out/src/fw/ssdt-misc.hex src/fw/ssdt-misc.dsl -o out/src/fw/ssdt-misc.dsl.i.orig
python ./scripts/acpi_extract_preprocess.py out/src/fw/ssdt-misc.dsl.i.orig > out/src/fw/ssdt-misc.dsl.i
"$SAGE_HOME"/tools/xgcc/bin/iasl -Pn -vs -l -tc -p out/src/fw/ssdt-misc out/src/fw/ssdt-misc.dsl.i
python ./scripts/acpi_extract.py out/src/fw/ssdt-misc.lst > out/src/fw/ssdt-misc.off
cat out/src/fw/ssdt-misc.off > out/src/fw/ssdt-misc.hex
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-cpp -P -MD -MT out/src/fw/q35-acpi-dsdt.hex src/fw/q35-acpi-dsdt.dsl -o out/src/fw/q35-acpi-dsdt.dsl.i.orig
python ./scripts/acpi_extract_preprocess.py out/src/fw/q35-acpi-dsdt.dsl.i.orig > out/src/fw/q35-acpi-dsdt.dsl.i
"$SAGE_HOME"/tools/xgcc/bin/iasl -Pn -vs -l -tc -p out/src/fw/q35-acpi-dsdt out/src/fw/q35-acpi-dsdt.dsl.i
python ./scripts/acpi_extract.py out/src/fw/q35-acpi-dsdt.lst > out/src/fw/q35-acpi-dsdt.off
cat out/src/fw/q35-acpi-dsdt.off > out/src/fw/q35-acpi-dsdt.hex
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/acpi.c -o out/src/fw/acpi.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/mptable.c -o out/src/fw/mptable.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/pirtable.c -o out/src/fw/pirtable.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/smbios.c -o out/src/fw/smbios.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/fw/romfile_loader.c -o out/src/fw/romfile_loader.o
printf '#include "misc.c"\n #include "stacks.c"\n #include "output.c"\n #include "string.c"\n #include "x86.c"\n #include "block.c"\n #include "cdrom.c"\n #include "mouse.c"\n #include "kbd.c"\n #include "serial.c"\n #include "clock.c"\n #include "resume.c"\n #include "pnpbios.c"\n #include "vgahooks.c"\n #include "pcibios.c"\n #include "apm.c"\n #include "fw/smp.c"\n #include "hw/pci.c"\n #include "hw/timer.c"\n #include "hw/rtc.c"\n #include "hw/dma.c"\n #include "hw/pic.c"\n #include "hw/ps2port.c"\n #include "hw/serialio.c"\n #include "hw/usb.c"\n #include "hw/usb-uhci.c"\n #include "hw/usb-ohci.c"\n #include "hw/usb-ehci.c"\n #include "hw/usb-hid.c"\n #include "hw/usb-msc.c"\n #include "hw/usb-uas.c"\n #include "hw/blockcmd.c"\n #include "hw/floppy.c"\n #include "hw/ata.c"\n #include "hw/ramdisk.c"\n #include "hw/virtio-ring.c"\n #include "hw/virtio-pci.c"\n #include "hw/virtio-blk.c"\n #include "hw/virtio-scsi.c"\n #include "hw/lsi-scsi.c"\n #include "hw/esp-scsi.c"\n #include "hw/megasas.c"\n #include "hw/sdhc_generic.c"\n #include "hw/sd.c"\n #include "hw/sd_if.c"\n #include "hw/sd_utils.c"\n #include "post.c"\n #include "memmap.c"\n #include "malloc.c"\n #include "pmm.c"\n #include "romfile.c"\n #include "optionroms.c"\n #include "boot.c"\n #include "bootsplash.c"\n #include "jpeg.c"\n #include "bmp.c"\n #include "hw/ahci.c"\n #include "hw/pvscsi.c"\n #include "hw/usb-xhci.c"\n #include "hw/usb-hub.c"\n #include "fw/coreboot.c"\n #include "fw/lzmadecode.c"\n #include "fw/csm.c"\n #include "fw/biostables.c"\n #include "fw/paravirt.c"\n #include "fw/shadow.c"\n #include "fw/pciinit.c"\n #include "fw/smm.c"\n #include "fw/mtrr.c"\n #include "fw/xen.c"\n #include "fw/acpi.c"\n #include "fw/mptable.c"\n #include "fw/pirtable.c"\n #include "fw/smbios.c"\n #include "fw/romfile_loader.c"\n' > out/ccode32flat.o.tmp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable   -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -fwhole-program -DWHOLE_PROGRAM -c out/ccode32flat.o.tmp.c -o out/ccode32flat.o
printf '#include "string.c"\n #include "output.c"\n #include "pcibios.c"\n #include "apm.c"\n #include "stacks.c"\n #include "hw/pci.c"\n #include "hw/serialio.c"\n' > out/code32seg.o.tmp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable   -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODESEGMENT=1 -fno-defer-pop -fno-jump-tables -fno-tree-switch-conversion -DMODE16=0 -fomit-frame-pointer -fwhole-program -DWHOLE_PROGRAM -c out/code32seg.o.tmp.c -o out/code32seg.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/system.c -o out/src/system.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/disk.c -o out/src/disk.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c src/font.c -o out/src/font.o
printf '#include "misc.c"\n #include "stacks.c"\n #include "output.c"\n #include "string.c"\n #include "x86.c"\n #include "block.c"\n #include "cdrom.c"\n #include "mouse.c"\n #include "kbd.c"\n #include "serial.c"\n #include "clock.c"\n #include "resume.c"\n #include "pnpbios.c"\n #include "vgahooks.c"\n #include "pcibios.c"\n #include "apm.c"\n #include "fw/smp.c"\n #include "hw/pci.c"\n #include "hw/timer.c"\n #include "hw/rtc.c"\n #include "hw/dma.c"\n #include "hw/pic.c"\n #include "hw/ps2port.c"\n #include "hw/serialio.c"\n #include "hw/usb.c"\n #include "hw/usb-uhci.c"\n #include "hw/usb-ohci.c"\n #include "hw/usb-ehci.c"\n #include "hw/usb-hid.c"\n #include "hw/usb-msc.c"\n #include "hw/usb-uas.c"\n #include "hw/blockcmd.c"\n #include "hw/floppy.c"\n #include "hw/ata.c"\n #include "hw/ramdisk.c"\n #include "hw/virtio-ring.c"\n #include "hw/virtio-pci.c"\n #include "hw/virtio-blk.c"\n #include "hw/virtio-scsi.c"\n #include "hw/lsi-scsi.c"\n #include "hw/esp-scsi.c"\n #include "hw/megasas.c"\n #include "hw/sdhc_generic.c"\n #include "hw/sd.c"\n #include "hw/sd_if.c"\n #include "hw/sd_utils.c"\n #include "system.c"\n #include "disk.c"\n #include "font.c"\n' > out/ccode16.o.tmp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable   -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODESEGMENT=1 -fno-defer-pop -fno-jump-tables -fno-tree-switch-conversion -MMD -DMODE16=1 -Wa,src/code16gcc.s --param large-stack-frame=4 -fomit-frame-pointer -fwhole-program -DWHOLE_PROGRAM -c out/ccode16.o.tmp.c -o out/ccode16.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODESEGMENT=1 -fno-defer-pop -fno-jump-tables -fno-tree-switch-conversion -MMD -DMODE16=1 -Wa,src/code16gcc.s --param large-stack-frame=4 -fomit-frame-pointer -S -c src/asm-offsets.c -o out/src/asm-offsets.s
./scripts/gen-offsets.sh out/src/asm-offsets.s out/asm-offsets.h
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODESEGMENT=1 -fno-defer-pop -fno-jump-tables -fno-tree-switch-conversion -MMD -DMODE16=1 -Wa,src/code16gcc.s --param large-stack-frame=4 -fomit-frame-pointer -c -D__ASSEMBLY__ src/romlayout.S -o out/romlayout.o
./scripts/buildversion.sh out/version.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Iout/ -Isrc -Os -MD -g -Wall -Wno-strict-aliasing -Wold-style-definition -Wtype-limits -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 -minline-all-stringops -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks -ffunction-sections -fdata-sections -fno-common  -fno-stack-protector  -DMODE16=0 -DMODESEGMENT=0 -fomit-frame-pointer -c out/version.c -o out/version.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -melf_i386 -r out/ccode32flat.o out/version.o -o out/code32flat.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -melf_i386 -r out/ccode16.o out/romlayout.o -o out/code16.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objdump -thr out/code32flat.o > out/code32flat.o.objdump
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objdump -thr out/code32seg.o > out/code32seg.o.objdump
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objdump -thr out/code16.o > out/code16.o.objdump
python ./scripts/layoutrom.py out/code16.o.objdump out/code32seg.o.objdump out/code32flat.o.objdump out/autoconf.h out/romlayout16.lds out/romlayout32seg.lds out/romlayout32flat.lds
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -T out/romlayout16.lds out/code16.o -o out/rom16.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --only-keep-debug out/rom16.o out/rom16.o.debug
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-strip out/rom16.o -o out/rom16.strip.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -T out/romlayout32seg.lds out/code32seg.o -o out/rom32seg.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --only-keep-debug out/rom32seg.o out/rom32seg.o.debug
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-strip out/rom32seg.o -o out/rom32seg.strip.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -T out/romlayout32flat.lds out/rom16.strip.o out/rom32seg.strip.o out/code32flat.o -o out/rom.o
rm -f out/bios.bin out/Csm16.bin out/bios.bin.elf
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objdump -thr out/rom.o > out/rom.o.objdump
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --only-keep-debug out/rom.o out/seabios.debug
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --strip-debug out/rom.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --add-gnu-debuglink=out/seabios.debug out/rom.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy -O binary out/rom.o out/bios.bin.raw
python ./scripts/checkrom.py out/rom.o.objdump 0 out/bios.bin.raw out/bios.bin.prep
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-strip -R .comment out/rom.o -o out/bios.bin.elf
popd # payloads/seabios
mkdir -p build/util/nvramtool
mkdir -p build/util/nvramtool/accessors
mkdir -p build/util/nvramtool/cli
build/util/nvramtool/nvramtool -y $ROOTDIR/src/mainboard/pcengines/apu/cmos.layout -H build/option_table.h
rm -f build/build.h
set -e ; export KERNELVERSION="\""4.0"\"" ; export COREBOOT_EXTRA_VERSION="" ; export CC="cc" ; export AS="as" ; export LD="ld" ; export ROUND_TIME="1" ; util/genbuild_h/genbuild_h.sh > build/build.ht
mv build/build.ht build/build.h
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -D__PRE_RAM__ -Isrc -I. -Ibuild -c -S src/mainboard/pcengines/apu/romstage.c -o build/mainboard/pcengines/apu/romstage.pre.inc
sed -e 's/\.rodata/.rom.data/g' -e 's/\^\.text/.section .rom.text/g' -e 's/\^\.section \.text/.section .rom.text/g' build/mainboard/pcengines/apu/romstage.pre.inc > build/mainboard/pcengines/apu/romstage.inc.tmp
mv build/mainboard/pcengines/apu/romstage.inc.tmp build/mainboard/pcengines/apu/romstage.inc
printf '#include "src/arch/x86/init/prologue.inc"\n #include "src/cpu/x86/32bit/entry32.inc"\n #include "src/cpu/x86/fpu_enable.inc"\n #include "src/cpu/amd/agesa/cache_as_ram.inc"\n #include "mainboard/pcengines/apu/romstage.inc"\n' > build/generated/crt0.romstage.S
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -MMD -x assembler-with-cpp -E -Isrc/include -Isrc/arch/x86/include -Ibuild -include build/config.h -include build/build.h -I. -Isrc build/generated/crt0.romstage.S -o build/generated/crt0.s
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -Wa,-acdlns -c -o build/generated/crt0.romstage.o build/generated/crt0.s  > build/generated/crt0.romstage.disasm
mkdir -p build/mainboard/pcengines/apu
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -MMD -D__PRE_RAM__ -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/static.romstage.o build/mainboard/pcengines/apu/static.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/cbmem.romstage.o src/arch/x86/boot/cbmem.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/cbfs_and_run.romstage.o src/arch/x86/lib/cbfs_and_run.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/memcpy.romstage.o src/arch/x86/lib/memcpy.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/memmove.romstage.o src/arch/x86/lib/memmove.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/memset.romstage.o src/arch/x86/lib/memset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/rom_media.romstage.o src/arch/x86/lib/rom_media.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/console.romstage.o src/console/console.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/die.romstage.o src/console/die.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/init.romstage.o src/console/init.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/post.romstage.o src/console/post.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/printk.romstage.o src/console/printk.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/vtxprintf.romstage.o src/console/vtxprintf.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/amd/agesa/s3_resume.romstage.o src/cpu/amd/agesa/s3_resume.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/car.romstage.o src/cpu/x86/car.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/lapic/apic_timer.romstage.o src/cpu/x86/lapic/apic_timer.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/lapic/boot_cpu.romstage.o src/cpu/x86/lapic/boot_cpu.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/device_romstage.romstage.o src/device/device_romstage.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/dram/ddr3.romstage.o src/device/dram/ddr3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/pci_early.romstage.o src/device/pci_early.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/pc80/mc146818rtc.romstage.o src/drivers/pc80/mc146818rtc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/pc80/mc146818rtc_early.romstage.o src/drivers/pc80/mc146818rtc_early.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/uart/uart8250io.romstage.o src/drivers/uart/uart8250io.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/uart/util.romstage.o src/drivers/uart/util.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/bootmode.romstage.o src/lib/bootmode.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/cbfs.romstage.o src/lib/cbfs.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/cbmem.romstage.o src/lib/cbmem.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/clog2.romstage.o src/lib/clog2.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/compute_ip_checksum.romstage.o src/lib/compute_ip_checksum.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/gcc.romstage.o src/lib/gcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/hexdump.romstage.o src/lib/hexdump.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/loaders/cbfs_ramstage_loader.romstage.o src/lib/loaders/cbfs_ramstage_loader.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/loaders/load_and_run_ramstage.romstage.o src/lib/loaders/load_and_run_ramstage.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/lzma.romstage.o src/lib/lzma.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/memchr.romstage.o src/lib/memchr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/memcmp.romstage.o src/lib/memcmp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/ramtest.romstage.o src/lib/ramtest.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/BiosCallOuts.romstage.o src/mainboard/pcengines/apu/BiosCallOuts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/PlatformGnbPcie.romstage.o src/mainboard/pcengines/apu/PlatformGnbPcie.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/agesawrapper.romstage.o src/mainboard/pcengines/apu/agesawrapper.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/buildOpts.romstage.o src/mainboard/pcengines/apu/buildOpts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/gpio_ftns.romstage.o src/mainboard/pcengines/apu/gpio_ftns.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/northbridge/amd/agesa/common/common.romstage.o src/northbridge/amd/agesa/common/common.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/northbridge/amd/agesa/family14/dimmSpd.romstage.o src/northbridge/amd/agesa/family14/dimmSpd.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/northbridge/amd/agesa/family14/fam14_callouts.romstage.o src/northbridge/amd/agesa/family14/fam14_callouts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/cimx_util.romstage.o src/southbridge/amd/cimx/cimx_util.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/cfg.romstage.o src/southbridge/amd/cimx/sb800/cfg.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/early.romstage.o src/southbridge/amd/cimx/sb800/early.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/reset.romstage.o src/southbridge/amd/cimx/sb800/reset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/smbus.romstage.o src/southbridge/amd/cimx/sb800/smbus.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/ACPILIB.romstage.o src/vendorcode/amd/cimx/sb800/ACPILIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/AMDLIB.romstage.o src/vendorcode/amd/cimx/sb800/AMDLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/AMDSBLIB.romstage.o src/vendorcode/amd/cimx/sb800/AMDSBLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/AZALIA.romstage.o src/vendorcode/amd/cimx/sb800/AZALIA.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/DISPATCHER.romstage.o src/vendorcode/amd/cimx/sb800/DISPATCHER.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/EC.romstage.o src/vendorcode/amd/cimx/sb800/EC.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/ECLIB.romstage.o src/vendorcode/amd/cimx/sb800/ECLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/ECfanLIB.romstage.o src/vendorcode/amd/cimx/sb800/ECfanLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/ECfanc.romstage.o src/vendorcode/amd/cimx/sb800/ECfanc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/GEC.romstage.o src/vendorcode/amd/cimx/sb800/GEC.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/Gpp.romstage.o src/vendorcode/amd/cimx/sb800/Gpp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/IOLIB.romstage.o src/vendorcode/amd/cimx/sb800/IOLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/MEMLIB.romstage.o src/vendorcode/amd/cimx/sb800/MEMLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/PCILIB.romstage.o src/vendorcode/amd/cimx/sb800/PCILIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/PMIO2LIB.romstage.o src/vendorcode/amd/cimx/sb800/PMIO2LIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/PMIOLIB.romstage.o src/vendorcode/amd/cimx/sb800/PMIOLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SATA.romstage.o src/vendorcode/amd/cimx/sb800/SATA.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SBCMN.romstage.o src/vendorcode/amd/cimx/sb800/SBCMN.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SBMAIN.romstage.o src/vendorcode/amd/cimx/sb800/SBMAIN.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SBPELIB.romstage.o src/vendorcode/amd/cimx/sb800/SBPELIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SBPOR.romstage.o src/vendorcode/amd/cimx/sb800/SBPOR.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SMM.romstage.o src/vendorcode/amd/cimx/sb800/SMM.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -D__PRE_RAM__ -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/USB.romstage.o src/vendorcode/amd/cimx/sb800/USB.c
awk '/^#define ([^"])* ([^"])*$/ {gsub("\\r","",$3); print $2 " = " $3 ";";}' build/config.h > build/ldoptions
rm -f build/generated/romstage_null.ld
printf "ROMSTAGE_BASE = 0x0;\n" > build/generated/romstage_null.ld.tmp
printf 'INCLUDE "ldoptions"\n INCLUDE "src/arch/x86/init/romstage.ld"\n INCLUDE "src/cpu/x86/32bit/entry32.lds"\n' >> build/generated/romstage_null.ld.tmp
mv build/generated/romstage_null.ld.tmp build/generated/romstage_null.ld
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Isrc/arch/x86/include -MM -MTbuild/generated/bootblock.inc src/arch/x86/init/bootblock_simple.c > build/generated/bootblock.inc.d
build/util/romcc/romcc -c -S -mcpu=i386 -O2 -D__PRE_RAM__ -D__BOOT_BLOCK__ -I. -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Isrc/arch/x86/include src/arch/x86/init/bootblock_simple.c -o build/generated/bootblock.inc
printf '#include "src/arch/x86/init/prologue.inc"\n #include "src/cpu/x86/16bit/entry16.inc"\n #include "src/cpu/x86/16bit/reset16.inc"\n #include "src/cpu/x86/32bit/entry32.inc"\n #include "src/arch/x86/lib/id.inc"\n #include "build/generated/bootblock.inc"\n #include "src/arch/x86/lib/walkcbfs.S"\n' > build/generated/bootblock_inc.S
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -MMD -x assembler-with-cpp -E -Isrc/include -Isrc/arch/x86/include -Ibuild -include build/build.h -include build/config.h -I. -Isrc build/generated/bootblock_inc.S -o build/generated/bootblock.s
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -Wa,-acdlns -c -o build/generated/bootblock.o build/generated/bootblock.s  > build/generated/bootblock.disasm
printf 'INCLUDE "ldoptions"\n INCLUDE "src/arch/x86/init/ldscript_failover.lb"\n INCLUDE "src/cpu/x86/16bit/entry16.lds"\n INCLUDE "src/cpu/x86/16bit/reset16.lds"\n INCLUDE "src/arch/x86/lib/id.lds"\n' > build/generated/bootblock.ld
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -nostdlib -nostartfiles -static -o build/cbfs/fallback/bootblock.debug -Lbuild -T build/generated/bootblock.ld build/generated/bootblock.o
cp build/cbfs/fallback/bootblock.debug build/cbfs/fallback/bootblock.elf.tmp
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-nm -n build/cbfs/fallback/bootblock.elf.tmp | sort > build/cbfs/fallback/bootblock.map
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --strip-debug build/cbfs/fallback/bootblock.elf.tmp
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --add-gnu-debuglink=build/cbfs/fallback/bootblock.debug build/cbfs/fallback/bootblock.elf.tmp
mv build/cbfs/fallback/bootblock.elf.tmp build/cbfs/fallback/bootblock.elf
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy -O binary build/cbfs/fallback/bootblock.elf build/cbfs/fallback/bootblock.bin
build/util/nvramtool/nvramtool -y $ROOTDIR/src/mainboard/pcengines/apu/cmos.layout -L build/cmos_layout.bin
for f in src/mainboard/pcengines/apu/HYNIX-H5TQ2G83CFR.spd.hex src/mainboard/pcengines/apu/HYNIX-H5TQ4G83MFR.spd.hex; do for c in $(cat $f | grep -v ^#); do echo -e -n "\\x$c"; done; done > build/spd.bin
printf %d 32768 | LC_ALL=C awk '{for (i=0; i<$1; i++) {printf "%c", 255}}' > build/coreboot_s3nv.rom.tmp
mv build/coreboot_s3nv.rom.tmp build/coreboot_s3nv.rom
build/cbfstool build/coreboot.pre1.tmp create -s 2048K -B build/cbfs/fallback/bootblock.bin -a 64 -m x86 -o $(( 0x200000 - 0x200000 ))
if [ -e build/cmos_layout.bin ]; then build/cbfstool build/coreboot.pre1.tmp add -f build/cmos_layout.bin -n cmos_layout.bin -t 0x01aa  ; fi ; if [ -e build/spd.bin ]; then   build/cbfstool build/coreboot.pre1.tmp add -f build/spd.bin -n spd.bin -t spd  ; fi ; if [ -e build/coreboot_s3nv.rom ]; then   build/cbfstool build/coreboot.pre1.tmp add -f build/coreboot_s3nv.rom -n s3nv -t raw -b 0xFFFF0000 ; fi
true
mv build/coreboot.pre1.tmp build/coreboot.pre1
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Legacy/Proc/Dispatcher.libagesa.o src/vendorcode/amd/agesa/f14/Legacy/Proc/Dispatcher.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Legacy/Proc/agesaCallouts.libagesa.o src/vendorcode/amd/agesa/f14/Legacy/Proc/agesaCallouts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Legacy/Proc/hobTransfer.libagesa.o src/vendorcode/amd/agesa/f14/Legacy/Proc/hobTransfer.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Lib/amdlib.libagesa.o src/vendorcode/amd/agesa/f14/Lib/amdlib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Lib/helper.libagesa.o src/vendorcode/amd/agesa/f14/Lib/helper.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14C6State.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14C6State.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14IoCstate.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14IoCstate.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch0500000B.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch0500000B.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch0500001A.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch0500001A.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch05000028.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch05000028.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch05000101.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch05000101.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnCpb.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnCpb.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnEquivalenceTable.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnEquivalenceTable.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnInitEarlyTable.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnInitEarlyTable.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnLogicalIdTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnLogicalIdTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnMicrocodePatchTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnMicrocodePatchTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnPciTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnPciTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuCommonF14Utilities.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuCommonF14Utilities.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14BrandId.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14BrandId.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14BrandIdFt1.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14BrandIdFt1.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14CacheDefaults.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14CacheDefaults.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Dmi.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Dmi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14LowPowerInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14LowPowerInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14MsrTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14MsrTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PciTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PciTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PerCorePciTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PerCorePciTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerCheck.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerCheck.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerMgmtSystemTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerMgmtSystemTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerPlane.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerPlane.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Pstate.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Pstate.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14SoftwareThermal.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14SoftwareThermal.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Utilities.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Utilities.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14WheaInitDataTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14WheaInitDataTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuC6State.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuC6State.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCacheFlushOnHalt.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCacheFlushOnHalt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCacheInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCacheInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCpb.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCpb.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuDmi.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuDmi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuFeatureLeveling.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuFeatureLeveling.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuFeatures.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuFeatures.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuHwC1e.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuHwC1e.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuIoCstate.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuIoCstate.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateGather.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateGather.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateLeveling.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateLeveling.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateTables.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateTables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuSlit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuSlit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuSrat.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuSrat.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuWhea.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuWhea.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/S3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/S3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/Table.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/Table.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cahalt.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cahalt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cahaltasm.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cahaltasm.S
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuApicUtilities.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuApicUtilities.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuBist.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuBist.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuBrandId.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuBrandId.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuEarlyInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuEarlyInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuEventLog.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuEventLog.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuFamilyTranslation.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuFamilyTranslation.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuGeneralServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuGeneralServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuInitEarlyTable.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuInitEarlyTable.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuLateInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuLateInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuMicrocodePatch.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuMicrocodePatch.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuPostInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuPostInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmt.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmtMultiSocket.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmtMultiSocket.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmtSingleSocket.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmtSingleSocket.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuWarmReset.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/cpuWarmReset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/CPU/heapManager.libagesa.o src/vendorcode/amd/agesa/f14/Proc/CPU/heapManager.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitEarly.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdInitEarly.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitEnv.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdInitEnv.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitLate.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdInitLate.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitMid.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdInitMid.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdInitPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitReset.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdInitReset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitResume.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdInitResume.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdLateRunApTask.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdLateRunApTask.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdS3LateRestore.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdS3LateRestore.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/AmdS3Save.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/AmdS3Save.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/CommonInits.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/CommonInits.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/CommonReturns.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/CommonReturns.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/CreateStruct.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/CreateStruct.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/S3RestoreState.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/S3RestoreState.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Common/S3SaveState.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Common/S3SaveState.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Common/GnbLibFeatures.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Common/GnbLibFeatures.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family/0x14/F14GfxServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family/0x14/F14GfxServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxConfigData.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxConfigData.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxGmcInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxGmcInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtEnvPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtEnvPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtMidPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtMidPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxIntegratedInfoTableInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxIntegratedInfoTableInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxLib.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxLib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxRegisterAcc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxRegisterAcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxStrapsInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxStrapsInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtEarly.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtEarly.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtEnv.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtEnv.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtLate.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtLate.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtMid.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtMid.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtReset.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtReset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLib.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibCpuAcc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibCpuAcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibHeap.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibHeap.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibIoAcc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibIoAcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibMemAcc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibMemAcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibPci.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibPci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibPciAcc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibPciAcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxConfig/GfxConfigEnv.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxConfig/GfxConfigEnv.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxConfig/GfxConfigPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxConfig/GfxConfigPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxCardInfo.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxCardInfo.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxEnumConnectors.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxEnumConnectors.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxPowerPlayTable.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxPowerPlayTable.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbNbInitLibV1/GnbNbInitLibV1.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbNbInitLibV1/GnbNbInitLibV1.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieAlibV1/PcieAlib.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieAlibV1/PcieAlib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieConfigData.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieConfigData.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieConfigLib.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieConfigLib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieInputParser.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieInputParser.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieMapTopology.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieMapTopology.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspm.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspm.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspmBlackList.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspmBlackList.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspmExitLatency.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspmExitLatency.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePifServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePifServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePortRegAcc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePortRegAcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePortServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePortServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePowerMgmt.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePowerMgmt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieSbLink.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieSbLink.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieSiliconServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieSiliconServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieTimer.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieTimer.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieTopologyServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieTopologyServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieUtilityLib.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieUtilityLib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieWrapperRegAcc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieWrapperRegAcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieTrainingV1/PcieTraining.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieTrainingV1/PcieTraining.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieTrainingV1/PcieWorkarounds.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieTrainingV1/PcieWorkarounds.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbLclkDpm.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbLclkDpm.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbLclkNclkRatio.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbLclkNclkRatio.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbPowerGate.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbPowerGate.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbSmu.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbSmu.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature/NbFuseTable.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature/NbFuseTable.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature/NbLclkDpm.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature/NbLclkDpm.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbConfigData.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbConfigData.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtEarly.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtEarly.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtEnv.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtEnv.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtLatePost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtLatePost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtReset.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtReset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbPowerMgmt.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbPowerMgmt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbSmuLib.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbSmuLib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieAlib.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieAlib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieComplexConfig.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieComplexConfig.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieComplexServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieComplexServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PciePhyServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PciePhyServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PciePifServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PciePifServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieWrapperServices.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieWrapperServices.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtEarlyPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtEarlyPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtEnv.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtEnv.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtLatePost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtLatePost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtPost.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtPost.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieLateInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieLateInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieMiscLib.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieMiscLib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PciePortInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PciePortInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PciePortLateInit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PciePortLateInit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/Fam14/htNbFam14.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/Fam14/htNbFam14.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/Fam14/htNbUtilitiesFam14.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/Fam14/htNbUtilitiesFam14.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/htFeat.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/htFeat.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/htInterface.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/htInterface.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceCoherent.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceCoherent.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceGeneral.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceGeneral.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceNonCoherent.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceNonCoherent.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/htMain.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/htMain.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/htNb.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/htNb.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/HT/htNotify.libagesa.o src/vendorcode/amd/agesa/f14/Proc/HT/htNotify.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ON/mason3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ON/mason3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ON/mauon3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ON/mauon3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ma.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ma.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/CHINTLV/mfchi.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/CHINTLV/mfchi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/CSINTLV/mfcsi.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/CSINTLV/mfcsi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/DMI/mfDMI.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/DMI/mfDMI.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ECC/mfecc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ECC/mfecc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ECC/mfemp.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ECC/mfemp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/EXCLUDIMM/mfdimmexclud.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/EXCLUDIMM/mfdimmexclud.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/IDENDIMM/mfidendimm.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/IDENDIMM/mfidendimm.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/INTLVRN/mfintlvrn.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/INTLVRN/mfintlvrn.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/LVDDR3/mflvddr3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/LVDDR3/mflvddr3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/MEMCLR/mfmemclr.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/MEMCLR/mfmemclr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ODTHERMAL/mfodthermal.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ODTHERMAL/mfodthermal.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/PARTRN/mfParallelTraining.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/PARTRN/mfParallelTraining.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/PARTRN/mfStandardTraining.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/PARTRN/mfStandardTraining.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/S3/mfs3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/S3/mfs3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/TABLE/mftds.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Feat/TABLE/mftds.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/ON/mmflowon.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/ON/mmflowon.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mdef.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mdef.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/merrhdl.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/merrhdl.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/minit.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/minit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mm.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mm.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmConditionalPso.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmConditionalPso.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmEcc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmEcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmExcludeDimm.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmExcludeDimm.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmLvDdr3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmLvDdr3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmMemClr.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmMemClr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmMemRestore.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmMemRestore.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmNodeInterleave.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmNodeInterleave.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmOnlineSpare.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmOnlineSpare.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmParallelTraining.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmParallelTraining.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmStandardTraining.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmStandardTraining.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmUmaAlloc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmUmaAlloc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmflow.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmflow.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mu.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/mu.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/muc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Main/muc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnS3on.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnS3on.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mndcton.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mndcton.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnflowon.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnflowon.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnidendimmon.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnidendimmon.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnmcton.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnmcton.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnon.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnon.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnoton.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnoton.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnphyon.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnphyon.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnprotoon.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnprotoon.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnregon.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnregon.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mn.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mn.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnS3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnS3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mndct.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mndct.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnfeat.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnfeat.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnflow.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnflow.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnmct.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnmct.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnphy.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnphy.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnreg.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnreg.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mntrain3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/NB/mntrain3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Ps/ON/mpson3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Ps/ON/mpson3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Ps/ON/mpuon3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Ps/ON/mpuon3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Ps/mp.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Ps/mp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mt3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mt3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtot3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtot3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtrci3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtrci3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtsdi3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtsdi3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtspd3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtspd3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mttecc3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mttecc3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mttwl3.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mttwl3.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mt.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mthdi.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mthdi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttEdgeDetect.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttEdgeDetect.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttdimbt.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttdimbt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttecc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttecc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mtthrc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mtthrc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttml.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttml.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttoptsrc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttoptsrc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttsrc.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttsrc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -c -o build/vendorcode/amd/agesa/f14/Proc/Recovery/HT/htInitReset.libagesa.o src/vendorcode/amd/agesa/f14/Proc/Recovery/HT/htInitReset.c
ar rcs build/libagesa.fam14.a build/vendorcode/amd/agesa/f14/Legacy/Proc/Dispatcher.libagesa.o build/vendorcode/amd/agesa/f14/Legacy/Proc/agesaCallouts.libagesa.o build/vendorcode/amd/agesa/f14/Legacy/Proc/hobTransfer.libagesa.o build/vendorcode/amd/agesa/f14/Lib/amdlib.libagesa.o build/vendorcode/amd/agesa/f14/Lib/helper.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14C6State.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14IoCstate.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch0500000B.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch0500001A.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch05000028.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/F14MicrocodePatch05000101.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnCpb.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnEquivalenceTable.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnInitEarlyTable.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnLogicalIdTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnMicrocodePatchTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON/F14OnPciTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuCommonF14Utilities.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14BrandId.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14BrandIdFt1.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14CacheDefaults.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Dmi.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14LowPowerInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14MsrTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PciTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PerCorePciTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerCheck.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerMgmtSystemTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14PowerPlane.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Pstate.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14SoftwareThermal.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14Utilities.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/cpuF14WheaInitDataTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuC6State.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCacheFlushOnHalt.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCacheInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuCpb.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuDmi.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuFeatureLeveling.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuFeatures.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuHwC1e.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuIoCstate.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateGather.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateLeveling.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuPstateTables.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuSlit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuSrat.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Feature/cpuWhea.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/S3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/Table.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cahalt.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cahaltasm.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuApicUtilities.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuBist.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuBrandId.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuEarlyInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuEventLog.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuFamilyTranslation.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuGeneralServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuInitEarlyTable.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuLateInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuMicrocodePatch.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuPostInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmt.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmtMultiSocket.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuPowerMgmtSingleSocket.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/cpuWarmReset.libagesa.o build/vendorcode/amd/agesa/f14/Proc/CPU/heapManager.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitEarly.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitEnv.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitLate.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitMid.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitReset.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdInitResume.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdLateRunApTask.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdS3LateRestore.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/AmdS3Save.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/CommonInits.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/CommonReturns.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/CreateStruct.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/S3RestoreState.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Common/S3SaveState.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Common/GnbLibFeatures.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family/0x14/F14GfxServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxConfigData.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxGmcInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtEnvPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtMidPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxInitAtPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxIntegratedInfoTableInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxLib.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxRegisterAcc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/GfxStrapsInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtEarly.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtEnv.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtLate.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtMid.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/GnbInitAtReset.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLib.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibCpuAcc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibHeap.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibIoAcc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibMemAcc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibPci.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib/GnbLibPciAcc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxConfig/GfxConfigEnv.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxConfig/GfxConfigPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxCardInfo.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxEnumConnectors.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbGfxInitLibV1/GfxPowerPlayTable.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbNbInitLibV1/GnbNbInitLibV1.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieAlibV1/PcieAlib.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieConfigData.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieConfigLib.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieInputParser.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieConfig/PcieMapTopology.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspm.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspmBlackList.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspmExitLatency.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePifServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePortRegAcc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePortServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PciePowerMgmt.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieSbLink.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieSiliconServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieTimer.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieTopologyServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieUtilityLib.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieInitLibV1/PcieWrapperRegAcc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieTrainingV1/PcieTraining.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbPcieTrainingV1/PcieWorkarounds.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbLclkDpm.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbLclkNclkRatio.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbPowerGate.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14/F14NbSmu.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature/NbFuseTable.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature/NbLclkDpm.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbConfigData.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtEarly.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtEnv.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtLatePost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbInitAtReset.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbPowerMgmt.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/Nb/NbSmuLib.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieAlib.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieComplexConfig.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieComplexServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PciePhyServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PciePifServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14/F14PcieWrapperServices.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtEarlyPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtEnv.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtLatePost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieInitAtPost.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieLateInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PcieMiscLib.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PciePortInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/PciePortLateInit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/Fam14/htNbFam14.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/Fam14/htNbUtilitiesFam14.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/htFeat.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/htInterface.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceCoherent.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceGeneral.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/htInterfaceNonCoherent.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/htMain.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/htNb.libagesa.o build/vendorcode/amd/agesa/f14/Proc/HT/htNotify.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ON/mason3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ON/mauon3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Ardk/ma.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/CHINTLV/mfchi.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/CSINTLV/mfcsi.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/DMI/mfDMI.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ECC/mfecc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ECC/mfemp.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/EXCLUDIMM/mfdimmexclud.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/IDENDIMM/mfidendimm.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/INTLVRN/mfintlvrn.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/LVDDR3/mflvddr3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/MEMCLR/mfmemclr.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/ODTHERMAL/mfodthermal.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/PARTRN/mfParallelTraining.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/PARTRN/mfStandardTraining.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/S3/mfs3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Feat/TABLE/mftds.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/ON/mmflowon.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mdef.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/merrhdl.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/minit.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mm.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmConditionalPso.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmEcc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmExcludeDimm.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmLvDdr3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmMemClr.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmMemRestore.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmNodeInterleave.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmOnlineSpare.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmParallelTraining.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmStandardTraining.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmUmaAlloc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mmflow.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/mu.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Main/muc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnS3on.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mndcton.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnflowon.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnidendimmon.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnmcton.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnon.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnoton.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnphyon.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnprotoon.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON/mnregon.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mn.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnS3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mndct.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnfeat.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnflow.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnmct.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnphy.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mnreg.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/NB/mntrain3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Ps/ON/mpson3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Ps/ON/mpuon3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Ps/mp.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mt3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtot3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtrci3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtsdi3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mtspd3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mttecc3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/DDR3/mttwl3.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mt.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mthdi.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttEdgeDetect.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttdimbt.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttecc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mtthrc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttml.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttoptsrc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Mem/Tech/mttsrc.libagesa.o build/vendorcode/amd/agesa/f14/Proc/Recovery/HT/htInitReset.libagesa.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -nostdlib -nostartfiles -static -o build/cbfs/fallback/romstage_null.debug -Lbuild -T build/generated/romstage_null.ld -Wl,--wrap,__divdi3 -Wl,--wrap,__udivdi3 -Wl,--wrap,__moddi3 -Wl,--wrap,__umoddi3 -Wl,--start-group build/generated/crt0.romstage.o build/mainboard/pcengines/apu/static.romstage.o build/arch/x86/boot/cbmem.romstage.o build/arch/x86/lib/cbfs_and_run.romstage.o build/arch/x86/lib/memcpy.romstage.o build/arch/x86/lib/memmove.romstage.o build/arch/x86/lib/memset.romstage.o build/arch/x86/lib/rom_media.romstage.o build/console/console.romstage.o build/console/die.romstage.o build/console/init.romstage.o build/console/post.romstage.o build/console/printk.romstage.o build/console/vtxprintf.romstage.o build/cpu/amd/agesa/s3_resume.romstage.o build/cpu/x86/car.romstage.o build/cpu/x86/lapic/apic_timer.romstage.o build/cpu/x86/lapic/boot_cpu.romstage.o build/device/device_romstage.romstage.o build/device/dram/ddr3.romstage.o build/device/pci_early.romstage.o build/drivers/pc80/mc146818rtc.romstage.o build/drivers/pc80/mc146818rtc_early.romstage.o build/drivers/uart/uart8250io.romstage.o build/drivers/uart/util.romstage.o build/lib/bootmode.romstage.o build/lib/cbfs.romstage.o build/lib/cbmem.romstage.o build/lib/clog2.romstage.o build/lib/compute_ip_checksum.romstage.o build/lib/gcc.romstage.o build/lib/hexdump.romstage.o build/lib/loaders/cbfs_ramstage_loader.romstage.o build/lib/loaders/load_and_run_ramstage.romstage.o build/lib/lzma.romstage.o build/lib/memchr.romstage.o build/lib/memcmp.romstage.o build/lib/ramtest.romstage.o build/mainboard/pcengines/apu/BiosCallOuts.romstage.o build/mainboard/pcengines/apu/PlatformGnbPcie.romstage.o build/mainboard/pcengines/apu/agesawrapper.romstage.o build/mainboard/pcengines/apu/buildOpts.romstage.o build/mainboard/pcengines/apu/gpio_ftns.romstage.o build/northbridge/amd/agesa/common/common.romstage.o build/northbridge/amd/agesa/family14/dimmSpd.romstage.o build/northbridge/amd/agesa/family14/fam14_callouts.romstage.o build/southbridge/amd/cimx/cimx_util.romstage.o build/southbridge/amd/cimx/sb800/cfg.romstage.o build/southbridge/amd/cimx/sb800/early.romstage.o build/southbridge/amd/cimx/sb800/reset.romstage.o build/southbridge/amd/cimx/sb800/smbus.romstage.o build/vendorcode/amd/cimx/sb800/ACPILIB.romstage.o build/vendorcode/amd/cimx/sb800/AMDLIB.romstage.o build/vendorcode/amd/cimx/sb800/AMDSBLIB.romstage.o build/vendorcode/amd/cimx/sb800/AZALIA.romstage.o build/vendorcode/amd/cimx/sb800/DISPATCHER.romstage.o build/vendorcode/amd/cimx/sb800/EC.romstage.o build/vendorcode/amd/cimx/sb800/ECLIB.romstage.o build/vendorcode/amd/cimx/sb800/ECfanLIB.romstage.o build/vendorcode/amd/cimx/sb800/ECfanc.romstage.o build/vendorcode/amd/cimx/sb800/GEC.romstage.o build/vendorcode/amd/cimx/sb800/Gpp.romstage.o build/vendorcode/amd/cimx/sb800/IOLIB.romstage.o build/vendorcode/amd/cimx/sb800/MEMLIB.romstage.o build/vendorcode/amd/cimx/sb800/PCILIB.romstage.o build/vendorcode/amd/cimx/sb800/PMIO2LIB.romstage.o build/vendorcode/amd/cimx/sb800/PMIOLIB.romstage.o build/vendorcode/amd/cimx/sb800/SATA.romstage.o build/vendorcode/amd/cimx/sb800/SBCMN.romstage.o build/vendorcode/amd/cimx/sb800/SBMAIN.romstage.o build/vendorcode/amd/cimx/sb800/SBPELIB.romstage.o build/vendorcode/amd/cimx/sb800/SBPOR.romstage.o build/vendorcode/amd/cimx/sb800/SMM.romstage.o build/vendorcode/amd/cimx/sb800/USB.romstage.o  build/libagesa.fam14.a "$SAGE_HOME"/tools/xgcc/bin/../lib/gcc/i386-elf/4.7.3/libgcc.a -Wl,--end-group
cp build/cbfs/fallback/romstage_null.debug build/cbfs/fallback/romstage_null.elf.tmp
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-nm -n build/cbfs/fallback/romstage_null.elf.tmp | sort > build/cbfs/fallback/romstage_null.map
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --strip-debug build/cbfs/fallback/romstage_null.elf.tmp
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --add-gnu-debuglink=build/cbfs/fallback/romstage_null.debug build/cbfs/fallback/romstage_null.elf.tmp
mv build/cbfs/fallback/romstage_null.elf.tmp build/cbfs/fallback/romstage_null.elf
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy -O binary build/cbfs/fallback/romstage_null.elf build/cbfs/fallback/romstage_null.bin
rm -f build/cbfs/fallback/base_xip.txt
if [ -e build/cbfs/fallback/romstage_null.bin ]; then build/cbfstool build/coreboot.pre1 locate -T -f build/cbfs/fallback/romstage_null.bin -n "fallback"/romstage -P 0x100000 > build/cbfs/fallback/base_xip.txt.tmp ; fi
mv build/cbfs/fallback/base_xip.txt.tmp build/cbfs/fallback/base_xip.txt
rm -f build/generated/romstage_xip.ld
sed -e 's/^/ROMSTAGE_BASE = /g' -e 's/$/;/g' build/cbfs/fallback/base_xip.txt > build/generated/romstage_xip.ld.tmp
sed -e '/ROMSTAGE_BASE/d' build/generated/romstage_null.ld >> build/generated/romstage_xip.ld.tmp
mv build/generated/romstage_xip.ld.tmp build/generated/romstage_xip.ld
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -nostdlib -nostartfiles -static -o build/cbfs/fallback/romstage_xip.debug -Lbuild -T build/generated/romstage_xip.ld -Wl,--wrap,__divdi3 -Wl,--wrap,__udivdi3 -Wl,--wrap,__moddi3 -Wl,--wrap,__umoddi3 -Wl,--start-group build/generated/crt0.romstage.o build/mainboard/pcengines/apu/static.romstage.o build/arch/x86/boot/cbmem.romstage.o build/arch/x86/lib/cbfs_and_run.romstage.o build/arch/x86/lib/memcpy.romstage.o build/arch/x86/lib/memmove.romstage.o build/arch/x86/lib/memset.romstage.o build/arch/x86/lib/rom_media.romstage.o build/console/console.romstage.o build/console/die.romstage.o build/console/init.romstage.o build/console/post.romstage.o build/console/printk.romstage.o build/console/vtxprintf.romstage.o build/cpu/amd/agesa/s3_resume.romstage.o build/cpu/x86/car.romstage.o build/cpu/x86/lapic/apic_timer.romstage.o build/cpu/x86/lapic/boot_cpu.romstage.o build/device/device_romstage.romstage.o build/device/dram/ddr3.romstage.o build/device/pci_early.romstage.o build/drivers/pc80/mc146818rtc.romstage.o build/drivers/pc80/mc146818rtc_early.romstage.o build/drivers/uart/uart8250io.romstage.o build/drivers/uart/util.romstage.o build/lib/bootmode.romstage.o build/lib/cbfs.romstage.o build/lib/cbmem.romstage.o build/lib/clog2.romstage.o build/lib/compute_ip_checksum.romstage.o build/lib/gcc.romstage.o build/lib/hexdump.romstage.o build/lib/loaders/cbfs_ramstage_loader.romstage.o build/lib/loaders/load_and_run_ramstage.romstage.o build/lib/lzma.romstage.o build/lib/memchr.romstage.o build/lib/memcmp.romstage.o build/lib/ramtest.romstage.o build/mainboard/pcengines/apu/BiosCallOuts.romstage.o build/mainboard/pcengines/apu/PlatformGnbPcie.romstage.o build/mainboard/pcengines/apu/agesawrapper.romstage.o build/mainboard/pcengines/apu/buildOpts.romstage.o build/mainboard/pcengines/apu/gpio_ftns.romstage.o build/northbridge/amd/agesa/common/common.romstage.o build/northbridge/amd/agesa/family14/dimmSpd.romstage.o build/northbridge/amd/agesa/family14/fam14_callouts.romstage.o build/southbridge/amd/cimx/cimx_util.romstage.o build/southbridge/amd/cimx/sb800/cfg.romstage.o build/southbridge/amd/cimx/sb800/early.romstage.o build/southbridge/amd/cimx/sb800/reset.romstage.o build/southbridge/amd/cimx/sb800/smbus.romstage.o build/vendorcode/amd/cimx/sb800/ACPILIB.romstage.o build/vendorcode/amd/cimx/sb800/AMDLIB.romstage.o build/vendorcode/amd/cimx/sb800/AMDSBLIB.romstage.o build/vendorcode/amd/cimx/sb800/AZALIA.romstage.o build/vendorcode/amd/cimx/sb800/DISPATCHER.romstage.o build/vendorcode/amd/cimx/sb800/EC.romstage.o build/vendorcode/amd/cimx/sb800/ECLIB.romstage.o build/vendorcode/amd/cimx/sb800/ECfanLIB.romstage.o build/vendorcode/amd/cimx/sb800/ECfanc.romstage.o build/vendorcode/amd/cimx/sb800/GEC.romstage.o build/vendorcode/amd/cimx/sb800/Gpp.romstage.o build/vendorcode/amd/cimx/sb800/IOLIB.romstage.o build/vendorcode/amd/cimx/sb800/MEMLIB.romstage.o build/vendorcode/amd/cimx/sb800/PCILIB.romstage.o build/vendorcode/amd/cimx/sb800/PMIO2LIB.romstage.o build/vendorcode/amd/cimx/sb800/PMIOLIB.romstage.o build/vendorcode/amd/cimx/sb800/SATA.romstage.o build/vendorcode/amd/cimx/sb800/SBCMN.romstage.o build/vendorcode/amd/cimx/sb800/SBMAIN.romstage.o build/vendorcode/amd/cimx/sb800/SBPELIB.romstage.o build/vendorcode/amd/cimx/sb800/SBPOR.romstage.o build/vendorcode/amd/cimx/sb800/SMM.romstage.o build/vendorcode/amd/cimx/sb800/USB.romstage.o  build/libagesa.fam14.a "$SAGE_HOME"/tools/xgcc/bin/../lib/gcc/i386-elf/4.7.3/libgcc.a -Wl,--end-group
cp build/cbfs/fallback/romstage_xip.debug build/cbfs/fallback/romstage_xip.elf.tmp
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-nm -n build/cbfs/fallback/romstage_xip.elf.tmp | sort > build/cbfs/fallback/romstage_xip.map
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --strip-debug build/cbfs/fallback/romstage_xip.elf.tmp
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --add-gnu-debuglink=build/cbfs/fallback/romstage_xip.debug build/cbfs/fallback/romstage_xip.elf.tmp
mv build/cbfs/fallback/romstage_xip.elf.tmp build/cbfs/fallback/romstage_xip.elf
cp build/coreboot.pre1 build/coreboot.pre.tmp
if [ -e build/cbfs/fallback/romstage_xip.elf ]; then build/cbfstool build/coreboot.pre.tmp add-stage -f build/cbfs/fallback/romstage_xip.elf -n "fallback"/romstage -c none	-b $( cat build/cbfs/fallback/base_xip.txt ) ; fi
mv build/coreboot.pre.tmp build/coreboot.pre
pushd payloads/ipxe
pushd src
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=__divdi3 -c libgcc/__divdi3.c -o $ROOTDIR/payloads/ipxe/src/bin/__divdi3.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=icc -c libgcc/icc.c -o $ROOTDIR/payloads/ipxe/src/bin/icc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=memcpy -c libgcc/memcpy.c -o $ROOTDIR/payloads/ipxe/src/bin/memcpy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=__moddi3 -c libgcc/__moddi3.c -o $ROOTDIR/payloads/ipxe/src/bin/__moddi3.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=__udivdi3 -c libgcc/__udivdi3.c -o $ROOTDIR/payloads/ipxe/src/bin/__udivdi3.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=__udivmoddi4 -c libgcc/__udivmoddi4.c -o $ROOTDIR/payloads/ipxe/src/bin/__udivmoddi4.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=__umoddi3 -c libgcc/__umoddi3.c -o $ROOTDIR/payloads/ipxe/src/bin/__umoddi3.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=acpi -c core/acpi.c -o $ROOTDIR/payloads/ipxe/src/bin/acpi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ansicol -c core/ansicol.c -o $ROOTDIR/payloads/ipxe/src/bin/ansicol.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ansicoldef -c core/ansicoldef.c -o $ROOTDIR/payloads/ipxe/src/bin/ansicoldef.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ansiesc -c core/ansiesc.c -o $ROOTDIR/payloads/ipxe/src/bin/ansiesc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=asprintf -c core/asprintf.c -o $ROOTDIR/payloads/ipxe/src/bin/asprintf.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=assert -c core/assert.c -o $ROOTDIR/payloads/ipxe/src/bin/assert.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=base16 -c core/base16.c -o $ROOTDIR/payloads/ipxe/src/bin/base16.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=base64 -c core/base64.c -o $ROOTDIR/payloads/ipxe/src/bin/base64.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=basename -c core/basename.c -o $ROOTDIR/payloads/ipxe/src/bin/basename.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bitmap -c core/bitmap.c -o $ROOTDIR/payloads/ipxe/src/bin/bitmap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=blockdev -c core/blockdev.c -o $ROOTDIR/payloads/ipxe/src/bin/blockdev.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=console -c core/console.c -o $ROOTDIR/payloads/ipxe/src/bin/console.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cpio -c core/cpio.c -o $ROOTDIR/payloads/ipxe/src/bin/cpio.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ctype -c core/ctype.c -o $ROOTDIR/payloads/ipxe/src/bin/ctype.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cwuri -c core/cwuri.c -o $ROOTDIR/payloads/ipxe/src/bin/cwuri.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=debug -c core/debug.c -o $ROOTDIR/payloads/ipxe/src/bin/debug.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=debug_md5 -c core/debug_md5.c -o $ROOTDIR/payloads/ipxe/src/bin/debug_md5.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=device -c core/device.c -o $ROOTDIR/payloads/ipxe/src/bin/device.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=downloader -c core/downloader.c -o $ROOTDIR/payloads/ipxe/src/bin/downloader.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=edd -c core/edd.c -o $ROOTDIR/payloads/ipxe/src/bin/edd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=errno -c core/errno.c -o $ROOTDIR/payloads/ipxe/src/bin/errno.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=exec -c core/exec.c -o $ROOTDIR/payloads/ipxe/src/bin/exec.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fbcon -c core/fbcon.c -o $ROOTDIR/payloads/ipxe/src/bin/fbcon.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fnrec -c core/fnrec.c -o $ROOTDIR/payloads/ipxe/src/bin/fnrec.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=gdbserial -c core/gdbserial.c -o $ROOTDIR/payloads/ipxe/src/bin/gdbserial.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=gdbstub -c core/gdbstub.c -o $ROOTDIR/payloads/ipxe/src/bin/gdbstub.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=gdbudp -c core/gdbudp.c -o $ROOTDIR/payloads/ipxe/src/bin/gdbudp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=getkey -c core/getkey.c -o $ROOTDIR/payloads/ipxe/src/bin/getkey.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=getopt -c core/getopt.c -o $ROOTDIR/payloads/ipxe/src/bin/getopt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=hw -c core/hw.c -o $ROOTDIR/payloads/ipxe/src/bin/hw.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=i82365 -c core/i82365.c -o $ROOTDIR/payloads/ipxe/src/bin/i82365.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=image -c core/image.c -o $ROOTDIR/payloads/ipxe/src/bin/image.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=init -c core/init.c -o $ROOTDIR/payloads/ipxe/src/bin/init.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=interface -c core/interface.c -o $ROOTDIR/payloads/ipxe/src/bin/interface.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=iobuf -c core/iobuf.c -o $ROOTDIR/payloads/ipxe/src/bin/iobuf.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=isqrt -c core/isqrt.c -o $ROOTDIR/payloads/ipxe/src/bin/isqrt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=job -c core/job.c -o $ROOTDIR/payloads/ipxe/src/bin/job.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=linebuf -c core/linebuf.c -o $ROOTDIR/payloads/ipxe/src/bin/linebuf.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=lineconsole -c core/lineconsole.c -o $ROOTDIR/payloads/ipxe/src/bin/lineconsole.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=list -c core/list.c -o $ROOTDIR/payloads/ipxe/src/bin/list.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=log -c core/log.c -o $ROOTDIR/payloads/ipxe/src/bin/log.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=main -c core/main.c -o $ROOTDIR/payloads/ipxe/src/bin/main.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=malloc -c core/malloc.c -o $ROOTDIR/payloads/ipxe/src/bin/malloc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=memblock -c core/memblock.c -o $ROOTDIR/payloads/ipxe/src/bin/memblock.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=memmap_settings -c core/memmap_settings.c -o $ROOTDIR/payloads/ipxe/src/bin/memmap_settings.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=menu -c core/menu.c -o $ROOTDIR/payloads/ipxe/src/bin/menu.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=misc -c core/misc.c -o $ROOTDIR/payloads/ipxe/src/bin/misc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=monojob -c core/monojob.c -o $ROOTDIR/payloads/ipxe/src/bin/monojob.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=null_nap -c core/null_nap.c -o $ROOTDIR/payloads/ipxe/src/bin/null_nap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=null_reboot -c core/null_reboot.c -o $ROOTDIR/payloads/ipxe/src/bin/null_reboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=null_sanboot -c core/null_sanboot.c -o $ROOTDIR/payloads/ipxe/src/bin/null_sanboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=null_time -c core/null_time.c -o $ROOTDIR/payloads/ipxe/src/bin/null_time.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nvo -c core/nvo.c -o $ROOTDIR/payloads/ipxe/src/bin/nvo.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=open -c core/open.c -o $ROOTDIR/payloads/ipxe/src/bin/open.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=params -c core/params.c -o $ROOTDIR/payloads/ipxe/src/bin/params.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=parseopt -c core/parseopt.c -o $ROOTDIR/payloads/ipxe/src/bin/parseopt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pc_kbd -c core/pc_kbd.c -o $ROOTDIR/payloads/ipxe/src/bin/pc_kbd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pcmcia -c core/pcmcia.c -o $ROOTDIR/payloads/ipxe/src/bin/pcmcia.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pending -c core/pending.c -o $ROOTDIR/payloads/ipxe/src/bin/pending.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pinger -c core/pinger.c -o $ROOTDIR/payloads/ipxe/src/bin/pinger.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pixbuf -c core/pixbuf.c -o $ROOTDIR/payloads/ipxe/src/bin/pixbuf.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=posix_io -c core/posix_io.c -o $ROOTDIR/payloads/ipxe/src/bin/posix_io.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=process -c core/process.c -o $ROOTDIR/payloads/ipxe/src/bin/process.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=profile -c core/profile.c -o $ROOTDIR/payloads/ipxe/src/bin/profile.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=random -c core/random.c -o $ROOTDIR/payloads/ipxe/src/bin/random.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=refcnt -c core/refcnt.c -o $ROOTDIR/payloads/ipxe/src/bin/refcnt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=resolv -c core/resolv.c -o $ROOTDIR/payloads/ipxe/src/bin/resolv.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=serial -c core/serial.c -o $ROOTDIR/payloads/ipxe/src/bin/serial.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=serial_console -c core/serial_console.c -o $ROOTDIR/payloads/ipxe/src/bin/serial_console.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=settings -c core/settings.c -o $ROOTDIR/payloads/ipxe/src/bin/settings.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=string -c core/string.c -o $ROOTDIR/payloads/ipxe/src/bin/string.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=stringextra -c core/stringextra.c -o $ROOTDIR/payloads/ipxe/src/bin/stringextra.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=strtoull -c core/strtoull.c -o $ROOTDIR/payloads/ipxe/src/bin/strtoull.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=time -c core/time.c -o $ROOTDIR/payloads/ipxe/src/bin/time.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=timer -c core/timer.c -o $ROOTDIR/payloads/ipxe/src/bin/timer.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=uri -c core/uri.c -o $ROOTDIR/payloads/ipxe/src/bin/uri.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=uuid -c core/uuid.c -o $ROOTDIR/payloads/ipxe/src/bin/uuid.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h  -DVERSION_MAJOR=1 -DVERSION_MINOR=0 -DVERSION_PATCH=0 -DVERSION="\"1.0.0+\"" -DOBJECT=version -c core/version.c -o $ROOTDIR/payloads/ipxe/src/bin/version.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vsprintf -c core/vsprintf.c -o $ROOTDIR/payloads/ipxe/src/bin/vsprintf.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wchar -c core/wchar.c -o $ROOTDIR/payloads/ipxe/src/bin/wchar.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=xferbuf -c core/xferbuf.c -o $ROOTDIR/payloads/ipxe/src/bin/xferbuf.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=xfer -c core/xfer.c -o $ROOTDIR/payloads/ipxe/src/bin/xfer.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=aoe -c net/aoe.c -o $ROOTDIR/payloads/ipxe/src/bin/aoe.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=arp -c net/arp.c -o $ROOTDIR/payloads/ipxe/src/bin/arp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dhcpopts -c net/dhcpopts.c -o $ROOTDIR/payloads/ipxe/src/bin/dhcpopts.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dhcppkt -c net/dhcppkt.c -o $ROOTDIR/payloads/ipxe/src/bin/dhcppkt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=eapol -c net/eapol.c -o $ROOTDIR/payloads/ipxe/src/bin/eapol.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ethernet -c net/ethernet.c -o $ROOTDIR/payloads/ipxe/src/bin/ethernet.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=eth_slow -c net/eth_slow.c -o $ROOTDIR/payloads/ipxe/src/bin/eth_slow.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fakedhcp -c net/fakedhcp.c -o $ROOTDIR/payloads/ipxe/src/bin/fakedhcp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fc -c net/fc.c -o $ROOTDIR/payloads/ipxe/src/bin/fc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fcels -c net/fcels.c -o $ROOTDIR/payloads/ipxe/src/bin/fcels.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fcns -c net/fcns.c -o $ROOTDIR/payloads/ipxe/src/bin/fcns.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fcoe -c net/fcoe.c -o $ROOTDIR/payloads/ipxe/src/bin/fcoe.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fcp -c net/fcp.c -o $ROOTDIR/payloads/ipxe/src/bin/fcp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fragment -c net/fragment.c -o $ROOTDIR/payloads/ipxe/src/bin/fragment.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=icmp -c net/icmp.c -o $ROOTDIR/payloads/ipxe/src/bin/icmp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=icmpv4 -c net/icmpv4.c -o $ROOTDIR/payloads/ipxe/src/bin/icmpv4.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=icmpv6 -c net/icmpv6.c -o $ROOTDIR/payloads/ipxe/src/bin/icmpv6.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=infiniband -c net/infiniband.c -o $ROOTDIR/payloads/ipxe/src/bin/infiniband.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=iobpad -c net/iobpad.c -o $ROOTDIR/payloads/ipxe/src/bin/iobpad.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ipv4 -c net/ipv4.c -o $ROOTDIR/payloads/ipxe/src/bin/ipv4.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ipv6 -c net/ipv6.c -o $ROOTDIR/payloads/ipxe/src/bin/ipv6.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ndp -c net/ndp.c -o $ROOTDIR/payloads/ipxe/src/bin/ndp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=neighbour -c net/neighbour.c -o $ROOTDIR/payloads/ipxe/src/bin/neighbour.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=netdevice -c net/netdevice.c -o $ROOTDIR/payloads/ipxe/src/bin/netdevice.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=netdev_settings -c net/netdev_settings.c -o $ROOTDIR/payloads/ipxe/src/bin/netdev_settings.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nullnet -c net/nullnet.c -o $ROOTDIR/payloads/ipxe/src/bin/nullnet.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ping -c net/ping.c -o $ROOTDIR/payloads/ipxe/src/bin/ping.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rarp -c net/rarp.c -o $ROOTDIR/payloads/ipxe/src/bin/rarp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=retry -c net/retry.c -o $ROOTDIR/payloads/ipxe/src/bin/retry.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=socket -c net/socket.c -o $ROOTDIR/payloads/ipxe/src/bin/socket.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tcp -c net/tcp.c -o $ROOTDIR/payloads/ipxe/src/bin/tcp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tcpip -c net/tcpip.c -o $ROOTDIR/payloads/ipxe/src/bin/tcpip.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tls -c net/tls.c -o $ROOTDIR/payloads/ipxe/src/bin/tls.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=udp -c net/udp.c -o $ROOTDIR/payloads/ipxe/src/bin/udp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=validator -c net/validator.c -o $ROOTDIR/payloads/ipxe/src/bin/validator.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vlan -c net/vlan.c -o $ROOTDIR/payloads/ipxe/src/bin/vlan.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=mount -c net/oncrpc/mount.c -o $ROOTDIR/payloads/ipxe/src/bin/mount.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nfs -c net/oncrpc/nfs.c -o $ROOTDIR/payloads/ipxe/src/bin/nfs.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nfs_open -c net/oncrpc/nfs_open.c -o $ROOTDIR/payloads/ipxe/src/bin/nfs_open.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nfs_uri -c net/oncrpc/nfs_uri.c -o $ROOTDIR/payloads/ipxe/src/bin/nfs_uri.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=oncrpc_iob -c net/oncrpc/oncrpc_iob.c -o $ROOTDIR/payloads/ipxe/src/bin/oncrpc_iob.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=portmap -c net/oncrpc/portmap.c -o $ROOTDIR/payloads/ipxe/src/bin/portmap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ftp -c net/tcp/ftp.c -o $ROOTDIR/payloads/ipxe/src/bin/ftp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=http -c net/tcp/http.c -o $ROOTDIR/payloads/ipxe/src/bin/http.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=httpcore -c net/tcp/httpcore.c -o $ROOTDIR/payloads/ipxe/src/bin/httpcore.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=https -c net/tcp/https.c -o $ROOTDIR/payloads/ipxe/src/bin/https.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=iscsi -c net/tcp/iscsi.c -o $ROOTDIR/payloads/ipxe/src/bin/iscsi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=oncrpc -c net/tcp/oncrpc.c -o $ROOTDIR/payloads/ipxe/src/bin/oncrpc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=syslogs -c net/tcp/syslogs.c -o $ROOTDIR/payloads/ipxe/src/bin/syslogs.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dhcp -c net/udp/dhcp.c -o $ROOTDIR/payloads/ipxe/src/bin/dhcp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dhcpv6 -c net/udp/dhcpv6.c -o $ROOTDIR/payloads/ipxe/src/bin/dhcpv6.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dns -c net/udp/dns.c -o $ROOTDIR/payloads/ipxe/src/bin/dns.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=slam -c net/udp/slam.c -o $ROOTDIR/payloads/ipxe/src/bin/slam.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=syslog -c net/udp/syslog.c -o $ROOTDIR/payloads/ipxe/src/bin/syslog.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tftp -c net/udp/tftp.c -o $ROOTDIR/payloads/ipxe/src/bin/tftp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_cm -c net/infiniband/ib_cm.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_cm.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_cmrc -c net/infiniband/ib_cmrc.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_cmrc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_mcast -c net/infiniband/ib_mcast.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_mcast.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_mi -c net/infiniband/ib_mi.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_mi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_packet -c net/infiniband/ib_packet.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_packet.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_pathrec -c net/infiniband/ib_pathrec.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_pathrec.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_sma -c net/infiniband/ib_sma.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_sma.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_smc -c net/infiniband/ib_smc.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_smc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ib_srp -c net/infiniband/ib_srp.c -o $ROOTDIR/payloads/ipxe/src/bin/ib_srp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=net80211 -c net/80211/net80211.c -o $ROOTDIR/payloads/ipxe/src/bin/net80211.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rc80211 -c net/80211/rc80211.c -o $ROOTDIR/payloads/ipxe/src/bin/rc80211.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sec80211 -c net/80211/sec80211.c -o $ROOTDIR/payloads/ipxe/src/bin/sec80211.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wep -c net/80211/wep.c -o $ROOTDIR/payloads/ipxe/src/bin/wep.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wpa -c net/80211/wpa.c -o $ROOTDIR/payloads/ipxe/src/bin/wpa.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wpa_ccmp -c net/80211/wpa_ccmp.c -o $ROOTDIR/payloads/ipxe/src/bin/wpa_ccmp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wpa_psk -c net/80211/wpa_psk.c -o $ROOTDIR/payloads/ipxe/src/bin/wpa_psk.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wpa_tkip -c net/80211/wpa_tkip.c -o $ROOTDIR/payloads/ipxe/src/bin/wpa_tkip.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_image -c image/efi_image.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_image.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=elf -c image/elf.c -o $ROOTDIR/payloads/ipxe/src/bin/elf.o 
env CCACHE_DISABLE=1 "$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h  -DEMBED_ALL="" -DOBJECT=embedded -c image/embedded.c -o $ROOTDIR/payloads/ipxe/src/bin/embedded.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=png -c image/png.c -o $ROOTDIR/payloads/ipxe/src/bin/png.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pnm -c image/pnm.c -o $ROOTDIR/payloads/ipxe/src/bin/pnm.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=script -c image/script.c -o $ROOTDIR/payloads/ipxe/src/bin/script.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=segment -c image/segment.c -o $ROOTDIR/payloads/ipxe/src/bin/segment.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=eisa -c drivers/bus/eisa.c -o $ROOTDIR/payloads/ipxe/src/bin/eisa.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=isa -c drivers/bus/isa.c -o $ROOTDIR/payloads/ipxe/src/bin/isa.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=isa_ids -c drivers/bus/isa_ids.c -o $ROOTDIR/payloads/ipxe/src/bin/isa_ids.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=isapnp -c drivers/bus/isapnp.c -o $ROOTDIR/payloads/ipxe/src/bin/isapnp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=mca -c drivers/bus/mca.c -o $ROOTDIR/payloads/ipxe/src/bin/mca.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pcibackup -c drivers/bus/pcibackup.c -o $ROOTDIR/payloads/ipxe/src/bin/pcibackup.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pci -c drivers/bus/pci.c -o $ROOTDIR/payloads/ipxe/src/bin/pci.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pciextra -c drivers/bus/pciextra.c -o $ROOTDIR/payloads/ipxe/src/bin/pciextra.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pci_settings -c drivers/bus/pci_settings.c -o $ROOTDIR/payloads/ipxe/src/bin/pci_settings.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pcivpd -c drivers/bus/pcivpd.c -o $ROOTDIR/payloads/ipxe/src/bin/pcivpd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=virtio_pci -c drivers/bus/virtio-pci.c -o $ROOTDIR/payloads/ipxe/src/bin/virtio-pci.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=virtio_ring -c drivers/bus/virtio-ring.c -o $ROOTDIR/payloads/ipxe/src/bin/virtio-ring.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=3c503 -c drivers/net/3c503.c -o $ROOTDIR/payloads/ipxe/src/bin/3c503.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=3c509 -c drivers/net/3c509.c -o $ROOTDIR/payloads/ipxe/src/bin/3c509.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=3c509_eisa -c drivers/net/3c509-eisa.c -o $ROOTDIR/payloads/ipxe/src/bin/3c509-eisa.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=3c515 -c drivers/net/3c515.c -o $ROOTDIR/payloads/ipxe/src/bin/3c515.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=3c529 -c drivers/net/3c529.c -o $ROOTDIR/payloads/ipxe/src/bin/3c529.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=3c595 -c drivers/net/3c595.c -o $ROOTDIR/payloads/ipxe/src/bin/3c595.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=3c5x9 -c drivers/net/3c5x9.c -o $ROOTDIR/payloads/ipxe/src/bin/3c5x9.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=3c90x -c drivers/net/3c90x.c -o $ROOTDIR/payloads/ipxe/src/bin/3c90x.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=amd8111e -c drivers/net/amd8111e.c -o $ROOTDIR/payloads/ipxe/src/bin/amd8111e.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=atl1e -c drivers/net/atl1e.c -o $ROOTDIR/payloads/ipxe/src/bin/atl1e.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=b44 -c drivers/net/b44.c -o $ROOTDIR/payloads/ipxe/src/bin/b44.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bnx2 -c drivers/net/bnx2.c -o $ROOTDIR/payloads/ipxe/src/bin/bnx2.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cs89x0 -c drivers/net/cs89x0.c -o $ROOTDIR/payloads/ipxe/src/bin/cs89x0.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=davicom -c drivers/net/davicom.c -o $ROOTDIR/payloads/ipxe/src/bin/davicom.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=depca -c drivers/net/depca.c -o $ROOTDIR/payloads/ipxe/src/bin/depca.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dmfe -c drivers/net/dmfe.c -o $ROOTDIR/payloads/ipxe/src/bin/dmfe.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=eepro100 -c drivers/net/eepro100.c -o $ROOTDIR/payloads/ipxe/src/bin/eepro100.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=eepro -c drivers/net/eepro.c -o $ROOTDIR/payloads/ipxe/src/bin/eepro.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=epic100 -c drivers/net/epic100.c -o $ROOTDIR/payloads/ipxe/src/bin/epic100.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=etherfabric -c drivers/net/etherfabric.c -o $ROOTDIR/payloads/ipxe/src/bin/etherfabric.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=forcedeth -c drivers/net/forcedeth.c -o $ROOTDIR/payloads/ipxe/src/bin/forcedeth.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=intel -c drivers/net/intel.c -o $ROOTDIR/payloads/ipxe/src/bin/intel.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=intelx -c drivers/net/intelx.c -o $ROOTDIR/payloads/ipxe/src/bin/intelx.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ipoib -c drivers/net/ipoib.c -o $ROOTDIR/payloads/ipxe/src/bin/ipoib.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=jme -c drivers/net/jme.c -o $ROOTDIR/payloads/ipxe/src/bin/jme.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=legacy -c drivers/net/legacy.c -o $ROOTDIR/payloads/ipxe/src/bin/legacy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=mii -c drivers/net/mii.c -o $ROOTDIR/payloads/ipxe/src/bin/mii.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=myri10ge -c drivers/net/myri10ge.c -o $ROOTDIR/payloads/ipxe/src/bin/myri10ge.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=myson -c drivers/net/myson.c -o $ROOTDIR/payloads/ipxe/src/bin/myson.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=natsemi -c drivers/net/natsemi.c -o $ROOTDIR/payloads/ipxe/src/bin/natsemi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ne2k_isa -c drivers/net/ne2k_isa.c -o $ROOTDIR/payloads/ipxe/src/bin/ne2k_isa.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ne -c drivers/net/ne.c -o $ROOTDIR/payloads/ipxe/src/bin/ne.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ns8390 -c drivers/net/ns8390.c -o $ROOTDIR/payloads/ipxe/src/bin/ns8390.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pcnet32 -c drivers/net/pcnet32.c -o $ROOTDIR/payloads/ipxe/src/bin/pcnet32.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pnic -c drivers/net/pnic.c -o $ROOTDIR/payloads/ipxe/src/bin/pnic.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=prism2_pci -c drivers/net/prism2_pci.c -o $ROOTDIR/payloads/ipxe/src/bin/prism2_pci.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=prism2_plx -c drivers/net/prism2_plx.c -o $ROOTDIR/payloads/ipxe/src/bin/prism2_plx.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=realtek -c drivers/net/realtek.c -o $ROOTDIR/payloads/ipxe/src/bin/realtek.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rhine -c drivers/net/rhine.c -o $ROOTDIR/payloads/ipxe/src/bin/rhine.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sis190 -c drivers/net/sis190.c -o $ROOTDIR/payloads/ipxe/src/bin/sis190.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sis900 -c drivers/net/sis900.c -o $ROOTDIR/payloads/ipxe/src/bin/sis900.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=skeleton -c drivers/net/skeleton.c -o $ROOTDIR/payloads/ipxe/src/bin/skeleton.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=skge -c drivers/net/skge.c -o $ROOTDIR/payloads/ipxe/src/bin/skge.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sky2 -c drivers/net/sky2.c -o $ROOTDIR/payloads/ipxe/src/bin/sky2.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=smc9000 -c drivers/net/smc9000.c -o $ROOTDIR/payloads/ipxe/src/bin/smc9000.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sundance -c drivers/net/sundance.c -o $ROOTDIR/payloads/ipxe/src/bin/sundance.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tlan -c drivers/net/tlan.c -o $ROOTDIR/payloads/ipxe/src/bin/tlan.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tulip -c drivers/net/tulip.c -o $ROOTDIR/payloads/ipxe/src/bin/tulip.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=velocity -c drivers/net/velocity.c -o $ROOTDIR/payloads/ipxe/src/bin/velocity.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=virtio_net -c drivers/net/virtio-net.c -o $ROOTDIR/payloads/ipxe/src/bin/virtio-net.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vmxnet3 -c drivers/net/vmxnet3.c -o $ROOTDIR/payloads/ipxe/src/bin/vmxnet3.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=w89c840 -c drivers/net/w89c840.c -o $ROOTDIR/payloads/ipxe/src/bin/w89c840.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wd -c drivers/net/wd.c -o $ROOTDIR/payloads/ipxe/src/bin/wd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=igbvf_main -c drivers/net/igbvf/igbvf_main.c -o $ROOTDIR/payloads/ipxe/src/bin/igbvf_main.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=igbvf_mbx -c drivers/net/igbvf/igbvf_mbx.c -o $ROOTDIR/payloads/ipxe/src/bin/igbvf_mbx.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=igbvf_vf -c drivers/net/igbvf/igbvf_vf.c -o $ROOTDIR/payloads/ipxe/src/bin/igbvf_vf.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=phantom -c drivers/net/phantom/phantom.c -o $ROOTDIR/payloads/ipxe/src/bin/phantom.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtl8180 -c drivers/net/rtl818x/rtl8180.c -o $ROOTDIR/payloads/ipxe/src/bin/rtl8180.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtl8180_grf5101 -c drivers/net/rtl818x/rtl8180_grf5101.c -o $ROOTDIR/payloads/ipxe/src/bin/rtl8180_grf5101.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtl8180_max2820 -c drivers/net/rtl818x/rtl8180_max2820.c -o $ROOTDIR/payloads/ipxe/src/bin/rtl8180_max2820.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtl8180_sa2400 -c drivers/net/rtl818x/rtl8180_sa2400.c -o $ROOTDIR/payloads/ipxe/src/bin/rtl8180_sa2400.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtl8185 -c drivers/net/rtl818x/rtl8185.c -o $ROOTDIR/payloads/ipxe/src/bin/rtl8185.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtl8185_rtl8225 -c drivers/net/rtl818x/rtl8185_rtl8225.c -o $ROOTDIR/payloads/ipxe/src/bin/rtl8185_rtl8225.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtl818x -c drivers/net/rtl818x/rtl818x.c -o $ROOTDIR/payloads/ipxe/src/bin/rtl818x.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath_hw -c drivers/net/ath/ath_hw.c -o $ROOTDIR/payloads/ipxe/src/bin/ath_hw.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath_key -c drivers/net/ath/ath_key.c -o $ROOTDIR/payloads/ipxe/src/bin/ath_key.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath_main -c drivers/net/ath/ath_main.c -o $ROOTDIR/payloads/ipxe/src/bin/ath_main.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath_regd -c drivers/net/ath/ath_regd.c -o $ROOTDIR/payloads/ipxe/src/bin/ath_regd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_attach -c drivers/net/ath/ath5k/ath5k_attach.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_attach.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k -c drivers/net/ath/ath5k/ath5k.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_caps -c drivers/net/ath/ath5k/ath5k_caps.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_caps.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_desc -c drivers/net/ath/ath5k/ath5k_desc.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_desc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_dma -c drivers/net/ath/ath5k/ath5k_dma.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_dma.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_eeprom -c drivers/net/ath/ath5k/ath5k_eeprom.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_eeprom.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_gpio -c drivers/net/ath/ath5k/ath5k_gpio.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_gpio.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_initvals -c drivers/net/ath/ath5k/ath5k_initvals.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_initvals.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_pcu -c drivers/net/ath/ath5k/ath5k_pcu.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_pcu.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_phy -c drivers/net/ath/ath5k/ath5k_phy.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_phy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_qcu -c drivers/net/ath/ath5k/ath5k_qcu.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_qcu.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_reset -c drivers/net/ath/ath5k/ath5k_reset.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_reset.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath5k_rfkill -c drivers/net/ath/ath5k/ath5k_rfkill.c -o $ROOTDIR/payloads/ipxe/src/bin/ath5k_rfkill.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ani -c drivers/net/ath/ath9k/ath9k_ani.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ani.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar5008_phy -c drivers/net/ath/ath9k/ath9k_ar5008_phy.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar5008_phy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9002_calib -c drivers/net/ath/ath9k/ath9k_ar9002_calib.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9002_calib.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9002_hw -c drivers/net/ath/ath9k/ath9k_ar9002_hw.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9002_hw.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9002_mac -c drivers/net/ath/ath9k/ath9k_ar9002_mac.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9002_mac.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9002_phy -c drivers/net/ath/ath9k/ath9k_ar9002_phy.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9002_phy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9003_calib -c drivers/net/ath/ath9k/ath9k_ar9003_calib.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_calib.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9003_eeprom -c drivers/net/ath/ath9k/ath9k_ar9003_eeprom.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_eeprom.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9003_hw -c drivers/net/ath/ath9k/ath9k_ar9003_hw.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_hw.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9003_mac -c drivers/net/ath/ath9k/ath9k_ar9003_mac.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_mac.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_ar9003_phy -c drivers/net/ath/ath9k/ath9k_ar9003_phy.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_phy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k -c drivers/net/ath/ath9k/ath9k.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_calib -c drivers/net/ath/ath9k/ath9k_calib.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_calib.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_common -c drivers/net/ath/ath9k/ath9k_common.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_common.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_eeprom_4k -c drivers/net/ath/ath9k/ath9k_eeprom_4k.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_eeprom_4k.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_eeprom_9287 -c drivers/net/ath/ath9k/ath9k_eeprom_9287.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_eeprom_9287.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_eeprom -c drivers/net/ath/ath9k/ath9k_eeprom.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_eeprom.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_eeprom_def -c drivers/net/ath/ath9k/ath9k_eeprom_def.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_eeprom_def.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_hw -c drivers/net/ath/ath9k/ath9k_hw.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_hw.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_init -c drivers/net/ath/ath9k/ath9k_init.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_init.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_mac -c drivers/net/ath/ath9k/ath9k_mac.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_mac.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_main -c drivers/net/ath/ath9k/ath9k_main.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_main.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_recv -c drivers/net/ath/ath9k/ath9k_recv.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_recv.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ath9k_xmit -c drivers/net/ath/ath9k/ath9k_xmit.c -o $ROOTDIR/payloads/ipxe/src/bin/ath9k_xmit.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vxge -c drivers/net/vxge/vxge.c -o $ROOTDIR/payloads/ipxe/src/bin/vxge.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vxge_config -c drivers/net/vxge/vxge_config.c -o $ROOTDIR/payloads/ipxe/src/bin/vxge_config.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vxge_main -c drivers/net/vxge/vxge_main.c -o $ROOTDIR/payloads/ipxe/src/bin/vxge_main.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vxge_traffic -c drivers/net/vxge/vxge_traffic.c -o $ROOTDIR/payloads/ipxe/src/bin/vxge_traffic.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=snpnet -c drivers/net/efi/snpnet.c -o $ROOTDIR/payloads/ipxe/src/bin/snpnet.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=snponly -c drivers/net/efi/snponly.c -o $ROOTDIR/payloads/ipxe/src/bin/snponly.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tg3 -c drivers/net/tg3/tg3.c -o $ROOTDIR/payloads/ipxe/src/bin/tg3.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tg3_hw -c drivers/net/tg3/tg3_hw.c -o $ROOTDIR/payloads/ipxe/src/bin/tg3_hw.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tg3_phy -c drivers/net/tg3/tg3_phy.c -o $ROOTDIR/payloads/ipxe/src/bin/tg3_phy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ata -c drivers/block/ata.c -o $ROOTDIR/payloads/ipxe/src/bin/ata.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ibft -c drivers/block/ibft.c -o $ROOTDIR/payloads/ipxe/src/bin/ibft.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=scsi -c drivers/block/scsi.c -o $ROOTDIR/payloads/ipxe/src/bin/scsi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=srp -c drivers/block/srp.c -o $ROOTDIR/payloads/ipxe/src/bin/srp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nvs -c drivers/nvs/nvs.c -o $ROOTDIR/payloads/ipxe/src/bin/nvs.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nvsvpd -c drivers/nvs/nvsvpd.c -o $ROOTDIR/payloads/ipxe/src/bin/nvsvpd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=spi -c drivers/nvs/spi.c -o $ROOTDIR/payloads/ipxe/src/bin/spi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=threewire -c drivers/nvs/threewire.c -o $ROOTDIR/payloads/ipxe/src/bin/threewire.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bitbash -c drivers/bitbash/bitbash.c -o $ROOTDIR/payloads/ipxe/src/bin/bitbash.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=i2c_bit -c drivers/bitbash/i2c_bit.c -o $ROOTDIR/payloads/ipxe/src/bin/i2c_bit.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=spi_bit -c drivers/bitbash/spi_bit.c -o $ROOTDIR/payloads/ipxe/src/bin/spi_bit.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=arbel -c drivers/infiniband/arbel.c -o $ROOTDIR/payloads/ipxe/src/bin/arbel.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=hermon -c drivers/infiniband/hermon.c -o $ROOTDIR/payloads/ipxe/src/bin/hermon.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=linda -c drivers/infiniband/linda.c -o $ROOTDIR/payloads/ipxe/src/bin/linda.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=linda_fw -c drivers/infiniband/linda_fw.c -o $ROOTDIR/payloads/ipxe/src/bin/linda_fw.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=qib7322 -c drivers/infiniband/qib7322.c -o $ROOTDIR/payloads/ipxe/src/bin/qib7322.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_bofm -c interface/efi/efi_bofm.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_bofm.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_console -c interface/efi/efi_console.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_console.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_debug -c interface/efi/efi_debug.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_debug.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_download -c interface/efi/efi_download.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_download.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_driver -c interface/efi/efi_driver.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_driver.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_file -c interface/efi/efi_file.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_file.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_hii -c interface/efi/efi_hii.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_hii.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_init -c interface/efi/efi_init.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_init.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_pci -c interface/efi/efi_pci.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_pci.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_reboot -c interface/efi/efi_reboot.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_reboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_smbios -c interface/efi/efi_smbios.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_smbios.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_snp -c interface/efi/efi_snp.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_snp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_snp_hii -c interface/efi/efi_snp_hii.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_snp_hii.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_strings -c interface/efi/efi_strings.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_strings.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_timer -c interface/efi/efi_timer.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_timer.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_uaccess -c interface/efi/efi_uaccess.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_uaccess.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efi_umalloc -c interface/efi/efi_umalloc.c -o $ROOTDIR/payloads/ipxe/src/bin/efi_umalloc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=smbios -c interface/smbios/smbios.c -o $ROOTDIR/payloads/ipxe/src/bin/smbios.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=smbios_settings -c interface/smbios/smbios_settings.c -o $ROOTDIR/payloads/ipxe/src/bin/smbios_settings.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bofm -c interface/bofm/bofm.c -o $ROOTDIR/payloads/ipxe/src/bin/bofm.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=aes_cbc_test -c tests/aes_cbc_test.c -o $ROOTDIR/payloads/ipxe/src/bin/aes_cbc_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=base16_test -c tests/base16_test.c -o $ROOTDIR/payloads/ipxe/src/bin/base16_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=base64_test -c tests/base64_test.c -o $ROOTDIR/payloads/ipxe/src/bin/base64_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bigint_test -c tests/bigint_test.c -o $ROOTDIR/payloads/ipxe/src/bin/bigint_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bofm_test -c tests/bofm_test.c -o $ROOTDIR/payloads/ipxe/src/bin/bofm_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=byteswap_test -c tests/byteswap_test.c -o $ROOTDIR/payloads/ipxe/src/bin/byteswap_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cbc_test -c tests/cbc_test.c -o $ROOTDIR/payloads/ipxe/src/bin/cbc_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cms_test -c tests/cms_test.c -o $ROOTDIR/payloads/ipxe/src/bin/cms_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=crc32_test -c tests/crc32_test.c -o $ROOTDIR/payloads/ipxe/src/bin/crc32_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=deflate_test -c tests/deflate_test.c -o $ROOTDIR/payloads/ipxe/src/bin/deflate_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=digest_test -c tests/digest_test.c -o $ROOTDIR/payloads/ipxe/src/bin/digest_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dns_test -c tests/dns_test.c -o $ROOTDIR/payloads/ipxe/src/bin/dns_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=entropy_sample -c tests/entropy_sample.c -o $ROOTDIR/payloads/ipxe/src/bin/entropy_sample.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=hash_df_test -c tests/hash_df_test.c -o $ROOTDIR/payloads/ipxe/src/bin/hash_df_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=hmac_drbg_test -c tests/hmac_drbg_test.c -o $ROOTDIR/payloads/ipxe/src/bin/hmac_drbg_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ipv6_test -c tests/ipv6_test.c -o $ROOTDIR/payloads/ipxe/src/bin/ipv6_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=linebuf_test -c tests/linebuf_test.c -o $ROOTDIR/payloads/ipxe/src/bin/linebuf_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=list_test -c tests/list_test.c -o $ROOTDIR/payloads/ipxe/src/bin/list_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=math_test -c tests/math_test.c -o $ROOTDIR/payloads/ipxe/src/bin/math_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=md5_test -c tests/md5_test.c -o $ROOTDIR/payloads/ipxe/src/bin/md5_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=memcpy_test -c tests/memcpy_test.c -o $ROOTDIR/payloads/ipxe/src/bin/memcpy_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ocsp_test -c tests/ocsp_test.c -o $ROOTDIR/payloads/ipxe/src/bin/ocsp_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pixbuf_test -c tests/pixbuf_test.c -o $ROOTDIR/payloads/ipxe/src/bin/pixbuf_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=png_test -c tests/png_test.c -o $ROOTDIR/payloads/ipxe/src/bin/png_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pnm_test -c tests/pnm_test.c -o $ROOTDIR/payloads/ipxe/src/bin/pnm_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=profile_test -c tests/profile_test.c -o $ROOTDIR/payloads/ipxe/src/bin/profile_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rsa_test -c tests/rsa_test.c -o $ROOTDIR/payloads/ipxe/src/bin/rsa_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=settings_test -c tests/settings_test.c -o $ROOTDIR/payloads/ipxe/src/bin/settings_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sha1_test -c tests/sha1_test.c -o $ROOTDIR/payloads/ipxe/src/bin/sha1_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sha256_test -c tests/sha256_test.c -o $ROOTDIR/payloads/ipxe/src/bin/sha256_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=string_test -c tests/string_test.c -o $ROOTDIR/payloads/ipxe/src/bin/string_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tcpip_test -c tests/tcpip_test.c -o $ROOTDIR/payloads/ipxe/src/bin/tcpip_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=test -c tests/test.c -o $ROOTDIR/payloads/ipxe/src/bin/test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=tests -c tests/tests.c -o $ROOTDIR/payloads/ipxe/src/bin/tests.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=time_test -c tests/time_test.c -o $ROOTDIR/payloads/ipxe/src/bin/time_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=umalloc_test -c tests/umalloc_test.c -o $ROOTDIR/payloads/ipxe/src/bin/umalloc_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=uri_test -c tests/uri_test.c -o $ROOTDIR/payloads/ipxe/src/bin/uri_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vsprintf_test -c tests/vsprintf_test.c -o $ROOTDIR/payloads/ipxe/src/bin/vsprintf_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=x509_test -c tests/x509_test.c -o $ROOTDIR/payloads/ipxe/src/bin/x509_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=aes_wrap -c crypto/aes_wrap.c -o $ROOTDIR/payloads/ipxe/src/bin/aes_wrap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=arc4 -c crypto/arc4.c -o $ROOTDIR/payloads/ipxe/src/bin/arc4.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=asn1 -c crypto/asn1.c -o $ROOTDIR/payloads/ipxe/src/bin/asn1.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=axtls_aes -c crypto/axtls_aes.c -o $ROOTDIR/payloads/ipxe/src/bin/axtls_aes.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bigint -c crypto/bigint.c -o $ROOTDIR/payloads/ipxe/src/bin/bigint.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cbc -c crypto/cbc.c -o $ROOTDIR/payloads/ipxe/src/bin/cbc.o 
env CCACHE_DISABLE=1 "$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h  -DCERT_ALL="" -DOBJECT=certstore -c crypto/certstore.c -o $ROOTDIR/payloads/ipxe/src/bin/certstore.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=chap -c crypto/chap.c -o $ROOTDIR/payloads/ipxe/src/bin/chap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cms -c crypto/cms.c -o $ROOTDIR/payloads/ipxe/src/bin/cms.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=crc32 -c crypto/crc32.c -o $ROOTDIR/payloads/ipxe/src/bin/crc32.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=crypto_null -c crypto/crypto_null.c -o $ROOTDIR/payloads/ipxe/src/bin/crypto_null.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=deflate -c crypto/deflate.c -o $ROOTDIR/payloads/ipxe/src/bin/deflate.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=drbg -c crypto/drbg.c -o $ROOTDIR/payloads/ipxe/src/bin/drbg.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=entropy -c crypto/entropy.c -o $ROOTDIR/payloads/ipxe/src/bin/entropy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=hash_df -c crypto/hash_df.c -o $ROOTDIR/payloads/ipxe/src/bin/hash_df.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=hmac -c crypto/hmac.c -o $ROOTDIR/payloads/ipxe/src/bin/hmac.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=hmac_drbg -c crypto/hmac_drbg.c -o $ROOTDIR/payloads/ipxe/src/bin/hmac_drbg.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=md5 -c crypto/md5.c -o $ROOTDIR/payloads/ipxe/src/bin/md5.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=null_entropy -c crypto/null_entropy.c -o $ROOTDIR/payloads/ipxe/src/bin/null_entropy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ocsp -c crypto/ocsp.c -o $ROOTDIR/payloads/ipxe/src/bin/ocsp.o 
env CCACHE_DISABLE=1 "$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=privkey -c crypto/privkey.c -o $ROOTDIR/payloads/ipxe/src/bin/privkey.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=random_nz -c crypto/random_nz.c -o $ROOTDIR/payloads/ipxe/src/bin/random_nz.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rbg -c crypto/rbg.c -o $ROOTDIR/payloads/ipxe/src/bin/rbg.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rootcert -c crypto/rootcert.c -o $ROOTDIR/payloads/ipxe/src/bin/rootcert.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rsa -c crypto/rsa.c -o $ROOTDIR/payloads/ipxe/src/bin/rsa.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sha1 -c crypto/sha1.c -o $ROOTDIR/payloads/ipxe/src/bin/sha1.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sha1extra -c crypto/sha1extra.c -o $ROOTDIR/payloads/ipxe/src/bin/sha1extra.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sha256 -c crypto/sha256.c -o $ROOTDIR/payloads/ipxe/src/bin/sha256.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=x509 -c crypto/x509.c -o $ROOTDIR/payloads/ipxe/src/bin/x509.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=aes -c crypto/axtls/aes.c -o $ROOTDIR/payloads/ipxe/src/bin/aes.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=editstring -c hci/editstring.c -o $ROOTDIR/payloads/ipxe/src/bin/editstring.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=linux_args -c hci/linux_args.c -o $ROOTDIR/payloads/ipxe/src/bin/linux_args.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=readline -c hci/readline.c -o $ROOTDIR/payloads/ipxe/src/bin/readline.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=shell -c hci/shell.c -o $ROOTDIR/payloads/ipxe/src/bin/shell.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=strerror -c hci/strerror.c -o $ROOTDIR/payloads/ipxe/src/bin/strerror.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wireless_errors -c hci/wireless_errors.c -o $ROOTDIR/payloads/ipxe/src/bin/wireless_errors.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=autoboot_cmd -c hci/commands/autoboot_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/autoboot_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=config_cmd -c hci/commands/config_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/config_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=console_cmd -c hci/commands/console_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/console_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dhcp_cmd -c hci/commands/dhcp_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/dhcp_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=digest_cmd -c hci/commands/digest_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/digest_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fcmgmt_cmd -c hci/commands/fcmgmt_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/fcmgmt_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=gdbstub_cmd -c hci/commands/gdbstub_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/gdbstub_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ifmgmt_cmd -c hci/commands/ifmgmt_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/ifmgmt_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=image_cmd -c hci/commands/image_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/image_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=image_trust_cmd -c hci/commands/image_trust_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/image_trust_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ipstat_cmd -c hci/commands/ipstat_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/ipstat_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=iwmgmt_cmd -c hci/commands/iwmgmt_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/iwmgmt_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=login_cmd -c hci/commands/login_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/login_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=lotest_cmd -c hci/commands/lotest_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/lotest_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=menu_cmd -c hci/commands/menu_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/menu_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=neighbour_cmd -c hci/commands/neighbour_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/neighbour_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nslookup_cmd -c hci/commands/nslookup_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/nslookup_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nvo_cmd -c hci/commands/nvo_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/nvo_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=param_cmd -c hci/commands/param_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/param_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pci_cmd -c hci/commands/pci_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/pci_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ping_cmd -c hci/commands/ping_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/ping_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=poweroff_cmd -c hci/commands/poweroff_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/poweroff_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=profstat_cmd -c hci/commands/profstat_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/profstat_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=reboot_cmd -c hci/commands/reboot_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/reboot_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=route_cmd -c hci/commands/route_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/route_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sanboot_cmd -c hci/commands/sanboot_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/sanboot_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sync_cmd -c hci/commands/sync_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/sync_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=time_cmd -c hci/commands/time_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/time_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vlan_cmd -c hci/commands/vlan_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/vlan_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=login_ui -c hci/tui/login_ui.c -o $ROOTDIR/payloads/ipxe/src/bin/login_ui.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=menu_ui -c hci/tui/menu_ui.c -o $ROOTDIR/payloads/ipxe/src/bin/menu_ui.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=settings_ui -c hci/tui/settings_ui.c -o $ROOTDIR/payloads/ipxe/src/bin/settings_ui.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=alert -c hci/mucurses/alert.c -o $ROOTDIR/payloads/ipxe/src/bin/alert.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ansi_screen -c hci/mucurses/ansi_screen.c -o $ROOTDIR/payloads/ipxe/src/bin/ansi_screen.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=clear -c hci/mucurses/clear.c -o $ROOTDIR/payloads/ipxe/src/bin/clear.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=colour -c hci/mucurses/colour.c -o $ROOTDIR/payloads/ipxe/src/bin/colour.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=edging -c hci/mucurses/edging.c -o $ROOTDIR/payloads/ipxe/src/bin/edging.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=kb -c hci/mucurses/kb.c -o $ROOTDIR/payloads/ipxe/src/bin/kb.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=mucurses -c hci/mucurses/mucurses.c -o $ROOTDIR/payloads/ipxe/src/bin/mucurses.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=print -c hci/mucurses/print.c -o $ROOTDIR/payloads/ipxe/src/bin/print.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=print_nadv -c hci/mucurses/print_nadv.c -o $ROOTDIR/payloads/ipxe/src/bin/print_nadv.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=slk -c hci/mucurses/slk.c -o $ROOTDIR/payloads/ipxe/src/bin/slk.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=winattrs -c hci/mucurses/winattrs.c -o $ROOTDIR/payloads/ipxe/src/bin/winattrs.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=windows -c hci/mucurses/windows.c -o $ROOTDIR/payloads/ipxe/src/bin/windows.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=wininit -c hci/mucurses/wininit.c -o $ROOTDIR/payloads/ipxe/src/bin/wininit.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=editbox -c hci/mucurses/widgets/editbox.c -o $ROOTDIR/payloads/ipxe/src/bin/editbox.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_al -c hci/keymap/keymap_al.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_al.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_az -c hci/keymap/keymap_az.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_az.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_bg -c hci/keymap/keymap_bg.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_bg.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_by -c hci/keymap/keymap_by.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_by.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_cf -c hci/keymap/keymap_cf.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_cf.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_cz -c hci/keymap/keymap_cz.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_cz.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_de -c hci/keymap/keymap_de.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_de.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_dk -c hci/keymap/keymap_dk.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_dk.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_es -c hci/keymap/keymap_es.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_es.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_et -c hci/keymap/keymap_et.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_et.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_fi -c hci/keymap/keymap_fi.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_fi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_fr -c hci/keymap/keymap_fr.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_fr.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_gr -c hci/keymap/keymap_gr.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_gr.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_hu -c hci/keymap/keymap_hu.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_hu.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_il -c hci/keymap/keymap_il.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_il.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_it -c hci/keymap/keymap_it.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_it.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_lt -c hci/keymap/keymap_lt.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_lt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_mk -c hci/keymap/keymap_mk.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_mk.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_mt -c hci/keymap/keymap_mt.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_mt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_nl -c hci/keymap/keymap_nl.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_nl.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_no -c hci/keymap/keymap_no.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_no.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_no_latin1 -c hci/keymap/keymap_no-latin1.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_no-latin1.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_pl -c hci/keymap/keymap_pl.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_pl.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_pt -c hci/keymap/keymap_pt.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_pt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_ro -c hci/keymap/keymap_ro.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_ro.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_ru -c hci/keymap/keymap_ru.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_ru.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_sg -c hci/keymap/keymap_sg.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_sg.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_sr -c hci/keymap/keymap_sr.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_sr.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_th -c hci/keymap/keymap_th.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_th.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_ua -c hci/keymap/keymap_ua.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_ua.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_uk -c hci/keymap/keymap_uk.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_uk.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_us -c hci/keymap/keymap_us.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_us.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=keymap_wo -c hci/keymap/keymap_wo.c -o $ROOTDIR/payloads/ipxe/src/bin/keymap_wo.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=autoboot -c usr/autoboot.c -o $ROOTDIR/payloads/ipxe/src/bin/autoboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dhcpmgmt -c usr/dhcpmgmt.c -o $ROOTDIR/payloads/ipxe/src/bin/dhcpmgmt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fcmgmt -c usr/fcmgmt.c -o $ROOTDIR/payloads/ipxe/src/bin/fcmgmt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ifmgmt -c usr/ifmgmt.c -o $ROOTDIR/payloads/ipxe/src/bin/ifmgmt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=imgmgmt -c usr/imgmgmt.c -o $ROOTDIR/payloads/ipxe/src/bin/imgmgmt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=imgtrust -c usr/imgtrust.c -o $ROOTDIR/payloads/ipxe/src/bin/imgtrust.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=ipstat -c usr/ipstat.c -o $ROOTDIR/payloads/ipxe/src/bin/ipstat.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=iwmgmt -c usr/iwmgmt.c -o $ROOTDIR/payloads/ipxe/src/bin/iwmgmt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=lotest -c usr/lotest.c -o $ROOTDIR/payloads/ipxe/src/bin/lotest.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=neighmgmt -c usr/neighmgmt.c -o $ROOTDIR/payloads/ipxe/src/bin/neighmgmt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nslookup -c usr/nslookup.c -o $ROOTDIR/payloads/ipxe/src/bin/nslookup.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pingmgmt -c usr/pingmgmt.c -o $ROOTDIR/payloads/ipxe/src/bin/pingmgmt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=profstat -c usr/profstat.c -o $ROOTDIR/payloads/ipxe/src/bin/profstat.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=prompt -c usr/prompt.c -o $ROOTDIR/payloads/ipxe/src/bin/prompt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxemenu -c usr/pxemenu.c -o $ROOTDIR/payloads/ipxe/src/bin/pxemenu.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=route -c usr/route.c -o $ROOTDIR/payloads/ipxe/src/bin/route.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=route_ipv4 -c usr/route_ipv4.c -o $ROOTDIR/payloads/ipxe/src/bin/route_ipv4.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=route_ipv6 -c usr/route_ipv6.c -o $ROOTDIR/payloads/ipxe/src/bin/route_ipv6.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sync -c usr/sync.c -o $ROOTDIR/payloads/ipxe/src/bin/sync.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=config -c config/config.c -o $ROOTDIR/payloads/ipxe/src/bin/config.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=config_ethernet -c config/config_ethernet.c -o $ROOTDIR/payloads/ipxe/src/bin/config_ethernet.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=config_fc -c config/config_fc.c -o $ROOTDIR/payloads/ipxe/src/bin/config_fc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=config_infiniband -c config/config_infiniband.c -o $ROOTDIR/payloads/ipxe/src/bin/config_infiniband.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=config_net80211 -c config/config_net80211.c -o $ROOTDIR/payloads/ipxe/src/bin/config_net80211.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=config_romprefix -c config/config_romprefix.c -o $ROOTDIR/payloads/ipxe/src/bin/config_romprefix.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=config_route -c config/config_route.c -o $ROOTDIR/payloads/ipxe/src/bin/config_route.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=basemem_packet -c arch/i386/core/basemem_packet.c -o $ROOTDIR/payloads/ipxe/src/bin/basemem_packet.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cachedhcp -c arch/i386/core/cachedhcp.c -o $ROOTDIR/payloads/ipxe/src/bin/cachedhcp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=dumpregs -c arch/i386/core/dumpregs.c -o $ROOTDIR/payloads/ipxe/src/bin/dumpregs.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=gdbmach -c arch/i386/core/gdbmach.c -o $ROOTDIR/payloads/ipxe/src/bin/gdbmach.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nulltrap -c arch/i386/core/nulltrap.c -o $ROOTDIR/payloads/ipxe/src/bin/nulltrap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pci_autoboot -c arch/i386/core/pci_autoboot.c -o $ROOTDIR/payloads/ipxe/src/bin/pci_autoboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pic8259 -c arch/i386/core/pic8259.c -o $ROOTDIR/payloads/ipxe/src/bin/pic8259.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rdtsc_timer -c arch/i386/core/rdtsc_timer.c -o $ROOTDIR/payloads/ipxe/src/bin/rdtsc_timer.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=relocate -c arch/i386/core/relocate.c -o $ROOTDIR/payloads/ipxe/src/bin/relocate.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=runtime -c arch/i386/core/runtime.c -o $ROOTDIR/payloads/ipxe/src/bin/runtime.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=timer2 -c arch/i386/core/timer2.c -o $ROOTDIR/payloads/ipxe/src/bin/timer2.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=video_subr -c arch/i386/core/video_subr.c -o $ROOTDIR/payloads/ipxe/src/bin/video_subr.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=librm_mgmt -c arch/i386/transitions/librm_mgmt.c -o $ROOTDIR/payloads/ipxe/src/bin/librm_mgmt.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=librm_test -c arch/i386/transitions/librm_test.c -o $ROOTDIR/payloads/ipxe/src/bin/librm_test.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=basemem -c arch/i386/firmware/pcbios/basemem.c -o $ROOTDIR/payloads/ipxe/src/bin/basemem.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bios_console -c arch/i386/firmware/pcbios/bios_console.c -o $ROOTDIR/payloads/ipxe/src/bin/bios_console.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=fakee820 -c arch/i386/firmware/pcbios/fakee820.c -o $ROOTDIR/payloads/ipxe/src/bin/fakee820.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=hidemem -c arch/i386/firmware/pcbios/hidemem.c -o $ROOTDIR/payloads/ipxe/src/bin/hidemem.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=memmap -c arch/i386/firmware/pcbios/memmap.c -o $ROOTDIR/payloads/ipxe/src/bin/memmap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pnpbios -c arch/i386/firmware/pcbios/pnpbios.c -o $ROOTDIR/payloads/ipxe/src/bin/pnpbios.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bootsector -c arch/i386/image/bootsector.c -o $ROOTDIR/payloads/ipxe/src/bin/bootsector.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bzimage -c arch/i386/image/bzimage.c -o $ROOTDIR/payloads/ipxe/src/bin/bzimage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=com32 -c arch/i386/image/com32.c -o $ROOTDIR/payloads/ipxe/src/bin/com32.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=comboot -c arch/i386/image/comboot.c -o $ROOTDIR/payloads/ipxe/src/bin/comboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=elfboot -c arch/i386/image/elfboot.c -o $ROOTDIR/payloads/ipxe/src/bin/elfboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=initrd -c arch/i386/image/initrd.c -o $ROOTDIR/payloads/ipxe/src/bin/initrd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=multiboot -c arch/i386/image/multiboot.c -o $ROOTDIR/payloads/ipxe/src/bin/multiboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=nbi -c arch/i386/image/nbi.c -o $ROOTDIR/payloads/ipxe/src/bin/nbi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_image -c arch/i386/image/pxe_image.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_image.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=sdi -c arch/i386/image/sdi.c -o $ROOTDIR/payloads/ipxe/src/bin/sdi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=apm -c arch/i386/interface/pcbios/apm.c -o $ROOTDIR/payloads/ipxe/src/bin/apm.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=biosint -c arch/i386/interface/pcbios/biosint.c -o $ROOTDIR/payloads/ipxe/src/bin/biosint.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bios_nap -c arch/i386/interface/pcbios/bios_nap.c -o $ROOTDIR/payloads/ipxe/src/bin/bios_nap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bios_reboot -c arch/i386/interface/pcbios/bios_reboot.c -o $ROOTDIR/payloads/ipxe/src/bin/bios_reboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bios_smbios -c arch/i386/interface/pcbios/bios_smbios.c -o $ROOTDIR/payloads/ipxe/src/bin/bios_smbios.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=bios_timer -c arch/i386/interface/pcbios/bios_timer.c -o $ROOTDIR/payloads/ipxe/src/bin/bios_timer.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=int13 -c arch/i386/interface/pcbios/int13.c -o $ROOTDIR/payloads/ipxe/src/bin/int13.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=memtop_umalloc -c arch/i386/interface/pcbios/memtop_umalloc.c -o $ROOTDIR/payloads/ipxe/src/bin/memtop_umalloc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pcibios -c arch/i386/interface/pcbios/pcibios.c -o $ROOTDIR/payloads/ipxe/src/bin/pcibios.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtc_entropy -c arch/i386/interface/pcbios/rtc_entropy.c -o $ROOTDIR/payloads/ipxe/src/bin/rtc_entropy.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=rtc_time -c arch/i386/interface/pcbios/rtc_time.c -o $ROOTDIR/payloads/ipxe/src/bin/rtc_time.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vesafb -c arch/i386/interface/pcbios/vesafb.c -o $ROOTDIR/payloads/ipxe/src/bin/vesafb.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_call -c arch/i386/interface/pxe/pxe_call.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_call.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_exit_hook -c arch/i386/interface/pxe/pxe_exit_hook.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_exit_hook.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_file -c arch/i386/interface/pxe/pxe_file.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_file.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_loader -c arch/i386/interface/pxe/pxe_loader.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_loader.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_preboot -c arch/i386/interface/pxe/pxe_preboot.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_preboot.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_tftp -c arch/i386/interface/pxe/pxe_tftp.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_tftp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_udp -c arch/i386/interface/pxe/pxe_udp.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_udp.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_undi -c arch/i386/interface/pxe/pxe_undi.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_undi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxeparent -c arch/i386/interface/pxeparent/pxeparent.c -o $ROOTDIR/payloads/ipxe/src/bin/pxeparent.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=com32_call -c arch/i386/interface/syslinux/com32_call.c -o $ROOTDIR/payloads/ipxe/src/bin/com32_call.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=comboot_call -c arch/i386/interface/syslinux/comboot_call.c -o $ROOTDIR/payloads/ipxe/src/bin/comboot_call.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=comboot_resolv -c arch/i386/interface/syslinux/comboot_resolv.c -o $ROOTDIR/payloads/ipxe/src/bin/comboot_resolv.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=guestinfo -c arch/i386/interface/vmware/guestinfo.c -o $ROOTDIR/payloads/ipxe/src/bin/guestinfo.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=guestrpc -c arch/i386/interface/vmware/guestrpc.c -o $ROOTDIR/payloads/ipxe/src/bin/guestrpc.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vmconsole -c arch/i386/interface/vmware/vmconsole.c -o $ROOTDIR/payloads/ipxe/src/bin/vmconsole.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=vmware -c arch/i386/interface/vmware/vmware.c -o $ROOTDIR/payloads/ipxe/src/bin/vmware.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pxe_cmd -c arch/i386/hci/commands/pxe_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/pxe_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cpuid -c arch/x86/core/cpuid.c -o $ROOTDIR/payloads/ipxe/src/bin/cpuid.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cpuid_settings -c arch/x86/core/cpuid_settings.c -o $ROOTDIR/payloads/ipxe/src/bin/cpuid_settings.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=debugcon -c arch/x86/core/debugcon.c -o $ROOTDIR/payloads/ipxe/src/bin/debugcon.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=pcidirect -c arch/x86/core/pcidirect.c -o $ROOTDIR/payloads/ipxe/src/bin/pcidirect.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=x86_bigint -c arch/x86/core/x86_bigint.c -o $ROOTDIR/payloads/ipxe/src/bin/x86_bigint.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=x86_io -c arch/x86/core/x86_io.c -o $ROOTDIR/payloads/ipxe/src/bin/x86_io.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=x86_string -c arch/x86/core/x86_string.c -o $ROOTDIR/payloads/ipxe/src/bin/x86_string.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=x86_tcpip -c arch/x86/core/x86_tcpip.c -o $ROOTDIR/payloads/ipxe/src/bin/x86_tcpip.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efix86_nap -c arch/x86/interface/efi/efix86_nap.c -o $ROOTDIR/payloads/ipxe/src/bin/efix86_nap.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efidrvprefix -c arch/x86/prefix/efidrvprefix.c -o $ROOTDIR/payloads/ipxe/src/bin/efidrvprefix.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=efiprefix -c arch/x86/prefix/efiprefix.c -o $ROOTDIR/payloads/ipxe/src/bin/efiprefix.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=cpuid_cmd -c arch/x86/hci/commands/cpuid_cmd.c -o $ROOTDIR/payloads/ipxe/src/bin/cpuid_cmd.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=undi -c arch/i386/drivers/net/undi.c -o $ROOTDIR/payloads/ipxe/src/bin/undi.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=undiload -c arch/i386/drivers/net/undiload.c -o $ROOTDIR/payloads/ipxe/src/bin/undiload.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=undinet -c arch/i386/drivers/net/undinet.c -o $ROOTDIR/payloads/ipxe/src/bin/undinet.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=undionly -c arch/i386/drivers/net/undionly.c -o $ROOTDIR/payloads/ipxe/src/bin/undionly.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=undipreload -c arch/i386/drivers/net/undipreload.c -o $ROOTDIR/payloads/ipxe/src/bin/undipreload.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h   -DOBJECT=undirom -c arch/i386/drivers/net/undirom.c -o $ROOTDIR/payloads/ipxe/src/bin/undirom.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=gdbstub_test tests/gdbstub_test.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/gdbstub_test.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=gdbidt arch/i386/core/gdbidt.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/gdbidt.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=patch_cf arch/i386/core/patch_cf.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/patch_cf.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=setjmp arch/i386/core/setjmp.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/setjmp.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=stack16 arch/i386/core/stack16.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/stack16.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=stack arch/i386/core/stack.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/stack.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=virtaddr arch/i386/core/virtaddr.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/virtaddr.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=liba20 arch/i386/transitions/liba20.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/liba20.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=libkir arch/i386/transitions/libkir.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/libkir.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=libpm arch/i386/transitions/libpm.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/libpm.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=librm arch/i386/transitions/librm.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/librm.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=bootpart arch/i386/prefix/bootpart.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/bootpart.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=dskprefix arch/i386/prefix/dskprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/dskprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=exeprefix arch/i386/prefix/exeprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/exeprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=hdprefix arch/i386/prefix/hdprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/hdprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=kkkpxeprefix arch/i386/prefix/kkkpxeprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/kkkpxeprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=kkpxeprefix arch/i386/prefix/kkpxeprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/kkpxeprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=kpxeprefix arch/i386/prefix/kpxeprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/kpxeprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=libprefix arch/i386/prefix/libprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/libprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY -DVERSION="\"1.0.0+\"" -DOBJECT=lkrnprefix arch/i386/prefix/lkrnprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/lkrnprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=mbr arch/i386/prefix/mbr.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/mbr.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=mromprefix arch/i386/prefix/mromprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/mromprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=nbiprefix arch/i386/prefix/nbiprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/nbiprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=nullprefix arch/i386/prefix/nullprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/nullprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=pxeprefix arch/i386/prefix/pxeprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/pxeprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=romprefix arch/i386/prefix/romprefix.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/romprefix.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=undiloader arch/i386/prefix/undiloader.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/undiloader.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=unnrv2b16 arch/i386/prefix/unnrv2b16.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/unnrv2b16.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=unnrv2b arch/i386/prefix/unnrv2b.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/unnrv2b.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=usbdisk arch/i386/prefix/usbdisk.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/usbdisk.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=e820mangler arch/i386/firmware/pcbios/e820mangler.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/e820mangler.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=pxe_entry arch/i386/interface/pxe/pxe_entry.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/pxe_entry.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=com32_wrapper arch/i386/interface/syslinux/com32_wrapper.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/com32_wrapper.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -E  -DARCH=i386 -DPLATFORM=pcbios -march=i386 -fomit-frame-pointer -fstrength-reduce -falign-jumps=1 -falign-loops=1 -falign-functions=1 -mpreferred-stack-boundary=2 -mregparm=3 -mrtd -freg-struct-return -m32 -fshort-wchar -Ui386 -Ulinux -DNVALGRIND -Iinclude -I. -Iarch/x86/include -Iarch/i386/include -Iarch/i386/include/pcbios -Os -g -ffreestanding -Wall -W -Wformat-nonliteral  -fno-stack-protector  -fno-dwarf2-cfi-asm -fno-exceptions  -fno-unwind-tables -fno-asynchronous-unwind-tables -Wno-address  -Werror -ffunction-sections -fdata-sections -include include/compiler.h -DASSEMBLY  -DOBJECT=undiisr arch/i386/drivers/net/undiisr.S | "$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  --32  --divide  --fatal-warnings -o $ROOTDIR/payloads/ipxe/src/bin/undiisr.o
rm -f $ROOTDIR/payloads/ipxe/src/bin/blib.a
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar r $ROOTDIR/payloads/ipxe/src/bin/blib.a  $ROOTDIR/payloads/ipxe/src/bin/__divdi3.o $ROOTDIR/payloads/ipxe/src/bin/icc.o $ROOTDIR/payloads/ipxe/src/bin/memcpy.o $ROOTDIR/payloads/ipxe/src/bin/__moddi3.o $ROOTDIR/payloads/ipxe/src/bin/__udivdi3.o $ROOTDIR/payloads/ipxe/src/bin/__udivmoddi4.o $ROOTDIR/payloads/ipxe/src/bin/__umoddi3.o $ROOTDIR/payloads/ipxe/src/bin/acpi.o $ROOTDIR/payloads/ipxe/src/bin/ansicol.o $ROOTDIR/payloads/ipxe/src/bin/ansicoldef.o $ROOTDIR/payloads/ipxe/src/bin/ansiesc.o $ROOTDIR/payloads/ipxe/src/bin/asprintf.o $ROOTDIR/payloads/ipxe/src/bin/assert.o $ROOTDIR/payloads/ipxe/src/bin/base16.o $ROOTDIR/payloads/ipxe/src/bin/base64.o $ROOTDIR/payloads/ipxe/src/bin/basename.o $ROOTDIR/payloads/ipxe/src/bin/bitmap.o $ROOTDIR/payloads/ipxe/src/bin/blockdev.o $ROOTDIR/payloads/ipxe/src/bin/console.o $ROOTDIR/payloads/ipxe/src/bin/cpio.o $ROOTDIR/payloads/ipxe/src/bin/ctype.o $ROOTDIR/payloads/ipxe/src/bin/cwuri.o $ROOTDIR/payloads/ipxe/src/bin/debug.o $ROOTDIR/payloads/ipxe/src/bin/debug_md5.o $ROOTDIR/payloads/ipxe/src/bin/device.o $ROOTDIR/payloads/ipxe/src/bin/downloader.o $ROOTDIR/payloads/ipxe/src/bin/edd.o $ROOTDIR/payloads/ipxe/src/bin/errno.o $ROOTDIR/payloads/ipxe/src/bin/exec.o $ROOTDIR/payloads/ipxe/src/bin/fbcon.o $ROOTDIR/payloads/ipxe/src/bin/fnrec.o $ROOTDIR/payloads/ipxe/src/bin/gdbserial.o $ROOTDIR/payloads/ipxe/src/bin/gdbstub.o $ROOTDIR/payloads/ipxe/src/bin/gdbudp.o $ROOTDIR/payloads/ipxe/src/bin/getkey.o $ROOTDIR/payloads/ipxe/src/bin/getopt.o $ROOTDIR/payloads/ipxe/src/bin/hw.o $ROOTDIR/payloads/ipxe/src/bin/i82365.o $ROOTDIR/payloads/ipxe/src/bin/image.o $ROOTDIR/payloads/ipxe/src/bin/init.o $ROOTDIR/payloads/ipxe/src/bin/interface.o $ROOTDIR/payloads/ipxe/src/bin/iobuf.o $ROOTDIR/payloads/ipxe/src/bin/isqrt.o $ROOTDIR/payloads/ipxe/src/bin/job.o $ROOTDIR/payloads/ipxe/src/bin/linebuf.o $ROOTDIR/payloads/ipxe/src/bin/lineconsole.o $ROOTDIR/payloads/ipxe/src/bin/list.o $ROOTDIR/payloads/ipxe/src/bin/log.o $ROOTDIR/payloads/ipxe/src/bin/main.o $ROOTDIR/payloads/ipxe/src/bin/malloc.o $ROOTDIR/payloads/ipxe/src/bin/memblock.o $ROOTDIR/payloads/ipxe/src/bin/memmap_settings.o $ROOTDIR/payloads/ipxe/src/bin/menu.o $ROOTDIR/payloads/ipxe/src/bin/misc.o $ROOTDIR/payloads/ipxe/src/bin/monojob.o $ROOTDIR/payloads/ipxe/src/bin/null_nap.o $ROOTDIR/payloads/ipxe/src/bin/null_reboot.o $ROOTDIR/payloads/ipxe/src/bin/null_sanboot.o $ROOTDIR/payloads/ipxe/src/bin/null_time.o $ROOTDIR/payloads/ipxe/src/bin/nvo.o $ROOTDIR/payloads/ipxe/src/bin/open.o $ROOTDIR/payloads/ipxe/src/bin/params.o $ROOTDIR/payloads/ipxe/src/bin/parseopt.o $ROOTDIR/payloads/ipxe/src/bin/pc_kbd.o $ROOTDIR/payloads/ipxe/src/bin/pcmcia.o $ROOTDIR/payloads/ipxe/src/bin/pending.o $ROOTDIR/payloads/ipxe/src/bin/pinger.o $ROOTDIR/payloads/ipxe/src/bin/pixbuf.o $ROOTDIR/payloads/ipxe/src/bin/posix_io.o $ROOTDIR/payloads/ipxe/src/bin/process.o $ROOTDIR/payloads/ipxe/src/bin/profile.o $ROOTDIR/payloads/ipxe/src/bin/random.o $ROOTDIR/payloads/ipxe/src/bin/refcnt.o $ROOTDIR/payloads/ipxe/src/bin/resolv.o $ROOTDIR/payloads/ipxe/src/bin/serial.o $ROOTDIR/payloads/ipxe/src/bin/serial_console.o $ROOTDIR/payloads/ipxe/src/bin/settings.o $ROOTDIR/payloads/ipxe/src/bin/string.o $ROOTDIR/payloads/ipxe/src/bin/stringextra.o $ROOTDIR/payloads/ipxe/src/bin/strtoull.o $ROOTDIR/payloads/ipxe/src/bin/time.o $ROOTDIR/payloads/ipxe/src/bin/timer.o $ROOTDIR/payloads/ipxe/src/bin/uri.o $ROOTDIR/payloads/ipxe/src/bin/uuid.o $ROOTDIR/payloads/ipxe/src/bin/version.o $ROOTDIR/payloads/ipxe/src/bin/vsprintf.o $ROOTDIR/payloads/ipxe/src/bin/wchar.o $ROOTDIR/payloads/ipxe/src/bin/xferbuf.o $ROOTDIR/payloads/ipxe/src/bin/xfer.o $ROOTDIR/payloads/ipxe/src/bin/aoe.o $ROOTDIR/payloads/ipxe/src/bin/arp.o $ROOTDIR/payloads/ipxe/src/bin/dhcpopts.o $ROOTDIR/payloads/ipxe/src/bin/dhcppkt.o $ROOTDIR/payloads/ipxe/src/bin/eapol.o $ROOTDIR/payloads/ipxe/src/bin/ethernet.o $ROOTDIR/payloads/ipxe/src/bin/eth_slow.o $ROOTDIR/payloads/ipxe/src/bin/fakedhcp.o $ROOTDIR/payloads/ipxe/src/bin/fc.o $ROOTDIR/payloads/ipxe/src/bin/fcels.o $ROOTDIR/payloads/ipxe/src/bin/fcns.o $ROOTDIR/payloads/ipxe/src/bin/fcoe.o $ROOTDIR/payloads/ipxe/src/bin/fcp.o $ROOTDIR/payloads/ipxe/src/bin/fragment.o $ROOTDIR/payloads/ipxe/src/bin/icmp.o $ROOTDIR/payloads/ipxe/src/bin/icmpv4.o $ROOTDIR/payloads/ipxe/src/bin/icmpv6.o $ROOTDIR/payloads/ipxe/src/bin/infiniband.o $ROOTDIR/payloads/ipxe/src/bin/iobpad.o $ROOTDIR/payloads/ipxe/src/bin/ipv4.o $ROOTDIR/payloads/ipxe/src/bin/ipv6.o $ROOTDIR/payloads/ipxe/src/bin/ndp.o $ROOTDIR/payloads/ipxe/src/bin/neighbour.o $ROOTDIR/payloads/ipxe/src/bin/netdevice.o $ROOTDIR/payloads/ipxe/src/bin/netdev_settings.o $ROOTDIR/payloads/ipxe/src/bin/nullnet.o $ROOTDIR/payloads/ipxe/src/bin/ping.o $ROOTDIR/payloads/ipxe/src/bin/rarp.o $ROOTDIR/payloads/ipxe/src/bin/retry.o $ROOTDIR/payloads/ipxe/src/bin/socket.o $ROOTDIR/payloads/ipxe/src/bin/tcp.o $ROOTDIR/payloads/ipxe/src/bin/tcpip.o $ROOTDIR/payloads/ipxe/src/bin/tls.o $ROOTDIR/payloads/ipxe/src/bin/udp.o $ROOTDIR/payloads/ipxe/src/bin/validator.o $ROOTDIR/payloads/ipxe/src/bin/vlan.o $ROOTDIR/payloads/ipxe/src/bin/mount.o $ROOTDIR/payloads/ipxe/src/bin/nfs.o $ROOTDIR/payloads/ipxe/src/bin/nfs_open.o $ROOTDIR/payloads/ipxe/src/bin/nfs_uri.o $ROOTDIR/payloads/ipxe/src/bin/oncrpc_iob.o $ROOTDIR/payloads/ipxe/src/bin/portmap.o $ROOTDIR/payloads/ipxe/src/bin/ftp.o $ROOTDIR/payloads/ipxe/src/bin/http.o $ROOTDIR/payloads/ipxe/src/bin/httpcore.o $ROOTDIR/payloads/ipxe/src/bin/https.o $ROOTDIR/payloads/ipxe/src/bin/iscsi.o $ROOTDIR/payloads/ipxe/src/bin/oncrpc.o $ROOTDIR/payloads/ipxe/src/bin/syslogs.o $ROOTDIR/payloads/ipxe/src/bin/dhcp.o $ROOTDIR/payloads/ipxe/src/bin/dhcpv6.o $ROOTDIR/payloads/ipxe/src/bin/dns.o $ROOTDIR/payloads/ipxe/src/bin/slam.o $ROOTDIR/payloads/ipxe/src/bin/syslog.o $ROOTDIR/payloads/ipxe/src/bin/tftp.o $ROOTDIR/payloads/ipxe/src/bin/ib_cm.o $ROOTDIR/payloads/ipxe/src/bin/ib_cmrc.o $ROOTDIR/payloads/ipxe/src/bin/ib_mcast.o $ROOTDIR/payloads/ipxe/src/bin/ib_mi.o $ROOTDIR/payloads/ipxe/src/bin/ib_packet.o $ROOTDIR/payloads/ipxe/src/bin/ib_pathrec.o $ROOTDIR/payloads/ipxe/src/bin/ib_sma.o $ROOTDIR/payloads/ipxe/src/bin/ib_smc.o $ROOTDIR/payloads/ipxe/src/bin/ib_srp.o $ROOTDIR/payloads/ipxe/src/bin/net80211.o $ROOTDIR/payloads/ipxe/src/bin/rc80211.o $ROOTDIR/payloads/ipxe/src/bin/sec80211.o $ROOTDIR/payloads/ipxe/src/bin/wep.o $ROOTDIR/payloads/ipxe/src/bin/wpa.o $ROOTDIR/payloads/ipxe/src/bin/wpa_ccmp.o $ROOTDIR/payloads/ipxe/src/bin/wpa_psk.o $ROOTDIR/payloads/ipxe/src/bin/wpa_tkip.o $ROOTDIR/payloads/ipxe/src/bin/efi_image.o $ROOTDIR/payloads/ipxe/src/bin/elf.o $ROOTDIR/payloads/ipxe/src/bin/embedded.o $ROOTDIR/payloads/ipxe/src/bin/png.o $ROOTDIR/payloads/ipxe/src/bin/pnm.o $ROOTDIR/payloads/ipxe/src/bin/script.o $ROOTDIR/payloads/ipxe/src/bin/segment.o $ROOTDIR/payloads/ipxe/src/bin/eisa.o $ROOTDIR/payloads/ipxe/src/bin/isa.o $ROOTDIR/payloads/ipxe/src/bin/isa_ids.o $ROOTDIR/payloads/ipxe/src/bin/isapnp.o $ROOTDIR/payloads/ipxe/src/bin/mca.o $ROOTDIR/payloads/ipxe/src/bin/pcibackup.o $ROOTDIR/payloads/ipxe/src/bin/pci.o $ROOTDIR/payloads/ipxe/src/bin/pciextra.o $ROOTDIR/payloads/ipxe/src/bin/pci_settings.o $ROOTDIR/payloads/ipxe/src/bin/pcivpd.o $ROOTDIR/payloads/ipxe/src/bin/virtio-pci.o $ROOTDIR/payloads/ipxe/src/bin/virtio-ring.o $ROOTDIR/payloads/ipxe/src/bin/3c503.o $ROOTDIR/payloads/ipxe/src/bin/3c509.o $ROOTDIR/payloads/ipxe/src/bin/3c509-eisa.o $ROOTDIR/payloads/ipxe/src/bin/3c515.o $ROOTDIR/payloads/ipxe/src/bin/3c529.o $ROOTDIR/payloads/ipxe/src/bin/3c595.o $ROOTDIR/payloads/ipxe/src/bin/3c5x9.o $ROOTDIR/payloads/ipxe/src/bin/3c90x.o $ROOTDIR/payloads/ipxe/src/bin/amd8111e.o $ROOTDIR/payloads/ipxe/src/bin/atl1e.o $ROOTDIR/payloads/ipxe/src/bin/b44.o $ROOTDIR/payloads/ipxe/src/bin/bnx2.o $ROOTDIR/payloads/ipxe/src/bin/cs89x0.o $ROOTDIR/payloads/ipxe/src/bin/davicom.o $ROOTDIR/payloads/ipxe/src/bin/depca.o $ROOTDIR/payloads/ipxe/src/bin/dmfe.o $ROOTDIR/payloads/ipxe/src/bin/eepro100.o $ROOTDIR/payloads/ipxe/src/bin/eepro.o $ROOTDIR/payloads/ipxe/src/bin/epic100.o $ROOTDIR/payloads/ipxe/src/bin/etherfabric.o $ROOTDIR/payloads/ipxe/src/bin/forcedeth.o $ROOTDIR/payloads/ipxe/src/bin/intel.o $ROOTDIR/payloads/ipxe/src/bin/intelx.o $ROOTDIR/payloads/ipxe/src/bin/ipoib.o $ROOTDIR/payloads/ipxe/src/bin/jme.o $ROOTDIR/payloads/ipxe/src/bin/legacy.o $ROOTDIR/payloads/ipxe/src/bin/mii.o $ROOTDIR/payloads/ipxe/src/bin/myri10ge.o $ROOTDIR/payloads/ipxe/src/bin/myson.o $ROOTDIR/payloads/ipxe/src/bin/natsemi.o $ROOTDIR/payloads/ipxe/src/bin/ne2k_isa.o $ROOTDIR/payloads/ipxe/src/bin/ne.o $ROOTDIR/payloads/ipxe/src/bin/ns8390.o $ROOTDIR/payloads/ipxe/src/bin/pcnet32.o $ROOTDIR/payloads/ipxe/src/bin/pnic.o $ROOTDIR/payloads/ipxe/src/bin/prism2_pci.o $ROOTDIR/payloads/ipxe/src/bin/prism2_plx.o $ROOTDIR/payloads/ipxe/src/bin/realtek.o $ROOTDIR/payloads/ipxe/src/bin/rhine.o $ROOTDIR/payloads/ipxe/src/bin/sis190.o $ROOTDIR/payloads/ipxe/src/bin/sis900.o $ROOTDIR/payloads/ipxe/src/bin/skeleton.o $ROOTDIR/payloads/ipxe/src/bin/skge.o $ROOTDIR/payloads/ipxe/src/bin/sky2.o $ROOTDIR/payloads/ipxe/src/bin/smc9000.o $ROOTDIR/payloads/ipxe/src/bin/sundance.o $ROOTDIR/payloads/ipxe/src/bin/tlan.o $ROOTDIR/payloads/ipxe/src/bin/tulip.o $ROOTDIR/payloads/ipxe/src/bin/velocity.o $ROOTDIR/payloads/ipxe/src/bin/virtio-net.o $ROOTDIR/payloads/ipxe/src/bin/vmxnet3.o $ROOTDIR/payloads/ipxe/src/bin/w89c840.o $ROOTDIR/payloads/ipxe/src/bin/wd.o $ROOTDIR/payloads/ipxe/src/bin/igbvf_main.o $ROOTDIR/payloads/ipxe/src/bin/igbvf_mbx.o $ROOTDIR/payloads/ipxe/src/bin/igbvf_vf.o $ROOTDIR/payloads/ipxe/src/bin/phantom.o $ROOTDIR/payloads/ipxe/src/bin/rtl8180.o $ROOTDIR/payloads/ipxe/src/bin/rtl8180_grf5101.o $ROOTDIR/payloads/ipxe/src/bin/rtl8180_max2820.o $ROOTDIR/payloads/ipxe/src/bin/rtl8180_sa2400.o $ROOTDIR/payloads/ipxe/src/bin/rtl8185.o $ROOTDIR/payloads/ipxe/src/bin/rtl8185_rtl8225.o $ROOTDIR/payloads/ipxe/src/bin/rtl818x.o $ROOTDIR/payloads/ipxe/src/bin/ath_hw.o $ROOTDIR/payloads/ipxe/src/bin/ath_key.o $ROOTDIR/payloads/ipxe/src/bin/ath_main.o $ROOTDIR/payloads/ipxe/src/bin/ath_regd.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_attach.o $ROOTDIR/payloads/ipxe/src/bin/ath5k.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_caps.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_desc.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_dma.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_eeprom.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_gpio.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_initvals.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_pcu.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_phy.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_qcu.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_reset.o $ROOTDIR/payloads/ipxe/src/bin/ath5k_rfkill.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ani.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar5008_phy.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9002_calib.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9002_hw.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9002_mac.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9002_phy.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_calib.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_eeprom.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_hw.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_mac.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_ar9003_phy.o $ROOTDIR/payloads/ipxe/src/bin/ath9k.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_calib.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_common.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_eeprom_4k.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_eeprom_9287.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_eeprom.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_eeprom_def.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_hw.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_init.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_mac.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_main.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_recv.o $ROOTDIR/payloads/ipxe/src/bin/ath9k_xmit.o $ROOTDIR/payloads/ipxe/src/bin/vxge.o $ROOTDIR/payloads/ipxe/src/bin/vxge_config.o $ROOTDIR/payloads/ipxe/src/bin/vxge_main.o $ROOTDIR/payloads/ipxe/src/bin/vxge_traffic.o $ROOTDIR/payloads/ipxe/src/bin/snpnet.o $ROOTDIR/payloads/ipxe/src/bin/snponly.o $ROOTDIR/payloads/ipxe/src/bin/tg3.o $ROOTDIR/payloads/ipxe/src/bin/tg3_hw.o $ROOTDIR/payloads/ipxe/src/bin/tg3_phy.o $ROOTDIR/payloads/ipxe/src/bin/ata.o $ROOTDIR/payloads/ipxe/src/bin/ibft.o $ROOTDIR/payloads/ipxe/src/bin/scsi.o $ROOTDIR/payloads/ipxe/src/bin/srp.o $ROOTDIR/payloads/ipxe/src/bin/nvs.o $ROOTDIR/payloads/ipxe/src/bin/nvsvpd.o $ROOTDIR/payloads/ipxe/src/bin/spi.o $ROOTDIR/payloads/ipxe/src/bin/threewire.o $ROOTDIR/payloads/ipxe/src/bin/bitbash.o $ROOTDIR/payloads/ipxe/src/bin/i2c_bit.o $ROOTDIR/payloads/ipxe/src/bin/spi_bit.o $ROOTDIR/payloads/ipxe/src/bin/arbel.o $ROOTDIR/payloads/ipxe/src/bin/hermon.o $ROOTDIR/payloads/ipxe/src/bin/linda.o $ROOTDIR/payloads/ipxe/src/bin/linda_fw.o $ROOTDIR/payloads/ipxe/src/bin/qib7322.o $ROOTDIR/payloads/ipxe/src/bin/efi_bofm.o $ROOTDIR/payloads/ipxe/src/bin/efi_console.o $ROOTDIR/payloads/ipxe/src/bin/efi_debug.o $ROOTDIR/payloads/ipxe/src/bin/efi_download.o $ROOTDIR/payloads/ipxe/src/bin/efi_driver.o $ROOTDIR/payloads/ipxe/src/bin/efi_file.o $ROOTDIR/payloads/ipxe/src/bin/efi_hii.o $ROOTDIR/payloads/ipxe/src/bin/efi_init.o $ROOTDIR/payloads/ipxe/src/bin/efi_pci.o $ROOTDIR/payloads/ipxe/src/bin/efi_reboot.o $ROOTDIR/payloads/ipxe/src/bin/efi_smbios.o $ROOTDIR/payloads/ipxe/src/bin/efi_snp.o $ROOTDIR/payloads/ipxe/src/bin/efi_snp_hii.o $ROOTDIR/payloads/ipxe/src/bin/efi_strings.o $ROOTDIR/payloads/ipxe/src/bin/efi_timer.o $ROOTDIR/payloads/ipxe/src/bin/efi_uaccess.o $ROOTDIR/payloads/ipxe/src/bin/efi_umalloc.o $ROOTDIR/payloads/ipxe/src/bin/smbios.o $ROOTDIR/payloads/ipxe/src/bin/smbios_settings.o $ROOTDIR/payloads/ipxe/src/bin/bofm.o $ROOTDIR/payloads/ipxe/src/bin/aes_cbc_test.o $ROOTDIR/payloads/ipxe/src/bin/base16_test.o $ROOTDIR/payloads/ipxe/src/bin/base64_test.o $ROOTDIR/payloads/ipxe/src/bin/bigint_test.o $ROOTDIR/payloads/ipxe/src/bin/bofm_test.o $ROOTDIR/payloads/ipxe/src/bin/byteswap_test.o $ROOTDIR/payloads/ipxe/src/bin/cbc_test.o $ROOTDIR/payloads/ipxe/src/bin/cms_test.o $ROOTDIR/payloads/ipxe/src/bin/crc32_test.o $ROOTDIR/payloads/ipxe/src/bin/deflate_test.o $ROOTDIR/payloads/ipxe/src/bin/digest_test.o $ROOTDIR/payloads/ipxe/src/bin/dns_test.o $ROOTDIR/payloads/ipxe/src/bin/entropy_sample.o $ROOTDIR/payloads/ipxe/src/bin/hash_df_test.o $ROOTDIR/payloads/ipxe/src/bin/hmac_drbg_test.o $ROOTDIR/payloads/ipxe/src/bin/ipv6_test.o $ROOTDIR/payloads/ipxe/src/bin/linebuf_test.o $ROOTDIR/payloads/ipxe/src/bin/list_test.o $ROOTDIR/payloads/ipxe/src/bin/math_test.o $ROOTDIR/payloads/ipxe/src/bin/md5_test.o $ROOTDIR/payloads/ipxe/src/bin/memcpy_test.o $ROOTDIR/payloads/ipxe/src/bin/ocsp_test.o $ROOTDIR/payloads/ipxe/src/bin/pixbuf_test.o $ROOTDIR/payloads/ipxe/src/bin/png_test.o $ROOTDIR/payloads/ipxe/src/bin/pnm_test.o $ROOTDIR/payloads/ipxe/src/bin/profile_test.o $ROOTDIR/payloads/ipxe/src/bin/rsa_test.o $ROOTDIR/payloads/ipxe/src/bin/settings_test.o $ROOTDIR/payloads/ipxe/src/bin/sha1_test.o $ROOTDIR/payloads/ipxe/src/bin/sha256_test.o $ROOTDIR/payloads/ipxe/src/bin/string_test.o $ROOTDIR/payloads/ipxe/src/bin/tcpip_test.o $ROOTDIR/payloads/ipxe/src/bin/test.o $ROOTDIR/payloads/ipxe/src/bin/tests.o $ROOTDIR/payloads/ipxe/src/bin/time_test.o $ROOTDIR/payloads/ipxe/src/bin/umalloc_test.o $ROOTDIR/payloads/ipxe/src/bin/uri_test.o $ROOTDIR/payloads/ipxe/src/bin/vsprintf_test.o $ROOTDIR/payloads/ipxe/src/bin/x509_test.o $ROOTDIR/payloads/ipxe/src/bin/aes_wrap.o $ROOTDIR/payloads/ipxe/src/bin/arc4.o $ROOTDIR/payloads/ipxe/src/bin/asn1.o $ROOTDIR/payloads/ipxe/src/bin/axtls_aes.o $ROOTDIR/payloads/ipxe/src/bin/bigint.o $ROOTDIR/payloads/ipxe/src/bin/cbc.o $ROOTDIR/payloads/ipxe/src/bin/certstore.o $ROOTDIR/payloads/ipxe/src/bin/chap.o $ROOTDIR/payloads/ipxe/src/bin/cms.o $ROOTDIR/payloads/ipxe/src/bin/crc32.o $ROOTDIR/payloads/ipxe/src/bin/crypto_null.o $ROOTDIR/payloads/ipxe/src/bin/deflate.o $ROOTDIR/payloads/ipxe/src/bin/drbg.o $ROOTDIR/payloads/ipxe/src/bin/entropy.o $ROOTDIR/payloads/ipxe/src/bin/hash_df.o $ROOTDIR/payloads/ipxe/src/bin/hmac.o $ROOTDIR/payloads/ipxe/src/bin/hmac_drbg.o $ROOTDIR/payloads/ipxe/src/bin/md5.o $ROOTDIR/payloads/ipxe/src/bin/null_entropy.o $ROOTDIR/payloads/ipxe/src/bin/ocsp.o $ROOTDIR/payloads/ipxe/src/bin/privkey.o $ROOTDIR/payloads/ipxe/src/bin/random_nz.o $ROOTDIR/payloads/ipxe/src/bin/rbg.o $ROOTDIR/payloads/ipxe/src/bin/rootcert.o $ROOTDIR/payloads/ipxe/src/bin/rsa.o $ROOTDIR/payloads/ipxe/src/bin/sha1.o $ROOTDIR/payloads/ipxe/src/bin/sha1extra.o $ROOTDIR/payloads/ipxe/src/bin/sha256.o $ROOTDIR/payloads/ipxe/src/bin/x509.o $ROOTDIR/payloads/ipxe/src/bin/aes.o $ROOTDIR/payloads/ipxe/src/bin/editstring.o $ROOTDIR/payloads/ipxe/src/bin/linux_args.o $ROOTDIR/payloads/ipxe/src/bin/readline.o $ROOTDIR/payloads/ipxe/src/bin/shell.o $ROOTDIR/payloads/ipxe/src/bin/strerror.o $ROOTDIR/payloads/ipxe/src/bin/wireless_errors.o $ROOTDIR/payloads/ipxe/src/bin/autoboot_cmd.o $ROOTDIR/payloads/ipxe/src/bin/config_cmd.o $ROOTDIR/payloads/ipxe/src/bin/console_cmd.o $ROOTDIR/payloads/ipxe/src/bin/dhcp_cmd.o $ROOTDIR/payloads/ipxe/src/bin/digest_cmd.o $ROOTDIR/payloads/ipxe/src/bin/fcmgmt_cmd.o $ROOTDIR/payloads/ipxe/src/bin/gdbstub_cmd.o $ROOTDIR/payloads/ipxe/src/bin/ifmgmt_cmd.o $ROOTDIR/payloads/ipxe/src/bin/image_cmd.o $ROOTDIR/payloads/ipxe/src/bin/image_trust_cmd.o $ROOTDIR/payloads/ipxe/src/bin/ipstat_cmd.o $ROOTDIR/payloads/ipxe/src/bin/iwmgmt_cmd.o $ROOTDIR/payloads/ipxe/src/bin/login_cmd.o $ROOTDIR/payloads/ipxe/src/bin/lotest_cmd.o $ROOTDIR/payloads/ipxe/src/bin/menu_cmd.o $ROOTDIR/payloads/ipxe/src/bin/neighbour_cmd.o $ROOTDIR/payloads/ipxe/src/bin/nslookup_cmd.o $ROOTDIR/payloads/ipxe/src/bin/nvo_cmd.o $ROOTDIR/payloads/ipxe/src/bin/param_cmd.o $ROOTDIR/payloads/ipxe/src/bin/pci_cmd.o $ROOTDIR/payloads/ipxe/src/bin/ping_cmd.o $ROOTDIR/payloads/ipxe/src/bin/poweroff_cmd.o $ROOTDIR/payloads/ipxe/src/bin/profstat_cmd.o $ROOTDIR/payloads/ipxe/src/bin/reboot_cmd.o $ROOTDIR/payloads/ipxe/src/bin/route_cmd.o $ROOTDIR/payloads/ipxe/src/bin/sanboot_cmd.o $ROOTDIR/payloads/ipxe/src/bin/sync_cmd.o $ROOTDIR/payloads/ipxe/src/bin/time_cmd.o $ROOTDIR/payloads/ipxe/src/bin/vlan_cmd.o $ROOTDIR/payloads/ipxe/src/bin/login_ui.o $ROOTDIR/payloads/ipxe/src/bin/menu_ui.o $ROOTDIR/payloads/ipxe/src/bin/settings_ui.o $ROOTDIR/payloads/ipxe/src/bin/alert.o $ROOTDIR/payloads/ipxe/src/bin/ansi_screen.o $ROOTDIR/payloads/ipxe/src/bin/clear.o $ROOTDIR/payloads/ipxe/src/bin/colour.o $ROOTDIR/payloads/ipxe/src/bin/edging.o $ROOTDIR/payloads/ipxe/src/bin/kb.o $ROOTDIR/payloads/ipxe/src/bin/mucurses.o $ROOTDIR/payloads/ipxe/src/bin/print.o $ROOTDIR/payloads/ipxe/src/bin/print_nadv.o $ROOTDIR/payloads/ipxe/src/bin/slk.o $ROOTDIR/payloads/ipxe/src/bin/winattrs.o $ROOTDIR/payloads/ipxe/src/bin/windows.o $ROOTDIR/payloads/ipxe/src/bin/wininit.o $ROOTDIR/payloads/ipxe/src/bin/editbox.o $ROOTDIR/payloads/ipxe/src/bin/keymap_al.o $ROOTDIR/payloads/ipxe/src/bin/keymap_az.o $ROOTDIR/payloads/ipxe/src/bin/keymap_bg.o $ROOTDIR/payloads/ipxe/src/bin/keymap_by.o $ROOTDIR/payloads/ipxe/src/bin/keymap_cf.o $ROOTDIR/payloads/ipxe/src/bin/keymap_cz.o $ROOTDIR/payloads/ipxe/src/bin/keymap_de.o $ROOTDIR/payloads/ipxe/src/bin/keymap_dk.o $ROOTDIR/payloads/ipxe/src/bin/keymap_es.o $ROOTDIR/payloads/ipxe/src/bin/keymap_et.o $ROOTDIR/payloads/ipxe/src/bin/keymap_fi.o $ROOTDIR/payloads/ipxe/src/bin/keymap_fr.o $ROOTDIR/payloads/ipxe/src/bin/keymap_gr.o $ROOTDIR/payloads/ipxe/src/bin/keymap_hu.o $ROOTDIR/payloads/ipxe/src/bin/keymap_il.o $ROOTDIR/payloads/ipxe/src/bin/keymap_it.o $ROOTDIR/payloads/ipxe/src/bin/keymap_lt.o $ROOTDIR/payloads/ipxe/src/bin/keymap_mk.o $ROOTDIR/payloads/ipxe/src/bin/keymap_mt.o $ROOTDIR/payloads/ipxe/src/bin/keymap_nl.o $ROOTDIR/payloads/ipxe/src/bin/keymap_no.o $ROOTDIR/payloads/ipxe/src/bin/keymap_no-latin1.o $ROOTDIR/payloads/ipxe/src/bin/keymap_pl.o $ROOTDIR/payloads/ipxe/src/bin/keymap_pt.o $ROOTDIR/payloads/ipxe/src/bin/keymap_ro.o $ROOTDIR/payloads/ipxe/src/bin/keymap_ru.o $ROOTDIR/payloads/ipxe/src/bin/keymap_sg.o $ROOTDIR/payloads/ipxe/src/bin/keymap_sr.o $ROOTDIR/payloads/ipxe/src/bin/keymap_th.o $ROOTDIR/payloads/ipxe/src/bin/keymap_ua.o $ROOTDIR/payloads/ipxe/src/bin/keymap_uk.o $ROOTDIR/payloads/ipxe/src/bin/keymap_us.o $ROOTDIR/payloads/ipxe/src/bin/keymap_wo.o $ROOTDIR/payloads/ipxe/src/bin/autoboot.o $ROOTDIR/payloads/ipxe/src/bin/dhcpmgmt.o $ROOTDIR/payloads/ipxe/src/bin/fcmgmt.o $ROOTDIR/payloads/ipxe/src/bin/ifmgmt.o $ROOTDIR/payloads/ipxe/src/bin/imgmgmt.o $ROOTDIR/payloads/ipxe/src/bin/imgtrust.o $ROOTDIR/payloads/ipxe/src/bin/ipstat.o $ROOTDIR/payloads/ipxe/src/bin/iwmgmt.o $ROOTDIR/payloads/ipxe/src/bin/lotest.o $ROOTDIR/payloads/ipxe/src/bin/neighmgmt.o $ROOTDIR/payloads/ipxe/src/bin/nslookup.o $ROOTDIR/payloads/ipxe/src/bin/pingmgmt.o $ROOTDIR/payloads/ipxe/src/bin/profstat.o $ROOTDIR/payloads/ipxe/src/bin/prompt.o $ROOTDIR/payloads/ipxe/src/bin/pxemenu.o $ROOTDIR/payloads/ipxe/src/bin/route.o $ROOTDIR/payloads/ipxe/src/bin/route_ipv4.o $ROOTDIR/payloads/ipxe/src/bin/route_ipv6.o $ROOTDIR/payloads/ipxe/src/bin/sync.o $ROOTDIR/payloads/ipxe/src/bin/config.o $ROOTDIR/payloads/ipxe/src/bin/config_ethernet.o $ROOTDIR/payloads/ipxe/src/bin/config_fc.o $ROOTDIR/payloads/ipxe/src/bin/config_infiniband.o $ROOTDIR/payloads/ipxe/src/bin/config_net80211.o $ROOTDIR/payloads/ipxe/src/bin/config_romprefix.o $ROOTDIR/payloads/ipxe/src/bin/config_route.o $ROOTDIR/payloads/ipxe/src/bin/basemem_packet.o $ROOTDIR/payloads/ipxe/src/bin/cachedhcp.o $ROOTDIR/payloads/ipxe/src/bin/dumpregs.o $ROOTDIR/payloads/ipxe/src/bin/gdbmach.o $ROOTDIR/payloads/ipxe/src/bin/nulltrap.o $ROOTDIR/payloads/ipxe/src/bin/pci_autoboot.o $ROOTDIR/payloads/ipxe/src/bin/pic8259.o $ROOTDIR/payloads/ipxe/src/bin/rdtsc_timer.o $ROOTDIR/payloads/ipxe/src/bin/relocate.o $ROOTDIR/payloads/ipxe/src/bin/runtime.o $ROOTDIR/payloads/ipxe/src/bin/timer2.o $ROOTDIR/payloads/ipxe/src/bin/video_subr.o $ROOTDIR/payloads/ipxe/src/bin/librm_mgmt.o $ROOTDIR/payloads/ipxe/src/bin/librm_test.o $ROOTDIR/payloads/ipxe/src/bin/basemem.o $ROOTDIR/payloads/ipxe/src/bin/bios_console.o $ROOTDIR/payloads/ipxe/src/bin/fakee820.o $ROOTDIR/payloads/ipxe/src/bin/hidemem.o $ROOTDIR/payloads/ipxe/src/bin/memmap.o $ROOTDIR/payloads/ipxe/src/bin/pnpbios.o $ROOTDIR/payloads/ipxe/src/bin/bootsector.o $ROOTDIR/payloads/ipxe/src/bin/bzimage.o $ROOTDIR/payloads/ipxe/src/bin/com32.o $ROOTDIR/payloads/ipxe/src/bin/comboot.o $ROOTDIR/payloads/ipxe/src/bin/elfboot.o $ROOTDIR/payloads/ipxe/src/bin/initrd.o $ROOTDIR/payloads/ipxe/src/bin/multiboot.o $ROOTDIR/payloads/ipxe/src/bin/nbi.o $ROOTDIR/payloads/ipxe/src/bin/pxe_image.o $ROOTDIR/payloads/ipxe/src/bin/sdi.o $ROOTDIR/payloads/ipxe/src/bin/apm.o $ROOTDIR/payloads/ipxe/src/bin/biosint.o $ROOTDIR/payloads/ipxe/src/bin/bios_nap.o $ROOTDIR/payloads/ipxe/src/bin/bios_reboot.o $ROOTDIR/payloads/ipxe/src/bin/bios_smbios.o $ROOTDIR/payloads/ipxe/src/bin/bios_timer.o $ROOTDIR/payloads/ipxe/src/bin/int13.o $ROOTDIR/payloads/ipxe/src/bin/memtop_umalloc.o $ROOTDIR/payloads/ipxe/src/bin/pcibios.o $ROOTDIR/payloads/ipxe/src/bin/rtc_entropy.o $ROOTDIR/payloads/ipxe/src/bin/rtc_time.o $ROOTDIR/payloads/ipxe/src/bin/vesafb.o $ROOTDIR/payloads/ipxe/src/bin/pxe_call.o $ROOTDIR/payloads/ipxe/src/bin/pxe_exit_hook.o $ROOTDIR/payloads/ipxe/src/bin/pxe_file.o $ROOTDIR/payloads/ipxe/src/bin/pxe_loader.o $ROOTDIR/payloads/ipxe/src/bin/pxe_preboot.o $ROOTDIR/payloads/ipxe/src/bin/pxe_tftp.o $ROOTDIR/payloads/ipxe/src/bin/pxe_udp.o $ROOTDIR/payloads/ipxe/src/bin/pxe_undi.o $ROOTDIR/payloads/ipxe/src/bin/pxeparent.o $ROOTDIR/payloads/ipxe/src/bin/com32_call.o $ROOTDIR/payloads/ipxe/src/bin/comboot_call.o $ROOTDIR/payloads/ipxe/src/bin/comboot_resolv.o $ROOTDIR/payloads/ipxe/src/bin/guestinfo.o $ROOTDIR/payloads/ipxe/src/bin/guestrpc.o $ROOTDIR/payloads/ipxe/src/bin/vmconsole.o $ROOTDIR/payloads/ipxe/src/bin/vmware.o $ROOTDIR/payloads/ipxe/src/bin/pxe_cmd.o $ROOTDIR/payloads/ipxe/src/bin/cpuid.o $ROOTDIR/payloads/ipxe/src/bin/cpuid_settings.o $ROOTDIR/payloads/ipxe/src/bin/debugcon.o $ROOTDIR/payloads/ipxe/src/bin/pcidirect.o $ROOTDIR/payloads/ipxe/src/bin/x86_bigint.o $ROOTDIR/payloads/ipxe/src/bin/x86_io.o $ROOTDIR/payloads/ipxe/src/bin/x86_string.o $ROOTDIR/payloads/ipxe/src/bin/x86_tcpip.o $ROOTDIR/payloads/ipxe/src/bin/efix86_nap.o $ROOTDIR/payloads/ipxe/src/bin/efidrvprefix.o $ROOTDIR/payloads/ipxe/src/bin/efiprefix.o $ROOTDIR/payloads/ipxe/src/bin/cpuid_cmd.o $ROOTDIR/payloads/ipxe/src/bin/undi.o $ROOTDIR/payloads/ipxe/src/bin/undiload.o $ROOTDIR/payloads/ipxe/src/bin/undinet.o $ROOTDIR/payloads/ipxe/src/bin/undionly.o $ROOTDIR/payloads/ipxe/src/bin/undipreload.o $ROOTDIR/payloads/ipxe/src/bin/undirom.o $ROOTDIR/payloads/ipxe/src/bin/gdbstub_test.o $ROOTDIR/payloads/ipxe/src/bin/gdbidt.o $ROOTDIR/payloads/ipxe/src/bin/patch_cf.o $ROOTDIR/payloads/ipxe/src/bin/setjmp.o $ROOTDIR/payloads/ipxe/src/bin/stack16.o $ROOTDIR/payloads/ipxe/src/bin/stack.o $ROOTDIR/payloads/ipxe/src/bin/virtaddr.o $ROOTDIR/payloads/ipxe/src/bin/liba20.o $ROOTDIR/payloads/ipxe/src/bin/libkir.o $ROOTDIR/payloads/ipxe/src/bin/libpm.o $ROOTDIR/payloads/ipxe/src/bin/librm.o $ROOTDIR/payloads/ipxe/src/bin/bootpart.o $ROOTDIR/payloads/ipxe/src/bin/dskprefix.o $ROOTDIR/payloads/ipxe/src/bin/exeprefix.o $ROOTDIR/payloads/ipxe/src/bin/hdprefix.o $ROOTDIR/payloads/ipxe/src/bin/kkkpxeprefix.o $ROOTDIR/payloads/ipxe/src/bin/kkpxeprefix.o $ROOTDIR/payloads/ipxe/src/bin/kpxeprefix.o $ROOTDIR/payloads/ipxe/src/bin/libprefix.o $ROOTDIR/payloads/ipxe/src/bin/lkrnprefix.o $ROOTDIR/payloads/ipxe/src/bin/mbr.o $ROOTDIR/payloads/ipxe/src/bin/mromprefix.o $ROOTDIR/payloads/ipxe/src/bin/nbiprefix.o $ROOTDIR/payloads/ipxe/src/bin/nullprefix.o $ROOTDIR/payloads/ipxe/src/bin/pxeprefix.o $ROOTDIR/payloads/ipxe/src/bin/romprefix.o $ROOTDIR/payloads/ipxe/src/bin/undiloader.o $ROOTDIR/payloads/ipxe/src/bin/unnrv2b16.o $ROOTDIR/payloads/ipxe/src/bin/unnrv2b.o $ROOTDIR/payloads/ipxe/src/bin/usbdisk.o $ROOTDIR/payloads/ipxe/src/bin/e820mangler.o $ROOTDIR/payloads/ipxe/src/bin/pxe_entry.o $ROOTDIR/payloads/ipxe/src/bin/com32_wrapper.o $ROOTDIR/payloads/ipxe/src/bin/undiisr.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ranlib $ROOTDIR/payloads/ipxe/src/bin/blib.a
gcc  -Wall -W -Wformat-nonliteral -O2 -g -MMD -Werror -o util/zbin util/zbin.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -m elf_i386 -N --no-check-sections   --gc-sections -static -T arch/i386/scripts/i386.lds  -u _rom_start --defsym check__rom_start=_rom_start   -u obj_realtek --defsym check_obj_realtek=obj_realtek   -u obj_config --defsym check_obj_config=obj_config  --defsym pci_vendor_id=0x10ec --defsym pci_device_id=0x8168 -e _rom_start $ROOTDIR/payloads/ipxe/src/bin/blib.a -o $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.tmp --defsym _build_id=`perl -e 'printf "0x%08x", int ( rand ( 0xffffffff ) );'` -Map $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.tmp.map
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objdump -ht $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.tmp | perl ./util/sortobjdump.pl >> $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.tmp.map
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy -O binary -R .zinfo $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.tmp $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.bin
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy -O binary -j .zinfo $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.tmp $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.zinfo
./util/zbin $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.bin $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.zinfo > $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.zbin
cp $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom.zbin $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom
perl ./util/padimg.pl --blksize=512 --byte=0xff $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom
perl ./util/fixrom.pl $ROOTDIR/payloads/ipxe/src/bin/10ec8168.rom
popd # src
popd # payloads/ipxe
if [ -e payloads/ipxe/src/bin/10ec8168.rom ]; then build/cbfstool build/coreboot.pre add -f payloads/ipxe/src/bin/10ec8168.rom -n genroms/pxe.rom  -t raw ; fi
pushd payloads/sortbootorder/
pushd $ROOTDIR/payloads/sortbootorder/../libpayload
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpci/libpci.libpci.o libpci/libpci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpci.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpci/libpci.libpci.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/main.libc.o arch/x86/main.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/sysinfo.libc.o arch/x86/sysinfo.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/timer.libc.o arch/x86/timer.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/coreboot.libc.o arch/x86/coreboot.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/util.libc.o arch/x86/util.S
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/exec.libc.o arch/x86/exec.S
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/virtual.libc.o arch/x86/virtual.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/string.libc.o arch/x86/string.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/crypto/sha1.libc.o crypto/sha1.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/malloc.libc.o libc/malloc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/printf.libc.o libc/printf.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/console.libc.o libc/console.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/string.libc.o libc/string.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/memory.libc.o libc/memory.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/ctype.libc.o libc/ctype.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/ipchecksum.libc.o libc/ipchecksum.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/lib.libc.o libc/lib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/rand.libc.o libc/rand.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/time.libc.o libc/time.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/exec.libc.o libc/exec.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/readline.libc.o libc/readline.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/getopt_long.libc.o libc/getopt_long.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/sysinfo.libc.o libc/sysinfo.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/args.libc.o libc/args.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/strings.libc.o libc/strings.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/strlcpy.libc.o libc/strlcpy.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/qsort.libc.o libc/qsort.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/hexdump.libc.o libc/hexdump.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/pci.libc.o drivers/pci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/speaker.libc.o drivers/speaker.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/serial.libc.o drivers/serial.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/keyboard.libc.o drivers/keyboard.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/cbmem_console.libc.o drivers/cbmem_console.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/nvram.libc.o drivers/nvram.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/options.libc.o drivers/options.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/video.libc.o drivers/video/video.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/vga.libc.o drivers/video/vga.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/corebootfb.libc.o drivers/video/corebootfb.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/font8x16.libc.o drivers/video/font8x16.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/storage.libc.o drivers/storage/storage.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci.libc.o drivers/storage/ahci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_common.libc.o drivers/storage/ahci_common.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ata.libc.o drivers/storage/ata.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_ata.libc.o drivers/storage/ahci_ata.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/atapi.libc.o drivers/storage/atapi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_atapi.libc.o drivers/storage/ahci_atapi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbinit.libc.o drivers/usb/usbinit.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usb.libc.o drivers/usb/usb.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usb_dev.libc.o drivers/usb/usb_dev.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/quirks.libc.o drivers/usb/quirks.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/generic_hub.libc.o drivers/usb/generic_hub.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbhub.libc.o drivers/usb/usbhub.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/uhci.libc.o drivers/usb/uhci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/uhci_rh.libc.o drivers/usb/uhci_rh.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ohci.libc.o drivers/usb/ohci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ohci_rh.libc.o drivers/usb/ohci_rh.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ehci.libc.o drivers/usb/ehci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ehci_rh.libc.o drivers/usb/ehci_rh.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci.libc.o drivers/usb/xhci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_debug.libc.o drivers/usb/xhci_debug.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_devconf.libc.o drivers/usb/xhci_devconf.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_events.libc.o drivers/usb/xhci_events.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_commands.libc.o drivers/usb/xhci_commands.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_rh.libc.o drivers/usb/xhci_rh.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbhid.libc.o drivers/usb/usbhid.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbmsc.libc.o drivers/usb/usbmsc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/hid.libc.o drivers/hid.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/main.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/sysinfo.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/timer.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/coreboot.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/util.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/exec.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/virtual.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/string.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/crypto/sha1.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/malloc.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/printf.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/console.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/string.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/memory.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/ctype.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/ipchecksum.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/lib.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/rand.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/time.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/exec.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/readline.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/getopt_long.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/sysinfo.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/args.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/strings.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/strlcpy.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/qsort.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/hexdump.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/pci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/speaker.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/serial.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/keyboard.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/cbmem_console.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/nvram.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/options.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/video.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/vga.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/corebootfb.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/font8x16.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/storage.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_common.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ata.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_ata.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/atapi.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_atapi.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbinit.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usb.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usb_dev.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/quirks.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/generic_hub.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbhub.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/uhci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/uhci_rh.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ohci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ohci_rh.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ehci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ehci_rh.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_debug.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_devconf.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_events.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_commands.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_rh.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbhid.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbmsc.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/hid.libc.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcdisp.libcurses.o curses/pdcurses-backend/pdcdisp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcgetsc.libcurses.o curses/pdcurses-backend/pdcgetsc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdckbd.libcurses.o curses/pdcurses-backend/pdckbd.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcscrn.libcurses.o curses/pdcurses-backend/pdcscrn.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcsetsc.libcurses.o curses/pdcurses-backend/pdcsetsc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcutil.libcurses.o curses/pdcurses-backend/pdcutil.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addch.libcurses.o curses/PDCurses-3.4/pdcurses/addch.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/move.libcurses.o curses/PDCurses-3.4/pdcurses/move.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/overlay.libcurses.o curses/PDCurses-3.4/pdcurses/overlay.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/refresh.libcurses.o curses/PDCurses-3.4/pdcurses/refresh.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/terminfo.libcurses.o curses/PDCurses-3.4/pdcurses/terminfo.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/window.libcurses.o curses/PDCurses-3.4/pdcurses/window.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/util.libcurses.o curses/PDCurses-3.4/pdcurses/util.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inopts.libcurses.o curses/PDCurses-3.4/pdcurses/inopts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addstr.libcurses.o curses/PDCurses-3.4/pdcurses/addstr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/keyname.libcurses.o curses/PDCurses-3.4/pdcurses/keyname.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/instr.libcurses.o curses/PDCurses-3.4/pdcurses/instr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/clear.libcurses.o curses/PDCurses-3.4/pdcurses/clear.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addchstr.libcurses.o curses/PDCurses-3.4/pdcurses/addchstr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/kernel.libcurses.o curses/PDCurses-3.4/pdcurses/kernel.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/pad.libcurses.o curses/PDCurses-3.4/pdcurses/pad.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/insstr.libcurses.o curses/PDCurses-3.4/pdcurses/insstr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/border.libcurses.o curses/PDCurses-3.4/pdcurses/border.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getyx.libcurses.o curses/PDCurses-3.4/pdcurses/getyx.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getstr.libcurses.o curses/PDCurses-3.4/pdcurses/getstr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getch.libcurses.o curses/PDCurses-3.4/pdcurses/getch.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/termattr.libcurses.o curses/PDCurses-3.4/pdcurses/termattr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/outopts.libcurses.o curses/PDCurses-3.4/pdcurses/outopts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/color.libcurses.o curses/PDCurses-3.4/pdcurses/color.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/deleteln.libcurses.o curses/PDCurses-3.4/pdcurses/deleteln.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/initscr.libcurses.o curses/PDCurses-3.4/pdcurses/initscr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/slk.libcurses.o curses/PDCurses-3.4/pdcurses/slk.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/delch.libcurses.o curses/PDCurses-3.4/pdcurses/delch.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/touch.libcurses.o curses/PDCurses-3.4/pdcurses/touch.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/mouse.libcurses.o curses/PDCurses-3.4/pdcurses/mouse.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/scanw.libcurses.o curses/PDCurses-3.4/pdcurses/scanw.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/scroll.libcurses.o curses/PDCurses-3.4/pdcurses/scroll.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/printw.libcurses.o curses/PDCurses-3.4/pdcurses/printw.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/bkgd.libcurses.o curses/PDCurses-3.4/pdcurses/bkgd.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inch.libcurses.o curses/PDCurses-3.4/pdcurses/inch.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/attr.libcurses.o curses/PDCurses-3.4/pdcurses/attr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/insch.libcurses.o curses/PDCurses-3.4/pdcurses/insch.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inchstr.libcurses.o curses/PDCurses-3.4/pdcurses/inchstr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/beep.libcurses.o curses/PDCurses-3.4/pdcurses/beep.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcurses.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcdisp.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcgetsc.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdckbd.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcscrn.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcsetsc.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcutil.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/move.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/overlay.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/refresh.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/terminfo.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/window.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/util.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inopts.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/keyname.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/instr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/clear.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addchstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/kernel.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/pad.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/insstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/border.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getyx.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/termattr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/outopts.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/color.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/deleteln.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/initscr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/slk.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/delch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/touch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/mouse.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/scanw.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/scroll.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/printw.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/bkgd.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/attr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/insch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inchstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/beep.libcurses.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_req_name.libmenu.o curses/menu/m_req_name.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_nam.libmenu.o curses/menu/m_item_nam.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_pad.libmenu.o curses/menu/m_pad.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_cursor.libmenu.o curses/menu/m_cursor.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_new.libmenu.o curses/menu/m_item_new.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_attribs.libmenu.o curses/menu/m_attribs.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_opt.libmenu.o curses/menu/m_item_opt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_format.libmenu.o curses/menu/m_format.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_post.libmenu.o curses/menu/m_post.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_userptr.libmenu.o curses/menu/m_userptr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_cur.libmenu.o curses/menu/m_item_cur.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_driver.libmenu.o curses/menu/m_driver.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_sub.libmenu.o curses/menu/m_sub.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_win.libmenu.o curses/menu/m_win.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_global.libmenu.o curses/menu/m_global.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_vis.libmenu.o curses/menu/m_item_vis.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_new.libmenu.o curses/menu/m_new.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_scale.libmenu.o curses/menu/m_scale.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_spacing.libmenu.o curses/menu/m_spacing.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_opts.libmenu.o curses/menu/m_opts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_pattern.libmenu.o curses/menu/m_pattern.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_val.libmenu.o curses/menu/m_item_val.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_hook.libmenu.o curses/menu/m_hook.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_use.libmenu.o curses/menu/m_item_use.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_items.libmenu.o curses/menu/m_items.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_top.libmenu.o curses/menu/m_item_top.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libmenu.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_req_name.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_nam.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_pad.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_cursor.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_new.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_attribs.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_opt.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_format.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_post.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_userptr.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_cur.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_driver.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_sub.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_win.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_global.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_vis.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_new.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_scale.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_spacing.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_opts.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_pattern.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_val.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_hook.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_use.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_items.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_top.libmenu.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_page.libform.o curses/form/frm_page.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_opts.libform.o curses/form/frm_opts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_def.libform.o curses/form/frm_def.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_req_name.libform.o curses/form/frm_req_name.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_alpha.libform.o curses/form/fty_alpha.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_driver.libform.o curses/form/frm_driver.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_user.libform.o curses/form/fld_user.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_win.libform.o curses/form/frm_win.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_newftyp.libform.o curses/form/fld_newftyp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_stat.libform.o curses/form/fld_stat.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_pad.libform.o curses/form/fld_pad.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_current.libform.o curses/form/fld_current.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_post.libform.o curses/form/frm_post.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_generic.libform.o curses/form/fty_generic.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_page.libform.o curses/form/fld_page.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_hook.libform.o curses/form/frm_hook.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_scale.libform.o curses/form/frm_scale.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_int.libform.o curses/form/fty_int.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_alnum.libform.o curses/form/fty_alnum.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_cursor.libform.o curses/form/frm_cursor.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_link.libform.o curses/form/fld_link.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_arg.libform.o curses/form/fld_arg.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_move.libform.o curses/form/fld_move.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_def.libform.o curses/form/fld_def.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_type.libform.o curses/form/fld_type.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_max.libform.o curses/form/fld_max.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_ftlink.libform.o curses/form/fld_ftlink.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_ftchoice.libform.o curses/form/fld_ftchoice.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_info.libform.o curses/form/fld_info.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_user.libform.o curses/form/frm_user.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_sub.libform.o curses/form/frm_sub.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_enum.libform.o curses/form/fty_enum.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_data.libform.o curses/form/frm_data.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_opts.libform.o curses/form/fld_opts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_attr.libform.o curses/form/fld_attr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_dup.libform.o curses/form/fld_dup.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_just.libform.o curses/form/fld_just.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libform.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_page.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_opts.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_def.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_req_name.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_alpha.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_driver.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_user.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_win.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_newftyp.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_stat.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_pad.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_current.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_post.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_generic.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_page.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_hook.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_scale.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_int.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_alnum.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_cursor.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_link.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_arg.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_move.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_def.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_type.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_max.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_ftlink.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_ftchoice.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_info.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_user.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_sub.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_enum.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_data.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_opts.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_attr.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_dup.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_just.libform.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/panel.libpanel.o curses/PDCurses-3.4/pdcurses/panel.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpanel.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/panel.libpanel.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/rom_media.libcbfs.o arch/x86/rom_media.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs/cbfs.libcbfs.o libcbfs/cbfs.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs/ram_media.libcbfs.o libcbfs/ram_media.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/rom_media.libcbfs.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs/cbfs.libcbfs.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs/ram_media.libcbfs.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/liblzma/lzma.liblzma.o liblzma/lzma.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/liblzma.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/liblzma/lzma.liblzma.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/gpio.libamd.o libamd/gpio.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/i2c.libamd.o libamd/i2c.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/pmreg.libamd.o libamd/pmreg.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/spi.libamd.o libamd/spi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/gpio.libamd.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/i2c.libamd.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/pmreg.libamd.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/spi.libamd.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ar rc $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpayload.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpci/libpci.libpci.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/main.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/sysinfo.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/timer.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/coreboot.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/util.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/exec.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/virtual.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/string.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/crypto/sha1.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/malloc.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/printf.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/console.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/string.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/memory.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/ctype.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/ipchecksum.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/lib.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/rand.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/time.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/exec.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/readline.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/getopt_long.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/sysinfo.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/args.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/strings.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/strlcpy.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/qsort.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc/hexdump.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/pci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/speaker.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/serial.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/keyboard.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/cbmem_console.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/nvram.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/options.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/video.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/vga.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/corebootfb.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/video/font8x16.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/storage.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_common.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ata.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_ata.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/atapi.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/storage/ahci_atapi.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbinit.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usb.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usb_dev.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/quirks.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/generic_hub.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbhub.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/uhci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/uhci_rh.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ohci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ohci_rh.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ehci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/ehci_rh.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_debug.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_devconf.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_events.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_commands.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/xhci_rh.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbhid.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/usb/usbmsc.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/drivers/hid.libc.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcdisp.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcgetsc.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdckbd.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcscrn.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcsetsc.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/pdcurses-backend/pdcutil.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/move.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/overlay.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/refresh.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/terminfo.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/window.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/util.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inopts.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/keyname.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/instr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/clear.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/addchstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/kernel.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/pad.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/insstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/border.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getyx.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/getch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/termattr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/outopts.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/color.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/deleteln.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/initscr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/slk.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/delch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/touch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/mouse.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/scanw.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/scroll.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/printw.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/bkgd.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/attr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/insch.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/inchstr.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/beep.libcurses.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_req_name.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_nam.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_pad.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_cursor.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_new.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_attribs.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_opt.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_format.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_post.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_userptr.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_cur.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_driver.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_sub.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_win.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_global.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_vis.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_new.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_scale.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_spacing.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_opts.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_pattern.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_val.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_hook.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_use.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_items.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/menu/m_item_top.libmenu.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_page.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_opts.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_def.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_req_name.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_alpha.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_driver.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_user.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_win.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_newftyp.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_stat.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_pad.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_current.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_post.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_generic.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_page.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_hook.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_scale.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_int.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_alnum.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_cursor.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_link.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_arg.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_move.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_def.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_type.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_max.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_ftlink.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_ftchoice.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_info.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_user.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_sub.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fty_enum.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/frm_data.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_opts.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_attr.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_dup.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/form/fld_just.libform.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/curses/PDCurses-3.4/pdcurses/panel.libpanel.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/rom_media.libcbfs.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs/cbfs.libcbfs.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs/ram_media.libcbfs.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/liblzma/lzma.liblzma.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/gpio.libamd.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/i2c.libamd.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/pmreg.libamd.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd/spi.libamd.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none  -MMD  -Iinclude -Iinclude/x86 -I$ROOTDIR/payloads/sortbootorder/libpayloadbin/build -D_LP64=0 -Icurses/PDCurses-3.4 -Icurses/pdcurses-backend -Icurses/menu -Icurses/form -Os -pipe -nostdinc -nostdlib -fno-builtin -ffreestanding -fomit-frame-pointer -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -c -o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/head.head.o.o arch/x86/head.S
cp $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/arch/x86/head.head.o.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/head.o
install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/lib
for lib in $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpci.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libc.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcurses.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libmenu.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libform.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpanel.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libcbfs.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/liblzma.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libamd.a $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpayload.a; do install -m 644 $lib $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/lib/; done
install -m 644 arch/x86/libpayload.ldscript $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/lib/
install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/lib/x86
install -m 644 $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/head.o $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/lib/x86
install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include
for file in `find include -name *.h -type f`; do install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/`dirname $file`; install -m 644 $file $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/$file; done
if [ -e $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpayload-config.h ]; then install -m 644 $ROOTDIR/payloads/sortbootorder/libpayloadbin/build/libpayload-config.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include ; fi
install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/pdcurses-backend/nc_alloc.h ]; then  install -m 644 curses/pdcurses-backend/nc_alloc.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi;   install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/pdcurses-backend/ncurses_cfg.h ]; then  install -m 644 curses/pdcurses-backend/ncurses_cfg.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi;   install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/PDCurses-3.4/curses.h ]; then  install -m 644 curses/PDCurses-3.4/curses.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi;   install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/PDCurses-3.4/term.h ]; then  install -m 644 curses/PDCurses-3.4/term.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi;   install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/PDCurses-3.4/panel.h ]; then  install -m 644 curses/PDCurses-3.4/panel.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi;   install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/menu/eti.h ]; then  install -m 644 curses/menu/eti.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi;   install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/menu/menu.h ]; then  install -m 644 curses/menu/menu.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi;   install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/menu/mf_common.h ]; then  install -m 644 curses/menu/mf_common.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi;   install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/;if [ -e curses/form/form.h ]; then  install -m 644 curses/form/form.h $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/include/ ; fi; 
install -m 755 -d $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin
install -m 755 bin/lpgcc $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin
install -m 755 bin/lpas $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin
install -m 644 bin/lp.functions $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin
install -m 644 $ROOTDIR/payloads/sortbootorder/libpayloadbin/.config $ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/libpayload.config
popd # $ROOTDIR/payloads/sortbootorder/../libpayload
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o sortbootorder.o sortbootorder.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o eon.o eon.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o gigadevice.o gigadevice.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o macronix.o macronix.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o spansion.o spansion.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o spi.o spi.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o spi_flash.o spi_flash.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o sst.o sst.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o stmicro.o stmicro.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -Wall -Werror -Wno-unused-but-set-variable -g -Os -pipe -MMD -c -o winbond.o winbond.c
$ROOTDIR/payloads/sortbootorder/libpayloadbin/libpayload/bin/lpgcc -o sortbootorder.elf sortbootorder.o eon.o gigadevice.o macronix.o spansion.o spi.o spi_flash.o sst.o stmicro.o winbond.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --only-keep-debug sortbootorder.elf sortbootorder.debug
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --strip-debug sortbootorder.elf
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --add-gnu-debuglink=sortbootorder.debug sortbootorder.elf
popd # payloads/sortbootorder/
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/ACPILIB.ramstage.o src/vendorcode/amd/cimx/sb800/ACPILIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/AMDLIB.ramstage.o src/vendorcode/amd/cimx/sb800/AMDLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/AMDSBLIB.ramstage.o src/vendorcode/amd/cimx/sb800/AMDSBLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/AZALIA.ramstage.o src/vendorcode/amd/cimx/sb800/AZALIA.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/DISPATCHER.ramstage.o src/vendorcode/amd/cimx/sb800/DISPATCHER.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/EC.ramstage.o src/vendorcode/amd/cimx/sb800/EC.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/ECLIB.ramstage.o src/vendorcode/amd/cimx/sb800/ECLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/ECfanLIB.ramstage.o src/vendorcode/amd/cimx/sb800/ECfanLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/ECfanc.ramstage.o src/vendorcode/amd/cimx/sb800/ECfanc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/GEC.ramstage.o src/vendorcode/amd/cimx/sb800/GEC.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/Gpp.ramstage.o src/vendorcode/amd/cimx/sb800/Gpp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/IOLIB.ramstage.o src/vendorcode/amd/cimx/sb800/IOLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/MEMLIB.ramstage.o src/vendorcode/amd/cimx/sb800/MEMLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/PCILIB.ramstage.o src/vendorcode/amd/cimx/sb800/PCILIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/PMIO2LIB.ramstage.o src/vendorcode/amd/cimx/sb800/PMIO2LIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/PMIOLIB.ramstage.o src/vendorcode/amd/cimx/sb800/PMIOLIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SATA.ramstage.o src/vendorcode/amd/cimx/sb800/SATA.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SBCMN.ramstage.o src/vendorcode/amd/cimx/sb800/SBCMN.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SBMAIN.ramstage.o src/vendorcode/amd/cimx/sb800/SBMAIN.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SBPELIB.ramstage.o src/vendorcode/amd/cimx/sb800/SBPELIB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SBPOR.ramstage.o src/vendorcode/amd/cimx/sb800/SBPOR.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/SMM.ramstage.o src/vendorcode/amd/cimx/sb800/SMM.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/vendorcode/amd/cimx/sb800/USB.ramstage.o src/vendorcode/amd/cimx/sb800/USB.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/vendorcode/amd/cimx/sb800/ramstage.o -r build/vendorcode/amd/cimx/sb800/ACPILIB.ramstage.o build/vendorcode/amd/cimx/sb800/AMDLIB.ramstage.o build/vendorcode/amd/cimx/sb800/AMDSBLIB.ramstage.o build/vendorcode/amd/cimx/sb800/AZALIA.ramstage.o build/vendorcode/amd/cimx/sb800/DISPATCHER.ramstage.o build/vendorcode/amd/cimx/sb800/EC.ramstage.o build/vendorcode/amd/cimx/sb800/ECLIB.ramstage.o build/vendorcode/amd/cimx/sb800/ECfanLIB.ramstage.o build/vendorcode/amd/cimx/sb800/ECfanc.ramstage.o build/vendorcode/amd/cimx/sb800/GEC.ramstage.o build/vendorcode/amd/cimx/sb800/Gpp.ramstage.o build/vendorcode/amd/cimx/sb800/IOLIB.ramstage.o build/vendorcode/amd/cimx/sb800/MEMLIB.ramstage.o build/vendorcode/amd/cimx/sb800/PCILIB.ramstage.o build/vendorcode/amd/cimx/sb800/PMIO2LIB.ramstage.o build/vendorcode/amd/cimx/sb800/PMIOLIB.ramstage.o build/vendorcode/amd/cimx/sb800/SATA.ramstage.o build/vendorcode/amd/cimx/sb800/SBCMN.ramstage.o build/vendorcode/amd/cimx/sb800/SBMAIN.ramstage.o build/vendorcode/amd/cimx/sb800/SBPELIB.ramstage.o build/vendorcode/amd/cimx/sb800/SBPOR.ramstage.o build/vendorcode/amd/cimx/sb800/SMM.ramstage.o build/vendorcode/amd/cimx/sb800/USB.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/superio/nuvoton/nct5104d/superio.ramstage.o src/superio/nuvoton/nct5104d/superio.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/superio/nuvoton/nct5104d/ramstage.o -r build/superio/nuvoton/nct5104d/superio.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/superio/common/conf_mode.ramstage.o src/superio/common/conf_mode.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/superio/common/ramstage.o -r build/superio/common/conf_mode.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/superio/acpi/spcr.ramstage.o src/superio/acpi/spcr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/superio/acpi/ramstage.o -r build/superio/acpi/spcr.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/cfg.ramstage.o src/southbridge/amd/cimx/sb800/cfg.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/fadt.ramstage.o src/southbridge/amd/cimx/sb800/fadt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/late.ramstage.o src/southbridge/amd/cimx/sb800/late.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/lpc.ramstage.o src/southbridge/amd/cimx/sb800/lpc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/reset.ramstage.o src/southbridge/amd/cimx/sb800/reset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/smbus.ramstage.o src/southbridge/amd/cimx/sb800/smbus.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/sb800/spi.ramstage.o src/southbridge/amd/cimx/sb800/spi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/southbridge/amd/cimx/sb800/ramstage.o -r build/southbridge/amd/cimx/sb800/cfg.ramstage.o build/southbridge/amd/cimx/sb800/fadt.ramstage.o build/southbridge/amd/cimx/sb800/late.ramstage.o build/southbridge/amd/cimx/sb800/lpc.ramstage.o build/southbridge/amd/cimx/sb800/reset.ramstage.o build/southbridge/amd/cimx/sb800/smbus.ramstage.o build/southbridge/amd/cimx/sb800/spi.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/southbridge/amd/cimx/cimx_util.ramstage.o src/southbridge/amd/cimx/cimx_util.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/southbridge/amd/cimx/ramstage.o -r build/southbridge/amd/cimx/cimx_util.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/northbridge/amd/common/bios_reset.ramstage.o src/northbridge/amd/common/bios_reset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/northbridge/amd/common/ramstage.o -r build/northbridge/amd/common/bios_reset.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/northbridge/amd/agesa/family14/fam14_callouts.ramstage.o src/northbridge/amd/agesa/family14/fam14_callouts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/northbridge/amd/agesa/family14/northbridge.ramstage.o src/northbridge/amd/agesa/family14/northbridge.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/northbridge/amd/agesa/family14/ramstage.o -r build/northbridge/amd/agesa/family14/fam14_callouts.ramstage.o build/northbridge/amd/agesa/family14/northbridge.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/northbridge/amd/agesa/common/common.ramstage.o src/northbridge/amd/agesa/common/common.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/northbridge/amd/agesa/common/ramstage.o -r build/northbridge/amd/agesa/common/common.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/static.ramstage.o build/mainboard/pcengines/apu/static.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/BiosCallOuts.ramstage.o src/mainboard/pcengines/apu/BiosCallOuts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/PlatformGnbPcie.ramstage.o src/mainboard/pcengines/apu/PlatformGnbPcie.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/acpi_tables.ramstage.o src/mainboard/pcengines/apu/acpi_tables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/agesawrapper.ramstage.o src/mainboard/pcengines/apu/agesawrapper.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/buildOpts.ramstage.o src/mainboard/pcengines/apu/buildOpts.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -x assembler-with-cpp -E -MMD -MT build/mainboard/pcengines/apu/dsdt.ramstage.o -D__ACPI__ -P -include src/include/kconfig.h -Ibuild -Isrc -Isrc/include -Isrc/arch/x86/include -Isrc/mainboard/pcengines/apu -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common src/mainboard/pcengines/apu/dsdt.asl -o build/mainboard/pcengines/apu/dsdt.ramstage.asl
pushd build/mainboard/pcengines/apu/; "$SAGE_HOME"/tools/xgcc/bin/iasl -p dsdt.ramstage.o -tc dsdt.ramstage.asl
popd
mv build/mainboard/pcengines/apu/dsdt.ramstage.hex build/mainboard/pcengines/apu/dsdt.ramstage.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include   -c -o build/mainboard/pcengines/apu/dsdt.ramstage.o build/mainboard/pcengines/apu/dsdt.ramstage.c
mv build/mainboard/pcengines/apu/dsdt.ramstage.c build/mainboard/pcengines/apu/dsdt.ramstage.hex
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/get_bus_conf.ramstage.o src/mainboard/pcengines/apu/get_bus_conf.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/gpio_ftns.ramstage.o src/mainboard/pcengines/apu/gpio_ftns.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/irq_tables.ramstage.o src/mainboard/pcengines/apu/irq_tables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/mainboard.ramstage.o src/mainboard/pcengines/apu/mainboard.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/mainboard/pcengines/apu/mptable.ramstage.o src/mainboard/pcengines/apu/mptable.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/mainboard/pcengines/apu/ramstage.o -r build/mainboard/pcengines/apu/static.ramstage.o build/mainboard/pcengines/apu/BiosCallOuts.ramstage.o build/mainboard/pcengines/apu/PlatformGnbPcie.ramstage.o build/mainboard/pcengines/apu/acpi_tables.ramstage.o build/mainboard/pcengines/apu/agesawrapper.ramstage.o build/mainboard/pcengines/apu/buildOpts.ramstage.o build/mainboard/pcengines/apu/dsdt.ramstage.o build/mainboard/pcengines/apu/get_bus_conf.ramstage.o build/mainboard/pcengines/apu/gpio_ftns.ramstage.o build/mainboard/pcengines/apu/irq_tables.ramstage.o build/mainboard/pcengines/apu/mainboard.ramstage.o build/mainboard/pcengines/apu/mptable.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/loaders/cbfs_payload_loader.ramstage.o src/lib/loaders/cbfs_payload_loader.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/loaders/load_and_run_payload.ramstage.o src/lib/loaders/load_and_run_payload.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/lib/loaders/ramstage.o -r build/lib/loaders/cbfs_payload_loader.ramstage.o build/lib/loaders/load_and_run_payload.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/bootmem.ramstage.o src/lib/bootmem.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/bootmode.ramstage.o src/lib/bootmode.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/cbfs.ramstage.o src/lib/cbfs.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/cbmem.ramstage.o src/lib/cbmem.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/cbmem_console.ramstage.o src/lib/cbmem_console.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/cbmem_info.ramstage.o src/lib/cbmem_info.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/clog2.ramstage.o src/lib/clog2.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/compute_ip_checksum.ramstage.o src/lib/compute_ip_checksum.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/coreboot_table.ramstage.o src/lib/coreboot_table.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/delay.ramstage.o src/lib/delay.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/fallback_boot.ramstage.o src/lib/fallback_boot.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/gcc.ramstage.o src/lib/gcc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/hardwaremain.ramstage.o src/lib/hardwaremain.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/hexdump.ramstage.o src/lib/hexdump.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/lzma.ramstage.o src/lib/lzma.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/malloc.ramstage.o src/lib/malloc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/memchr.ramstage.o src/lib/memchr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/memcmp.ramstage.o src/lib/memcmp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/memrange.ramstage.o src/lib/memrange.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/reg_script.ramstage.o src/lib/reg_script.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/selfboot.ramstage.o src/lib/selfboot.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/stack.ramstage.o src/lib/stack.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/lib/version.ramstage.o src/lib/version.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/lib/ramstage.o -r build/lib/bootmem.ramstage.o build/lib/bootmode.ramstage.o build/lib/cbfs.ramstage.o build/lib/cbmem.ramstage.o build/lib/cbmem_console.ramstage.o build/lib/cbmem_info.ramstage.o build/lib/clog2.ramstage.o build/lib/compute_ip_checksum.ramstage.o build/lib/coreboot_table.ramstage.o build/lib/delay.ramstage.o build/lib/fallback_boot.ramstage.o build/lib/gcc.ramstage.o build/lib/hardwaremain.ramstage.o build/lib/hexdump.ramstage.o build/lib/lzma.ramstage.o build/lib/malloc.ramstage.o build/lib/memchr.ramstage.o build/lib/memcmp.ramstage.o build/lib/memrange.ramstage.o build/lib/reg_script.ramstage.o build/lib/selfboot.ramstage.o build/lib/stack.ramstage.o build/lib/version.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/uart/uart8250io.ramstage.o src/drivers/uart/uart8250io.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/uart/util.ramstage.o src/drivers/uart/util.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/drivers/uart/ramstage.o -r build/drivers/uart/uart8250io.ramstage.o build/drivers/uart/util.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/adesto.ramstage.o src/drivers/spi/adesto.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/amic.ramstage.o src/drivers/spi/amic.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/atmel.ramstage.o src/drivers/spi/atmel.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/eon.ramstage.o src/drivers/spi/eon.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/gigadevice.ramstage.o src/drivers/spi/gigadevice.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/macronix.ramstage.o src/drivers/spi/macronix.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/micron.ramstage.o src/drivers/spi/micron.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/spansion.ramstage.o src/drivers/spi/spansion.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/spi_flash.ramstage.o src/drivers/spi/spi_flash.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/sst.ramstage.o src/drivers/spi/sst.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/stmicro.ramstage.o src/drivers/spi/stmicro.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/spi/winbond.ramstage.o src/drivers/spi/winbond.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/drivers/spi/ramstage.o -r build/drivers/spi/adesto.ramstage.o build/drivers/spi/amic.ramstage.o build/drivers/spi/atmel.ramstage.o build/drivers/spi/eon.ramstage.o build/drivers/spi/gigadevice.ramstage.o build/drivers/spi/macronix.ramstage.o build/drivers/spi/micron.ramstage.o build/drivers/spi/spansion.ramstage.o build/drivers/spi/spi_flash.ramstage.o build/drivers/spi/sst.ramstage.o build/drivers/spi/stmicro.ramstage.o build/drivers/spi/winbond.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/pc80/i8254.ramstage.o src/drivers/pc80/i8254.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/pc80/i8259.ramstage.o src/drivers/pc80/i8259.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/pc80/isa-dma.ramstage.o src/drivers/pc80/isa-dma.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/pc80/keyboard.ramstage.o src/drivers/pc80/keyboard.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/drivers/pc80/mc146818rtc.ramstage.o src/drivers/pc80/mc146818rtc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/drivers/pc80/ramstage.o -r build/drivers/pc80/i8254.ramstage.o build/drivers/pc80/i8259.ramstage.o build/drivers/pc80/isa-dma.ramstage.o build/drivers/pc80/keyboard.ramstage.o build/drivers/pc80/mc146818rtc.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/agp_device.ramstage.o src/device/agp_device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/cardbus_device.ramstage.o src/device/cardbus_device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/cpu_device.ramstage.o src/device/cpu_device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/device.ramstage.o src/device/device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/device_util.ramstage.o src/device/device_util.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/pci_device.ramstage.o src/device/pci_device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/pci_early.ramstage.o src/device/pci_early.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/pci_ops.ramstage.o src/device/pci_ops.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/pciexp_device.ramstage.o src/device/pciexp_device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/pcix_device.ramstage.o src/device/pcix_device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/pnp_device.ramstage.o src/device/pnp_device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/root_device.ramstage.o src/device/root_device.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/device/smbus_ops.ramstage.o src/device/smbus_ops.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/device/ramstage.o -r build/device/agp_device.ramstage.o build/device/cardbus_device.ramstage.o build/device/cpu_device.ramstage.o build/device/device.ramstage.o build/device/device_util.ramstage.o build/device/pci_device.ramstage.o build/device/pci_early.ramstage.o build/device/pci_ops.ramstage.o build/device/pciexp_device.ramstage.o build/device/pcix_device.ramstage.o build/device/pnp_device.ramstage.o build/device/root_device.ramstage.o build/device/smbus_ops.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/mtrr/mtrr.ramstage.o src/cpu/x86/mtrr/mtrr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/cpu/x86/mtrr/ramstage.o -r build/cpu/x86/mtrr/mtrr.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/lapic/apic_timer.ramstage.o src/cpu/x86/lapic/apic_timer.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/lapic/boot_cpu.ramstage.o src/cpu/x86/lapic/boot_cpu.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/lapic/lapic.ramstage.o src/cpu/x86/lapic/lapic.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/lapic/lapic_cpu_init.ramstage.o src/cpu/x86/lapic/lapic_cpu_init.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/lapic/secondary.ramstage.o src/cpu/x86/lapic/secondary.S
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/cpu/x86/lapic/ramstage.o -r build/cpu/x86/lapic/apic_timer.ramstage.o build/cpu/x86/lapic/boot_cpu.ramstage.o build/cpu/x86/lapic/lapic.ramstage.o build/cpu/x86/lapic/lapic_cpu_init.ramstage.o build/cpu/x86/lapic/secondary.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/x86/cache/cache.ramstage.o src/cpu/x86/cache/cache.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/cpu/x86/cache/ramstage.o -r build/cpu/x86/cache/cache.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/amd/mtrr/amd_mtrr.ramstage.o src/cpu/amd/mtrr/amd_mtrr.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/cpu/amd/mtrr/ramstage.o -r build/cpu/amd/mtrr/amd_mtrr.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/amd/agesa/family14/chip_name.ramstage.o src/cpu/amd/agesa/family14/chip_name.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/amd/agesa/family14/model_14_init.ramstage.o src/cpu/amd/agesa/family14/model_14_init.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/cpu/amd/agesa/family14/ramstage.o -r build/cpu/amd/agesa/family14/chip_name.ramstage.o build/cpu/amd/agesa/family14/model_14_init.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/cpu/amd/agesa/s3_resume.ramstage.o src/cpu/amd/agesa/s3_resume.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/cpu/amd/agesa/ramstage.o -r build/cpu/amd/agesa/s3_resume.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/console.ramstage.o src/console/console.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/die.ramstage.o src/console/die.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/init.ramstage.o src/console/init.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/post.ramstage.o src/console/post.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/printk.ramstage.o src/console/printk.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/vsprintf.ramstage.o src/console/vsprintf.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/console/vtxprintf.ramstage.o src/console/vtxprintf.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/console/ramstage.o -r build/console/console.ramstage.o build/console/die.ramstage.o build/console/init.ramstage.o build/console/post.ramstage.o build/console/printk.ramstage.o build/console/vsprintf.ramstage.o build/console/vtxprintf.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/c_start.ramstage.o src/arch/x86/lib/c_start.S
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/cpu.ramstage.o src/arch/x86/lib/cpu.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/ebda.ramstage.o src/arch/x86/lib/ebda.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/exception.ramstage.o src/arch/x86/lib/exception.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/ioapic.ramstage.o src/arch/x86/lib/ioapic.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/memcpy.ramstage.o src/arch/x86/lib/memcpy.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/memmove.ramstage.o src/arch/x86/lib/memmove.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/memset.ramstage.o src/arch/x86/lib/memset.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/pci_ops_conf1.ramstage.o src/arch/x86/lib/pci_ops_conf1.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/pci_ops_mmconf.ramstage.o src/arch/x86/lib/pci_ops_mmconf.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/lib/rom_media.ramstage.o src/arch/x86/lib/rom_media.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/arch/x86/lib/ramstage.o -r build/arch/x86/lib/c_start.ramstage.o build/arch/x86/lib/cpu.ramstage.o build/arch/x86/lib/ebda.ramstage.o build/arch/x86/lib/exception.ramstage.o build/arch/x86/lib/ioapic.ramstage.o build/arch/x86/lib/memcpy.ramstage.o build/arch/x86/lib/memmove.ramstage.o build/arch/x86/lib/memset.ramstage.o build/arch/x86/lib/pci_ops_conf1.ramstage.o build/arch/x86/lib/pci_ops_mmconf.ramstage.o build/arch/x86/lib/rom_media.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/acpi.ramstage.o src/arch/x86/boot/acpi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/acpigen.ramstage.o src/arch/x86/boot/acpigen.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/boot.ramstage.o src/arch/x86/boot/boot.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/cbmem.ramstage.o src/arch/x86/boot/cbmem.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/gdt.ramstage.o src/arch/x86/boot/gdt.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/mpspec.ramstage.o src/arch/x86/boot/mpspec.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/pirq_routing.ramstage.o src/arch/x86/boot/pirq_routing.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/smbios.ramstage.o src/arch/x86/boot/smbios.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/tables.ramstage.o src/arch/x86/boot/tables.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800  -MMD -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -c -o build/arch/x86/boot/wakeup.ramstage.o src/arch/x86/boot/wakeup.S
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -o build/arch/x86/boot/ramstage.o -r build/arch/x86/boot/acpi.ramstage.o build/arch/x86/boot/acpigen.ramstage.o build/arch/x86/boot/boot.ramstage.o build/arch/x86/boot/cbmem.ramstage.o build/arch/x86/boot/gdt.ramstage.o build/arch/x86/boot/mpspec.ramstage.o build/arch/x86/boot/pirq_routing.ramstage.o build/arch/x86/boot/smbios.ramstage.o build/arch/x86/boot/tables.ramstage.o build/arch/x86/boot/wakeup.ramstage.o 
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -Isrc -Isrc/include -Ibuild -include src/include/kconfig.h -Isrc/mainboard/pcengines/apu -Isrc/northbridge/amd/common -Os -pipe -g -nostdinc -nostdlib -Wall -Wundef -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wredundant-decls -Wno-trigraphs -Wstrict-aliasing -Wshadow -Werror -fno-common -ffreestanding -fno-builtin -fomit-frame-pointer -Isrc/arch/x86/include  -Isrc/arch/x86/include  -nostdlib -r -o build/generated/ramstage.o -Wl,--wrap,__divdi3 -Wl,--wrap,__udivdi3 -Wl,--wrap,__moddi3 -Wl,--wrap,__umoddi3 -Wl,--start-group build/vendorcode/amd/cimx/sb800/ramstage.o build/superio/nuvoton/nct5104d/ramstage.o build/superio/common/ramstage.o build/superio/acpi/ramstage.o build/southbridge/amd/cimx/sb800/ramstage.o build/southbridge/amd/cimx/ramstage.o build/northbridge/amd/common/ramstage.o build/northbridge/amd/agesa/family14/ramstage.o build/northbridge/amd/agesa/common/ramstage.o build/mainboard/pcengines/apu/ramstage.o build/lib/loaders/ramstage.o build/lib/ramstage.o build/drivers/uart/ramstage.o build/drivers/spi/ramstage.o build/drivers/pc80/ramstage.o build/device/ramstage.o build/cpu/x86/mtrr/ramstage.o build/cpu/x86/lapic/ramstage.o build/cpu/x86/cache/ramstage.o build/cpu/amd/mtrr/ramstage.o build/cpu/amd/agesa/family14/ramstage.o build/cpu/amd/agesa/ramstage.o build/console/ramstage.o build/arch/x86/lib/ramstage.o build/arch/x86/boot/ramstage.o  build/libagesa.fam14.a "$SAGE_HOME"/tools/xgcc/bin/../lib/gcc/i386-elf/4.7.3/libgcc.a -Wl,--end-group
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc  -Wno-unused-but-set-variable  -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Isrc/mainboard/pcengines/apu -Isrc/vendorcode/amd/agesa/f14 -Isrc/vendorcode/amd/agesa/f14/Include -Isrc/vendorcode/amd/agesa/f14/Lib -Isrc/vendorcode/amd/agesa/f14/Legacy -Isrc/vendorcode/amd/agesa/f14/Proc/Common -Isrc/vendorcode/amd/agesa/f14/Proc/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Family/0x14/ON -Isrc/vendorcode/amd/agesa/f14/Proc/CPU/Feature  -Isrc/vendorcode/amd/agesa/f14/Proc/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Common -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Gfx/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Modules/GnbCommonLib -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/Nb/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Family/0x14 -Isrc/vendorcode/amd/agesa/f14/Proc/GNB/PCIe/Feature -Isrc/vendorcode/amd/agesa/f14/Proc/HT -Isrc/vendorcode/amd/agesa/f14/Proc/IDS -Isrc/vendorcode/amd/agesa/f14/Proc/Mem -Isrc/vendorcode/amd/agesa/f14/Proc/Mem/NB/ON -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/GNB -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/CPU -Isrc/vendorcode/amd/agesa/f14/Proc/Recovery/Mem -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing -Isrc/mainboard/pcengines/apu -Isrc/southbridge/amd/cimx/sb800 -Isrc/include/cpu/amd/common -Isrc/vendorcode/amd/cimx/sb800 -nostdlib -nostartfiles -static -o build/cbfs/fallback/ramstage.debug -Lbuild -T src/arch/x86/ramstage.ld build/generated/ramstage.o
cp build/cbfs/fallback/ramstage.debug build/cbfs/fallback/ramstage.elf.tmp
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-nm -n build/cbfs/fallback/ramstage.elf.tmp | sort > build/cbfs/fallback/ramstage.map
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --strip-debug build/cbfs/fallback/ramstage.elf.tmp
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy --add-gnu-debuglink=build/cbfs/fallback/ramstage.debug build/cbfs/fallback/ramstage.elf.tmp
mv build/cbfs/fallback/ramstage.elf.tmp build/cbfs/fallback/ramstage.elf
pushd payloads/memtest86+
echo make -C payloads/memtest86+ com1
rm -f *.o *.s *.d *.iso memtest.bin memtest.elf memtest_shared memtest_shared.bin memtest.iso
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -MMD -E -traditional head.S -o head.s
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  -32   -o head.o head.s
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0 -fno-strict-aliasing -c reloc.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o main.o main.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -c test.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o init.o init.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o lib.o lib.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o patn.o patn.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o screen_buffer.o screen_buffer.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o config.o config.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o cpuid.o cpuid.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o linuxbios.o linuxbios.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o pci.o pci.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o memsize.o memsize.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o spd.o spd.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o error.o error.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o dmi.o dmi.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o controller.o controller.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o smp.o smp.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O0 -fPIC  -fno-stack-protector -DSERIAL_CONSOLE_DEFAULT=1 -DSERIAL_TTY=0   -c -o vmem.o vmem.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -Wall -march=i486 -m32 -fomit-frame-pointer -fno-builtin -MMD -ffreestanding -O3 -c random.c
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  --warn-constructors --warn-common -static -T memtest_shared.lds -o memtest_shared head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o cpuid.o linuxbios.o pci.o memsize.o spd.o error.o dmi.o controller.o smp.o vmem.o random.o && "$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -shared -Bsymbolic -T memtest_shared.lds -o memtest_shared head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o cpuid.o linuxbios.o pci.o memsize.o spd.o error.o dmi.o controller.o smp.o vmem.o random.o
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-objcopy -O binary memtest_shared memtest_shared.bin
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -MMD -E -traditional bootsect.S -o bootsect.s
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  -32   -o bootsect.o bootsect.s
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-gcc -Wa,--divide -fno-stack-protector -Wl,--build-id=none -Wno-unused-but-set-variable  -MMD -E -traditional setup.S -o setup.s
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-as  -32   -o setup.o setup.s
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -T memtest.bin.lds bootsect.o setup.o -b binary memtest_shared.bin -o memtest.bin
"$SAGE_HOME"/tools/xgcc/bin/i386-elf-ld  -s -T memtest.lds -b binary memtest_shared.bin -o memtest.elf
popd # payloads/memtest86+
if [ -e payloads/memtest86+/memtest.elf ]; then build/cbfstool build/coreboot.pre add-payload -f payloads/memtest86+/memtest.elf -n "img/memtest"  -c LZMA ; fi
cp build/coreboot.pre build/coreboot.rom.tmp
if [ -e build/cbfs/fallback/ramstage.elf ]; then build/cbfstool build/coreboot.rom.tmp add-stage -f build/cbfs/fallback/ramstage.elf -n "fallback"/ramstage -c LZMA ; fi
if [ -e payloads/seabios/out/bios.bin.elf ]; then build/cbfstool build/coreboot.rom.tmp add-payload -f "payloads/seabios/out/bios.bin.elf" -n "fallback"/payload -c LZMA  ; fi
if [ -e payloads/sortbootorder/sortbootorder.elf ]; then build/cbfstool build/coreboot.rom.tmp add-payload -f "payloads/sortbootorder/sortbootorder.elf" -n img/"setup"  -c LZMA ; fi
if [ -e src/mainboard/pcengines/apu/bootorder_map ]; then build/cbfstool build/coreboot.rom.tmp add -f src/mainboard/pcengines/apu/bootorder_map -n bootorder_map  -t raw ; fi
if [ -e src/mainboard/pcengines/apu/bootorder_def ]; then build/cbfstool build/coreboot.rom.tmp add -f src/mainboard/pcengines/apu/bootorder_def -n bootorder_def  -t raw ; fi
if [ -e src/mainboard/pcengines/apu/no_debug_with_screen ]; then build/cbfstool build/coreboot.rom.tmp add -f src/mainboard/pcengines/apu/no_debug_with_screen -n etc/screen-and-debug  -t raw ; fi
if [ -e src/mainboard/pcengines/apu/boot-menu-message ]; then build/cbfstool build/coreboot.rom.tmp add -f src/mainboard/pcengines/apu/boot-menu-message -n etc/boot-menu-message  -t raw ; fi
if [ -e src/mainboard/pcengines/apu/boot-menu-key ]; then build/cbfstool build/coreboot.rom.tmp add -f src/mainboard/pcengines/apu/boot-menu-key -n etc/boot-menu-key  -t raw ; fi
if [ -e src/mainboard/pcengines/apu/bootorder ]; then build/cbfstool build/coreboot.rom.tmp add -f src/mainboard/pcengines/apu/bootorder -n bootorder -b 0xFFFF9000 -t raw ; fi
mv build/coreboot.rom.tmp build/coreboot.rom
build/cbfstool build/coreboot.rom print
exit 0
